#ifndef __DISPLACEMENTFIELDS_H
#define __DISPLACEMENTFIELDS_H

// -- STL includes --
#include <vector>

using std::vector;

// -- project includes --
#include "StdScalarField.h"
//#include "StdVectorField.h"

/*!
  \class TDisplacementXField
  \brief x component of the displacement field

  \author  Steffen Abe
  $Revision$
  $Date$
*/
template <class T>
class TDisplacementXField : public TStdScalarField<T>
{
 public:
  TDisplacementXField(ParallelParticleArray<T>*);
  virtual double operator()(int,int component=0)const;
};

template <class T>
class TDisplacementYField : public TStdScalarField<T>
{
 public:
  TDisplacementYField(ParallelParticleArray<T>*);
  virtual double operator()(int,int component=0)const;
};

/*!
  \class TDisplacementField
  \brief the displacement field

  \author  Steffen Abe
  $Revision$
  $Date$
*/
/* template <class T> */
/* class TDisplacementField : public TStdVectorField<T> */
/* { */
/*  public: */
/*   TDisplacementField(vector<T*> *); */
/*   virtual double operator()(int,int)const; */
/* }; */
 
#include "DisplacementField.hpp"

#endif // __DISPLACEMENTFIELDS_H
