template <class T>
TDisplacementXField<T>::TDisplacementXField(ParallelParticleArray<T>* ppa)
  :TStdScalarField<T>(ppa,&T::getTotalDisplacement)
{
}

template <class T>
double TDisplacementXField<T>::operator()(int idx,int component)const
{ 
  double res;
  if(idx<m_field_values.size()){
    res=m_field_values[i].second.X();
  } else {
    res=0.0;
  }
  return res;
}

template <class T>
TDisplacementYField<T>::TDisplacementYField(ParallelParticleArray<T>* ppa)
  :TStdScalarField<T>(ppa,T::getTotalDisplacement)
{
}

template <class T>
double TDisplacementYField<T>::operator()(int idx,int component)const
{ 
  double res;
  if(idx<m_field_values.size()){
    res=m_field_values[i].second.Y();
  } else {
    res=0.0;
  }
  return res;
}

// template <class T>
// TDisplacementField<T>::TDisplacementField(ParallelParticleArray<T>* ppa)
//   :TStdVectorField<T>(ppa,T::getTotalDisplacement)
// {
// }

// template <class T>
// double TDisplacementField<T>::operator()(int idx,int component)const
// { 
//   double res;

//   if(idx<m_field_values.size()){
//     Vec3 disp=m_field_values[i].second;  
//     switch(component){
//     case(0): res=disp.X(); break;
//     case(1): res=disp.Y(); break;
//     case(2): res=disp.Z(); break;
//     default: res=0.0;
//     }
//   } else {
//     res=0.0;
//   }
//   return res;
// }
