#ifndef __FIELDMASTER_H
#define __FIELDMASTER_H

//--- STL includes ---
#include <string>
using std::string;

class TML_Comm;

/*!
  \class AFieldMaster
  \brief Abstract base class for master part of field

*/
class AFieldMaster
{
 private:
  static int s_field_count;
  
 protected:
  TML_Comm *m_comm;
  string m_field_name;
  string m_file_name;
  int m_t0,m_tend,m_dt;
  int m_id;
  int m_save_count;
  int m_write_type; // 0:DX, 1:POV. 2:SUM, 3:MAX, 4:RAW_SERIES

  string makeFilename();
  virtual void writeAsDX()=0;
  virtual void writeAsSUM()=0;
  virtual void writeAsMAX()=0;
  virtual void writeAsRAW_SERIES()=0;
  virtual void writeAsRAW2(){};

 public:
  AFieldMaster(TML_Comm*,const string&,const string&,const string&,int,int,int);
  virtual ~AFieldMaster(){};

  virtual bool needSave(int);
  virtual void collect()=0;
  virtual void write();
};

#endif //__FIELDMASTER_H
