#ifndef __FIELDSHAPE_H
#define __FIELDSHAPE_H

// -- system includes --
#include <string>

using std::string;

/*!
  \class AFieldShape
  \brief abstract base class for field shapes

   \author  Steffen Abe
  $revision: $
  $Date$
*/

class AFieldShape
{
private:
  string m_name; //!< the name of the shape

protected:
  AFieldShape(const string& s){m_name=s;};

public:
  string getName()const{return m_name;}; //!< return the shape name
  virtual int getNumParams()const=0;
  virtual string getParamName(int)const=0;
  virtual string getParamType(int)const=0;
};

#endif  //__FIELDSHAPE_H
