#ifndef __FREESCALARFIELD_H
#define __FREESCALARFIELD_H

// -- project includes --
#include "Field.h"

/*!
  \class AFreeScalarField
  \brief Abstract base class for "free" scalar fields, i.e. scalar given at arbitrary positions

  \author  Steffen Abe
  $Revision$
  $Date$
*/

class AFreeScalarField : public AField
{
 public:
  AFreeScalarField(){AddShape("free");};
  virtual ~AFreeScalarField(){};
  virtual bool isScalar()const{return true;};
  virtual bool isScalar()const{return false;};
  virtual int getSize()const=0;
  virtual int idx(int)const=0;
};

#endif //__FREESCALARFIELD_H
