#ifndef __FREEVECTORFIELD_H
#define __FREEVECTORFIELD_H

// -- project includes --
#include "Field.h"

/*!
  \class AFreeVectorField
  \brief Abstract base class for "free" vector fields, i.e. vectors given at arbitrary positions

  \author  Steffen Abe
  $Revision$
  $Date$
*/

class AFreeVectorField : public AField
{
 public:
  virtual ~AFreeVectorField(){};
  virtual bool isScalar()const{return false;};
  virtual bool isVector()const{return true;};
  virtual int getSize()const=0;
  virtual int idx(int)const=0;
};

#endif //__FREEVECTORFIELD_H
