#ifndef __INTERACTIONFIELDMASTER_H
#define __INTERACTIONFIELDMASTER_H

//--- project includes ---
#include "FieldMaster.h"
#include "vec3.h"

//--- STL includes ---
#include <vector>

using std::vector;

//class TML_Comm;

/*!
  \class ScalarInteractionFieldMaster
  \brief Class for master part of a scalar field which is defined on all particles

  \author Steffen Abe
  $Revision$
  $Date$
*/
class ScalarInteractionFieldMaster : public AFieldMaster
{
 protected:
  vector<pair<Vec3,double> >  m_data; // vector of <position,value> pairs
  vector<double> m_sum_vec;

  virtual void writeAsDX();
  virtual void writeAsSUM();
  virtual void writeAsMAX();
  virtual void writeAsRAW_SERIES();
  
  void collectFull();
  void collectSum();
  void collectMax();

 public:
  ScalarInteractionFieldMaster(TML_Comm*,const string&,const string&,const string&,const string&,const string&,int,int,int,bool);
  ScalarInteractionFieldMaster(TML_Comm*,const string&,const string&,const string&,const string&,const string&,int,int,int,int,int,bool);
  virtual ~ScalarInteractionFieldMaster(){};

  void collect();
 };

#endif //__INTERACTIONFIELDMASTER_H
