#include "field_const.h"


template <typename T>
InteractionFieldSlave<T>::InteractionFieldSlave(TML_Comm* comm,TParallelInteractionStorage<T>* pis):AFieldSlave(comm)
{
  m_pis=pis;
}


/*!
  Send data back to master. Determine the type of data (full/sum) to send back from
  the received coll_type and call the sendDataFull or sendDataSum.
*/
template <typename T>
void InteractionFieldSlave<T>::sendData()
{
  int coll_type;
  m_comm->recv_broadcast(coll_type,0);

  switch(coll_type){
  case COLL_TYPE_FULL : SendDataFull();break;
  case COLL_TYPE_SUM : SendDataSum();break;
  case COLL_TYPE_MAX : SendDataMax();break;
  case COLL_TYPE_FULL2 : SendDataFull2();break;	

  default: std::cerr << "unknown collection type" << std::endl;
  }
}
