#ifndef __SCALAR_INTERACTION_FIELD_SLAVE_H
#define __SCALAR_INTERACTION_FIELD_SLAVE_H

// -- project includes --
#include "InteractionFieldSlave.h"

template <typename I> class TParallelInteractionStorage;
class TML_Comm;

/*!
  \class ScalarInteractionFieldSlave
  \brief class for slave part of scalar field defined on the interactions

  \author Steffen Abe
  $Revision$
  $Date$
*/
template <typename T>
class ScalarInteractionFieldSlave : public InteractionFieldSlave<T>
{
 private:
  virtual void SendDataFull();
  virtual void SendDataFull2(){};
  virtual void SendDataSum();
  virtual void SendDataMax();

 protected:
  typename T::ScalarFieldFunction m_rdf;

 public:
  ScalarInteractionFieldSlave(TML_Comm*,TParallelInteractionStorage<T>*,typename T::ScalarFieldFunction);
};

#include "ScalarInteractionFieldSlave.hpp"

#endif //__SCALAR_INTERACTION_FIELD_SLAVE_H
