template <class  T>
TStdComponentField<T>::TStdComponentField(ParallelParticleArray<T>* ppa,Vec3 (T::*af)()const,int c)
{
  m_accessFn=af;
  m_ppa_ptr=ppa;
  if((0<=c)&&(c<3)){
    m_component=c;
  } else {
    c=0;
    console.Error()<<"StdComponentField: invalid component!\n";
  }
  AddShape("rawp");
}

template <class  T>
void TStdComponentField<T>::updateFieldValues()
{
  m_field_values=m_ppa_ptr->forAllParticlesGetIndexed(m_accessFn);
}

template <class  T>
int TStdComponentField<T>::getSize()const
{
  return m_field_values.size();
}

template <class  T>
int TStdComponentField<T>::idx(int i)const
{
  int res;

  if(i<m_field_values.size()){
    res=m_field_values[i].first;
  } else {
    res=0;
  }

  return res;
}

template <class  T>
double TStdComponentField<T>::operator()(int idx,int)const
{
  double res;
  if(idx<m_field_values.size()){
    switch(m_component){
    case 0:
      res=m_field_values[idx].second.X(); break;
    case 1:
      res=m_field_values[idx].second.Y(); break;
    case 2:
      res=m_field_values[idx].second.Z(); break;
    }
  } else {
    res=0.0;
  }
  return res;
}
