template <class  T>
TStdScalarField<T>::TStdScalarField(ParallelParticleArray<T>* ppa,double (T::*af)()const)
{
  m_accessFn=af;
  m_ppa_ptr=ppa;
  AddShape("rawp");
}

template <class  T>
void TStdScalarField<T>::updateFieldValues()
{
  m_field_values=m_ppa_ptr->forAllParticlesGetIndexed(m_accessFn);
}

template <class  T>
int TStdScalarField<T>::getSize()const
{
  return m_field_values.size();
}

template <class  T>
int TStdScalarField<T>::idx(int i)const
{
  int res;

  if(i<m_field_values.size()){
    res=m_field_values[i].first;
  } else {
    res=0;
  }

  return res;
}

template <class  T>
double TStdScalarField<T>::operator()(int idx,int component)const
{
  double res;
  if(idx<m_field_values.size()){
    res=m_field_values[idx].second;
  } else {
    res=0.0;
  }
  return res;
}
