#ifndef __STDVECTORFIELD_H
#define __STDVECTORFIELD_H

// -- project includes --
#include "Field.h"
#include "vec3.h"
#include "pp_array.h"

/*!
  \class TStdVectorField
  \brief Abstract base class for "standard" vector fields, i.e. one vector value per particle

  \author  Steffen Abe
  $Revision$
  $Date$
*/

template <class T>
class TStdVectorField : public AField
{
 protected:
  ParallelParticleArray<T> *m_ppa_ptr; //!< pointer to the parallel particle array
  Vec3 (T::*m_accessFn)()const; //!< particle field value access function
  vector<pair<int,Vec3> > m_field_values;

 public:
  TStdVectorField(ParallelParticleArray<T>*,double (T::*)()const);
  virtual bool isScalar()const{return false;};
  virtual bool isVector()const{return true;};
  virtual int getSize()const;
  virtual int idx(int)const;
  virtual Vec3 pos(int) const;
};

#include "StdVectorField.hpp"

#endif //__STDVECTORFIELD_H
