#ifndef __VECTORINTERACTIONFIELDMASTER_H
#define __VECTORINTERACTIONFIELDMASTER_H

//--- project includes ---
#include "FieldMaster.h"
#include "vec3.h"

//--- STL includes ---
#include <map>
#include <vector>

using std::map;
using std::vector;

/*!
  \class VectorInteractionFieldMaster
  \brief Class for master part of a vector field which is defined on all particles

  \author Steffen Abe
  $Revision$
  $Date$
*/
class VectorInteractionFieldMaster : public AFieldMaster
{
 public:
  typedef pair<pair<Vec3,Vec3>,Vec3> IVecData2;

 protected:
  vector<IVecData2> m_data2; // vector of <pos1,pos2,value> groups
  vector<pair<Vec3,Vec3> >  m_data; // vector of <position,value> pairs
  vector<Vec3> m_sum_vec;

  virtual void writeAsDX();
  virtual void writeAsSUM();
  virtual void writeAsMAX(){};
  virtual void writeAsRAW_SERIES(){};
  virtual void writeAsRAW2();

  void collectFull();
  void collectSum();
  void collectMax();
  void collectFull2();

 public:
  VectorInteractionFieldMaster(TML_Comm*,const string&,const string&,const string&,const string&,const string&,int,int,int,bool);
  virtual ~VectorInteractionFieldMaster(){}; 

  virtual void collect();
};

#endif // __VECTORINTERACTIONFIELDMASTER_H
