#ifndef __VECTOR_INTERACTION_FIELD_SLAVE_H
#define __VECTOR_INTERACTION_FIELD_SLAVE_H

// -- project includes --
#include "InteractionFieldSlave.h"

template <typename I> class TParallelInteractionStorage;
class TML_Comm;

/*!
  \class VectorInteractionFieldSlave
  \brief class for slave part of vector field defined on the interactions

  \author Steffen Abe
  $Revision$
  $Date$
*/
template <typename T>
class VectorInteractionFieldSlave : public InteractionFieldSlave<T>
{
 private:
  virtual void SendDataFull();
  virtual void SendDataFull2();
  virtual void SendDataSum();
  virtual void SendDataMax();

 protected:
  typename T::VectorFieldFunction m_rdf;

 public:
  VectorInteractionFieldSlave(TML_Comm*,TParallelInteractionStorage<T>*,typename T::VectorFieldFunction);
};

#include "VectorInteractionFieldSlave.hpp"

#endif // __VECTOR_INTERACTION_FIELD_SLAVE_H
