#ifndef __VECTOR_TRIANGLE_FIELD_SLAVE_H
#define __VECTOR_TRIANGLE_FIELD_SLAVE_H

// -- project includes --
#include "Fields/FieldSlave.h"
#include "Model/TriMesh.h"
#include "tml/comm/comm.h"

// == STL includes --
#include <map>
using std::map;
using std::multimap;

/*!
  \class VectorTriangleFieldSlave
  \brief Slave part for saving a vector field defined on the triangles
  in a given TriMesh

  \author Steffen Abe
  $Date$
  $Revision$
*/
class VectorTriangleFieldSlave : public AFieldSlave
{
 private:
  map<int,Vec3>  m_data;
 protected: 
  TriMesh *m_mesh;
  Triangle::VectorFieldFunction m_rdf;
  virtual void SendDataFull();
  virtual void SendDataFullDX();

 public:
  VectorTriangleFieldSlave(TML_Comm*,TriMesh*,Triangle::VectorFieldFunction);
  virtual void sendData();
};

#endif // __VECTOR_TRIANGLE_FIELD_SLAVE_H
