#ifndef __WALLFORCEFIELD_H
#define __WALLFORCEFIELD_H

// -- project includes --
#include "FreeVectorField.h"
#include "Wall.h"
#include "vec3.h"

//--- STL includes ---
#include <vector>

using std::vector;


/*!
  \class CWallForceField
  \brief class for vector fields representing forces on walls

  \author  Steffen Abe
  $Revision$
  $Date$
*/

class CWallForceField : public AFreeVectorField
{
protected:
  vector<CWall*> m_walls;

public:
  CWallForceField();
  virtual ~CWallForceField();

  void addWall(CWall*);
  virtual int getSize()const;
  virtual int idx(int)const;
  virtual Vec3 pos(int) const;
  virtual double operator()(int,int)const;
  virtual void updateFieldValues(){};
};

#endif //__WALLFORCEFIELD_H
