#ifndef __WALLPOSFIELD_H
#define __WALLPOSFIELD_H

// --- project includes ---
#include "FreeVectorField.h"
#include "Wall.h"
#include "vec3.h"

// --- STL includes ---
#include <vector>

using std::vector;

/*!
  \class CWallPosField
  \brief class for vector fields representing positions of walls

  \author  Steffen Abe
  $Revision$
  $Date$
*/

class CWallPosField : public AFreeVectorField
{
protected:
  vector<CWall*> m_walls;

public:
  CWallPosField();
  virtual ~CWallPosField();

  void addWall(CWall*);
  virtual int getSize()const;
  virtual int idx(int)const;
  virtual Vec3 pos(int) const;
  virtual double operator()(int,int)const;
  virtual void updateFieldValues(){};
};


#endif //__WALLPOSFIELD_H
