/*=============================================================================
??
??******************************************************************************
??*                                               *
??* COPYRIGHT ??????? - All Rights Reserved *
??*  *
??* This software is the property of ??????????????. No part of this code   *
??* may be copied in any form or by any means without the expressed written   *
??* consent of ???????????. Copying, use or modification of this software     *
??* by any unauthorised person is illegal unless that    *
??* person has a software license agreement with ?????????????.            *
??*                                                          *
??******************************************************************************
??
*********************************************************************************/

#ifndef ESYS_LSMBOUNDINGBOX_H
#define ESYS_LSMBOUNDINGBOX_H

#include "Foundation/vec3.h"

namespace esys
{
  namespace lsm
  {
    /**
     *
     */
    class BoundingBox
    {
    public:
      BoundingBox();
      
      BoundingBox(const Vec3 &minBBoxPt, const Vec3 &maxBBoxPt);

      virtual ~BoundingBox();

      double getVolume() const;

      const Vec3 &getMinPt() const;

      const Vec3 &getMaxPt() const;
      
      bool operator==(const BoundingBox &bbox) const;
      
      Vec3 getSizes() const;
      
      bool contains(const Vec3 &pt, double tolerence = 0.0) const;

    private:
      Vec3 m_minPt;
      Vec3 m_maxPt;
    };
    std::ostream &operator<<(std::ostream &oStream, const BoundingBox &bbox)    ;
  };
};

#endif
