#include "stdafx.h"
#include "Foundation/console.h"
#include "Foundation/shake_debug.h"
#include "ShakeInclude.h"
#include <string.h>

CSshakeInclude shakeInclude;

CSshakeInclude::CSshakeInclude() {
  LastFilename = new char[256] ;
  DB_NEWALLOC(LastFilename,"char") ;
}

CSshakeInclude::~CSshakeInclude() {
  includeDirList.First() ;
  while (!includeDirList.IsEnd()) {
    DB_DELETE(includeDirList.Get(),"?") ;
    delete includeDirList.Get() ;
    includeDirList.Clear() ;
  }
  DB_DELETE(LastFilename,"?") ;
  delete [] LastFilename ;
}

char *CSshakeInclude::getPath(const char *filename)  {
	FILE *file ;
	char *buffer = LastFilename ;
	
	file = fopen(filename,"r") ;
	if (!file) {
		includeDirList.First() ;
		while (!includeDirList.IsEnd()) {
			strcpy(buffer,includeDirList.Get()) ;
			strcat(buffer,filename) ;
			file = fopen(buffer,"r") ;
			if (file) {
				fclose(file) ;
				return buffer ;
			}
			includeDirList.Next() ;
		}    
		return NULL ;
	} else {
		fclose(file) ;
		strcpy(buffer,filename) ;
		return buffer ;
	}
}

FILE* CSshakeInclude::open(char *filename) {
  FILE *file ;
  char *buffer = LastFilename ;

  file = fopen(filename,"r") ;
  if (!file) {
     includeDirList.First() ;
     while (!includeDirList.IsEnd()) {
        strcpy(buffer,includeDirList.Get()) ;
	strcat(buffer,filename) ;
	file = fopen(buffer,"r") ;
	if (file) {
	  console.Debug() << "including " << buffer << "\n" ;
	  return file ;
	}
        includeDirList.Next() ;
    }    
    console.Debug() << "Can't include " << filename << "\n" ;
    return NULL ;
  } else {
    strcpy(buffer,filename) ;
    console.Debug() << "including ./" << filename << "\n" ;
    return file ;
  }
}
 
void CSshakeInclude::addDir(char *dir) {
  char *newdir ;

  newdir = new char[strlen(dir)+1] ;
  DB_NEWALLOC(newdir,"char") ;
  strcpy(newdir,dir) ;
  newdir[strlen(dir)] = '\0' ;
  includeDirList.Append(newdir) ;
} 

void CSshakeInclude::addDirs(const char *dirs) {
  char *newdir ;

  int l=0 ; 
  while (dirs[l])
  {
      while ((dirs[l]) && (dirs[l]==';')) {
	  l++ ; 
      }     
      int i=0 ; 
      while ((dirs[l]) && (dirs[l]!=';')) {
	  l++ ; i++ ;
      }
      newdir = new char[i+1] ;
	  DB_NEWALLOC(newdir,"char") ;
      strncpy(newdir,&(dirs[l-i]),i) ;
      newdir[i] = '\0' ;
      includeDirList.Append(newdir) ;
  }
} 

int CSshakeInclude::getNbDir() {
	int n=0;
    
	includeDirList.First() ;
    while (!includeDirList.IsEnd()) {
		n++ ;
		includeDirList.Next() ;
	}
	return n ;
}

char *CSshakeInclude::getDir(int n) {
	int i=0;
    
	includeDirList.First() ;
    while (!includeDirList.IsEnd()) {
		if (i==n) {
			return includeDirList.Get() ;
		}
		i++ ;
		includeDirList.Next() ;
	}
	return NULL ;
}

char *CSshakeInclude::getDirs() {
	int size=0 ;
    
	includeDirList.First() ;
    while (!includeDirList.IsEnd()) {
		size+=strlen(includeDirList.Get()+5) ;
		includeDirList.Next() ;
	}
	char *alldirs = new char[size] ;
	  DB_NEWALLOC(alldirs,"char") ;

	alldirs[0] = '\0' ;
	includeDirList.First() ;
    while (!includeDirList.IsEnd()) {
		strcat(alldirs,includeDirList.Get()) ;
		includeDirList.Next() ;
		if (!includeDirList.IsEnd()) strcat(alldirs,";") ;
	}
	return alldirs ;
}

int CSshakeInclude::delDir(char *d) {
	includeDirList.First() ;
    while (!includeDirList.IsEnd()) {
		if (!strcmp(includeDirList.Get(),d)) {
			DB_DELETE(includeDirList.Get(),"?") ;
			delete includeDirList.Get() ;
			includeDirList.Clear() ;
			return 1 ;
		}
		includeDirList.Next() ;
	}
	return 0 ;
}

int CSshakeInclude::delDir(int n) {
	int i=0;
    
	includeDirList.First() ;
    while (!includeDirList.IsEnd()) {
		if (i==n) {
			DB_DELETE(includeDirList.Get(),"?") ;
			delete includeDirList.Get() ;
			includeDirList.Clear() ;
			return 1 ;
		}
		i++ ;
		includeDirList.Next() ;
	}
	return 0 ;
}

int CSshakeInclude::delDirs() {
	includeDirList.First() ;
    while (!includeDirList.IsEnd()) {
		DB_DELETE(includeDirList.Get(),"?") ;
		delete includeDirList.Get() ;
		includeDirList.Clear() ;
	}
	return 1 ;
}
