#ifndef _SHAKE_INCLUDE_H_
#define _SHAKE_INCLUDE_H_
#include "t_list.h"
#include <stdio.h>
#include <stdlib.h>

/*!
  \class CSshakeInclude
  \brief Include directory class

  The class CSshakeInclude is used to define include directory where
  the parser will look for when files are included in a script

  \author David Place
  $Revision$
  $Date$
*/
class CSshakeInclude {
 protected:
  List<char> includeDirList ; //!< List of Directory
  char *LastFilename ;        //!< Last file name which has been looked for
 public:
  CSshakeInclude() ;
  ~CSshakeInclude() ;

  FILE* open(char *filename) ;  //!< Open a file for reading, will look in all directory
  void addDir(char *dir) ;
  void addDirs(const char *dirs) ;
  char *getFilename() { return LastFilename; } ;
  char *getPath(const char *filename)  ;

  int getNbDir() ;
  char *getDir(int n) ;
  char *getDirs() ;
  int delDir(char *d) ;
  int delDir(int n) ;
  int delDirs() ;
} ;

extern CSshakeInclude shakeInclude ;

#endif
