#ifndef _SHAKE_STDEFS_H_
#define _SHAKE_STDEFS_H_
#include <stdlib.h>
//Define the precision of the calculation

typedef double real ;
typedef int integer ;

#ifndef _SGI
#ifndef M_PI
#define M_PI 3.141592657
#endif
#endif

#ifndef INFINITY
#define INFINITY 1e20
#endif

#define NEARZERO 1e-8
#define ALMOSTZERO 1e-20

#ifdef _SGI64
#define bool int 
#define true (!0)
#define false (0)
#endif

#ifndef _WINDOWS
#ifndef __G_LIB_H__
#define MAX(e1,e2) ((e1)>(e2) ? (e1):(e2))
#define MIN(e1,e2) ((e1)>(e2) ? (e2):(e1))
#endif
#endif
#define SIGN(e1,e2) ((e2>0) ? (e1):(-(e1)))

#ifdef _WINDOWS
#define shake_random() rand()
#define shake_srandom(seed) srand(seed)
#define shake_RAND_MAX RAND_MAX
#else
#ifdef _LINUX
#define shake_random() rand()
#define shake_srandom(seed) srand(seed)
#define shake_RAND_MAX RAND_MAX
#else
#define shake_random() drand48()
#define shake_srandom(seed) srand48(seed)
#define shake_RAND_MAX 1.0
#endif
#endif
#endif
