#include "stdafx.h"
#include "console.h"
#include "shake_xdr.h"
#include <string.h>
#include <stdlib.h>
  

int Cxdr::PAGESIZE = 1024 ;

Cxdr::Cxdr(int n) 
{
  if (n>0) {
    m_len = n ;
    m_truelen = n ;
    m_buffer = new char[n] ;
    m_cur = 0 ;
  } else {
    m_len = 0 ;
    m_truelen = 0 ;
    m_buffer = NULL ;
    m_cur = 0 ;
  }
  // get byte order
  unsigned long hostlong=1;
  unsigned long netlong=htonl(hostlong);
  if(hostlong==netlong){
    m_is_reverse=false;
  }else{
    m_is_reverse=true;
  }
  m_growable = true ;
}

Cxdr::Cxdr(char *buf,int n) {
  m_len = n ;
  m_truelen = n ;
  m_buffer = buf ;
  m_cur = 0 ;
  // get byte order
  unsigned long hostlong=1;
  unsigned long netlong=htonl(hostlong);
  if(hostlong==netlong){
    m_is_reverse=false;
  }else{
    m_is_reverse=true;
  }
  m_growable = false ;
}

Cxdr::Cxdr(char *buf) {
  m_len = strlen(buf) ;
  m_truelen = strlen(buf) ;
  m_buffer = buf ;
  m_cur = 0 ;
  // get byte order
  unsigned long hostlong=1;
  unsigned long netlong=htonl(hostlong);
  if(hostlong==netlong){
    m_is_reverse=false;
  }else{
    m_is_reverse=true;
  }
  m_growable = false ;
}

Cxdr::~Cxdr() {
  if (m_buffer && m_growable) {
    delete m_buffer ;
  }
}

void Cxdr::reset(int n) {
  m_cur = 0 ;
  if (n!=0) {
    reserve(n) ;
  }
}

