#ifndef _TCPSOCKET_H
#define _TCPSOCKET_H
#include "shake_xdr.h"

#ifdef _WINDOWS
//#include <winsock2.h>
#else
#include <arpa/inet.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#endif

#define TCP 'T'
#define UDP 'U'

/*!
  \class CSocket
  \brief Socket for TCP/IP connection
  \author David Place
*/
class CSocket {
private:
  int m_sockfd; //!< socket file descriptor
  sockaddr_in m_INetAddress, m_RemoteAddress; //!< address at both side of the connection
  bool m_isNonBlocking ; //!< true is communication are non blocking
  static long MAX_TCP_LENGTH ; 
  bool print_err() ;
public:
  CSocket();
  ~CSocket();
    
  bool create();
  bool create(char nType);
  bool bind(int nPort);
    
  bool listen();           //!< start listening to connection
  bool accept(CSocket &s); //!< accept incoming transmission (server side)
    
    
  bool connect(int nPort, char *Hostname);
    
  long send(Cxdr &cxdr) ;
  long recv(Cxdr &cxdr) ;
  long send(const void *Message, int nLength=0);
  long recv(void *Buffer, int nLength);
  void nonBlocking(bool flag) ;
  bool wouldBlock() ;
  bool isNonBlocking() ;
  
  bool close();
  bool shutdown() ;
};


#endif
