/*=============================================================================
??
??******************************************************************************
??*                                               *
??* COPYRIGHT ??????? - All Rights Reserved *
??*  *
??* This software is the property of ??????????????. No part of this code   *
??* may be copied in any form or by any means without the expressed written   *
??* consent of ???????????. Copying, use or modification of this software     *
??* by any unauthorised person is illegal unless that    *
??* person has a software license agreement with ?????????????.            *
??*                                                          *
??******************************************************************************
??
*********************************************************************************/

#ifndef LSMTESTVEC3TEST_H
#define LSMTESTVEC3TEST_H

#include <cppunit/extensions/HelperMacros.h>
#include <cppunit/TestCase.h>

#include <boost/shared_ptr.hpp>

namespace LsmTest
{
  /*!
     $Revision$
     $Date$
  */
  class Vec3Test : public CppUnit::TestCase
  {
  public:
    Vec3Test();
    virtual ~Vec3Test();

    virtual void setUp();
    virtual void tearDown();

    CPPUNIT_TEST_SUITE( Vec3Test );
      CPPUNIT_TEST( testIndex );
      CPPUNIT_TEST( testPerformanceArrayVsMembers );
      CPPUNIT_TEST( testPerformanceCopyVsAssignConstruct );
    CPPUNIT_TEST_SUITE_END();

    // the test methods
    void testIndex();
    void testPerformanceArrayVsMembers();
    void testPerformanceCopyVsAssignConstruct();
  private:
    class Impl;
    typedef boost::shared_ptr<Impl> ImplPtr;
    ImplPtr m_impl;
  };
};

#endif // LSMTESTVEC3TEST_H
