/*=============================================================================
??
??******************************************************************************
??*                                               *
??* COPYRIGHT ??????? - All Rights Reserved *
??*  *
??* This software is the property of ??????????????. No part of this code   *
??* may be copied in any form or by any means without the expressed written   *
??* consent of ???????????. Copying, use or modification of this software     *
??* by any unauthorised person is illegal unless that    *
??* person has a software license agreement with ?????????????.            *
??*                                                          *
??******************************************************************************
??
*********************************************************************************/

#include "Geometry/ParticleGenerator.h"
#include "Geometry/CircularNeighbourTable.h"

namespace esys
{
  namespace lsm
  {
    ParticleGenerator::ParticleGenerator()
      : m_pNTable(NULL),
        m_pParticlePool(NULL)
    {
    }

    ParticleGenerator::ParticleGenerator(
      NTable       &nTable,
      ParticlePool &particlePool
    )
      : m_pNTable(&nTable),
        m_pParticlePool(&particlePool)
    {
    }

    ParticleGenerator::~ParticleGenerator()
    {
    }
    
    ParticleGenerator::NTable &ParticleGenerator::getNTable()
    {
      return *(m_pNTable);
    }

    const ParticleGenerator::NTable &ParticleGenerator::getNTable() const
    {
      return *(m_pNTable);
    }

    ParticleGenerator::ParticlePool &ParticleGenerator::getParticlePool()
    {
      return *m_pParticlePool;
    }
    
    const ParticleGenerator::ParticlePool &ParticleGenerator::getParticlePool() const
    {
      return *m_pParticlePool;
    }
  };
};
