/*=============================================================================
??
??******************************************************************************
??*                                               *
??* COPYRIGHT ??????? - All Rights Reserved *
??*  *
??* This software is the property of ??????????????. No part of this code   *
??* may be copied in any form or by any means without the expressed written   *
??* consent of ???????????. Copying, use or modification of this software     *
??* by any unauthorised person is illegal unless that    *
??* person has a software license agreement with ?????????????.            *
??*                                                          *
??******************************************************************************
??
*********************************************************************************/

#ifndef ESYS_LSMPARTICLEGENERATOR_H
#define ESYS_LSMPARTICLEGENERATOR_H

#include "Geometry/SimpleParticle.h"
#include "Geometry/CircularNeighbourTable.h"

#include <boost/pool/object_pool.hpp>

namespace esys
{
  namespace lsm
  {
    /**
     *
     */
    class ParticleGenerator
    {
    public:
      typedef CircularNeighbourTable<SimpleParticle> NTable;
      typedef boost::object_pool<SimpleParticle>     ParticlePool;
      
      ParticleGenerator(NTable &nTable, ParticlePool &particlePool);

      virtual ~ParticleGenerator();

      virtual void generate() = 0;
      
    protected:
      ParticleGenerator();
      
      NTable &getNTable();
      const NTable &getNTable() const;
      
      ParticlePool &getParticlePool();
      const ParticlePool &getParticlePool() const;
    private:
      NTable       *m_pNTable;
      ParticlePool *m_pParticlePool;
    };
  };
};

#endif
