/*=============================================================================
??
??******************************************************************************
??*                                               *
??* COPYRIGHT ??????? - All Rights Reserved *
??*  *
??* This software is the property of ??????????????. No part of this code   *
??* may be copied in any form or by any means without the expressed written   *
??* consent of ???????????. Copying, use or modification of this software     *
??* by any unauthorised person is illegal unless that    *
??* person has a software license agreement with ?????????????.            *
??*                                                          *
??******************************************************************************
??
*********************************************************************************/

#include "Geometry/RegularBlockGenerator.h"
#include "Geometry/GridIterator.h"
#include "Geometry/SimpleParticle.h"

namespace esys
{
  namespace lsm
  {
    RegularBlockGenerator::RegularBlockGenerator(
      NTable            &nTable,
      ParticlePool      &particlePool,
      const BoundingBox &bBox,
      const BoolVector  &periodicDimensions,
      double            tolerence,
      double            sphereRadius
    ) : BlockGenerator(nTable, particlePool, bBox, periodicDimensions, tolerence),
        m_radius(sphereRadius)
    {
    }

    RegularBlockGenerator::~RegularBlockGenerator()
    {
    }
    
    double RegularBlockGenerator::getRadius() const
    {
      return m_radius;
    }

    double RegularBlockGenerator::getGridRadius() const
    {
      return m_radius;
    }

    void RegularBlockGenerator::generate()
    {
      generateSeedParticles();
    }
  };
};
