/*=============================================================================
??
??******************************************************************************
??*                                               *
??* COPYRIGHT ??????? - All Rights Reserved *
??*  *
??* This software is the property of ??????????????. No part of this code   *
??* may be copied in any form or by any means without the expressed written   *
??* consent of ???????????. Copying, use or modification of this software     *
??* by any unauthorised person is illegal unless that    *
??* person has a software license agreement with ?????????????.            *
??*                                                          *
??******************************************************************************
??
*********************************************************************************/

#ifndef ESYS_LSMREGULARBLOCKGENERATOR_H
#define ESYS_LSMREGULARBLOCKGENERATOR_H

#include <Geometry/BlockGenerator.h>

namespace esys
{
  namespace lsm
  {
    typedef std::vector<bool> BoolVector;
    /**
     *
     */
    class RegularBlockGenerator : public BlockGenerator
    {
    public:
      RegularBlockGenerator(
        NTable            &nTable,
        ParticlePool      &particlePool,
        const BoundingBox &bBox,
        const BoolVector  &periodicDimensions,
        double            tolerence,
        double            sphereRadius
      );

      virtual ~RegularBlockGenerator();

      virtual double getRadius() const;
      
      virtual double getGridRadius() const;

      virtual void generate();

    private:
      double      m_radius;
    };
  };
};

#endif
