/*=============================================================================
??
??******************************************************************************
??*                                               *
??* COPYRIGHT ??????? - All Rights Reserved *
??*  *
??* This software is the property of ??????????????. No part of this code   *
??* may be copied in any form or by any means without the expressed written   *
??* consent of ???????????. Copying, use or modification of this software     *
??* by any unauthorised person is illegal unless that    *
??* person has a software license agreement with ?????????????.            *
??*                                                          *
??******************************************************************************
??
*********************************************************************************/

#ifndef LSMTESTCIRCULARNEIGHBOURTABLETEST_H
#define LSMTESTCIRCULARNEIGHBOURTABLETEST_H

#include <cppunit/extensions/HelperMacros.h>
#include <cppunit/TestCase.h>
#include <stdexcept>

namespace LsmTest
{
  /**
  @author Shane J Latham
  */
  class CircularNeighbourTableTest : public CppUnit::TestCase
  {

  public:
    /**
    @author Shane J Latham
    */
    CircularNeighbourTableTest();

    ~CircularNeighbourTableTest();

    /**
     * Sets up common data.
     */
    virtual void setUp();

    /**
     * Cleans up common data.
     */
    virtual void tearDown();

    CPPUNIT_TEST_SUITE( CircularNeighbourTableTest );
    CPPUNIT_TEST_EXCEPTION( testMultipleCircularDimension, std::runtime_error );
    CPPUNIT_TEST( testSingleCircularDimension );
    CPPUNIT_TEST( testGetNeighbours );
    CPPUNIT_TEST_SUITE_END();

    void testGetNeighbours();
    void testSingleCircularDimension();
    void testMultipleCircularDimension();
  };
};

#endif
