/*=============================================================================
??
??******************************************************************************
??*                                               *
??* COPYRIGHT ??????? - All Rights Reserved *
??*  *
??* This software is the property of ??????????????. No part of this code   *
??* may be copied in any form or by any means without the expressed written   *
??* consent of ???????????. Copying, use or modification of this software     *
??* by any unauthorised person is illegal unless that    *
??* person has a software license agreement with ?????????????.            *
??*                                                          *
??******************************************************************************
??
*********************************************************************************/

#ifndef LSMTESTGOUGEBLOCK3DTEST_H
#define LSMTESTGOUGEBLOCK3DTEST_H

#include <cppunit/extensions/HelperMacros.h>
#include <cppunit/TestCase.h>

#include <boost/shared_ptr.hpp>

namespace LsmTest
{
  /**
   *
   */
  class GougeBlock3DTest : public CppUnit::TestCase
  {
  public:
    GougeBlock3DTest();

    ~GougeBlock3DTest();

    /**
     * Sets up common data.
     */
    virtual void setUp();

    /**
     * Cleans up common data.
     */
    virtual void tearDown();

    CPPUNIT_TEST_SUITE( GougeBlock3DTest );
    CPPUNIT_TEST( test3dPrmsBlockSize );
    CPPUNIT_TEST( test2dPrmsBlockSize );
    CPPUNIT_TEST( testGougeBlockPrms );
    CPPUNIT_TEST( testGougeBlock );
    CPPUNIT_TEST( test2d );
    CPPUNIT_TEST_SUITE_END();

    void test3dPrmsBlockSize();
    void test2dPrmsBlockSize();
    void testGougeBlockPrms();
    void testGougeBlock();
    void test2d();

  private:
    class Impl;
    typedef boost::shared_ptr<Impl> ImplPtr;
    ImplPtr m_implPtr;
  };
};

#endif
