/*=============================================================================
??
??******************************************************************************
??*                                               *
??* COPYRIGHT ??????? - All Rights Reserved *
??*  *
??* This software is the property of ??????????????. No part of this code   *
??* may be copied in any form or by any means without the expressed written   *
??* consent of ???????????. Copying, use or modification of this software     *
??* by any unauthorised person is illegal unless that    *
??* person has a software license agreement with ?????????????.            *
??*                                                          *
??******************************************************************************
??
*********************************************************************************/

#ifndef LSMTESTGRIDITERATORTEST_H
#define LSMTESTGRIDITERATORTEST_H

#include <cppunit/extensions/HelperMacros.h>
#include <cppunit/TestCase.h>

namespace esys
{
  namespace lsm
  {
    class GridIterator;
  }
}

namespace LsmTest
{
  /**
   *
   */
  class GridIteratorTest : public CppUnit::TestCase
  {

  public:
    /**
     *
     */
    GridIteratorTest();

    ~GridIteratorTest();

    /**
     * Sets up common data.
     */
    virtual void setUp();

    /**
     * Cleans up common data.
     */
    virtual void tearDown();

    CPPUNIT_TEST_SUITE( GridIteratorTest );
    CPPUNIT_TEST( testIterator );
    CPPUNIT_TEST( testZeroDim );
    CPPUNIT_TEST( testCentrePointBoundingBox );
    CPPUNIT_TEST( testSphereBoundingBox );
    CPPUNIT_TEST( test2dSphereBoundingBox );
    CPPUNIT_TEST_SUITE_END();

    void testIterator();
    void testZeroDim();
    void testCentrePointBoundingBox();
    void testSphereBoundingBox();
    void test2dSphereBoundingBox();

  protected:
    int count(esys::lsm::GridIterator &it);

  };
};

#endif
