/*=============================================================================
??
??******************************************************************************
??*                                               *
??* COPYRIGHT ??????? - All Rights Reserved *
??*  *
??* This software is the property of ??????????????. No part of this code   *
??* may be copied in any form or by any means without the expressed written   *
??* consent of ???????????. Copying, use or modification of this software     *
??* by any unauthorised person is illegal unless that    *
??* person has a software license agreement with ?????????????.            *
??*                                                          *
??******************************************************************************
??
*********************************************************************************/

#ifndef LSMTESTTRIANGLETEST_H
#define LSMTESTTRIANGLETEST_H

#include <cppunit/extensions/HelperMacros.h>
#include <cppunit/TestCase.h>

namespace LsmTest
{
  /*!
     \author Steffen Abe
     $Revision$
     $$Date$
  */
  class TriangleTest :public CppUnit::TestCase
  {

  public:
    TriangleTest();
    virtual ~TriangleTest();

    virtual void setUp();
    virtual void tearDown();

    CPPUNIT_TEST_SUITE( TriangleTest );
    CPPUNIT_TEST( testDist );
    CPPUNIT_TEST( testSep );
    CPPUNIT_TEST( testBBXMin );
    CPPUNIT_TEST( testBBXMax );
    CPPUNIT_TEST( testContainsEdge );
    CPPUNIT_TEST( testToGlobal );
    CPPUNIT_TEST_SUITE_END();
    
    // the test methods
    void testDist();
    void testSep();
    void testBBXMin();
    void testBBXMax();
    void testContainsEdge();
    void testToGlobal();
  };
};

#endif // LSMTESTTRIANGLETEST_H
