/*--------------------------------------------------------------------------
 * GTK display for shake++
 * D. Place
 *-------------------------------------------------------------------------*/ 

#ifndef _BACKENDCOM_H
#define _BACKENDCOM_H

// -- project includes --
#include "RDFields.h"

// -- STL includes --
#include <string>

using std::string;

/***************************************************************************************/
/* Class CBackEndCom                                                                   */
/*                                                                                     */
/*                                                                                     */
/***************************************************************************************/
class CRemoteData;

/*!
  \class CBackEndCom
  \brief Class for communication to Back-End

  \author David Place, Steffen Abe
  $Revision$
  $Date$
*/
class CBackEndCom 
{
public:
  CBackEndCom() ;
  ~CBackEndCom() ;

  bool ping() ; //!< ping the back-end return true if OK.
  bool startSim() ; //!< start/continue simulation return true if OK.
  bool pauseSim() ; //!< pause simulation return true if OK.
  bool shutdown() ; //!< shutdown the back-end return true if OK.
  bool disconnect() ; //!< disconect from the back-end return true if OK.

  bool getParticlesData(CRemoteData *data);  //!< read particle data... return true if OK.
  bool getAvailableFields(CRemoteData *data);//!< get available fields... return true if OK.
  bool getFieldData(ADataField *);           //!< get field data... return true if OK.
  
} ;

#endif
