//--- Project includes ---
#include "ColorMap.h"
#include "console.h"

//--- IO includes ---
#include <fstream>
#include <iostream>

using std::ofstream;
using std::ifstream;
using std::endl;

/*! 
  Default constructor. Initializes the name of the colormap with "default"
  \note Is this really needed ?
*/
AColorMap::AColorMap()
{
  m_name=string("default");
  m_boundary=BConst;
}

/*!
  Constructor

  \param name the name of the colormap
*/
AColorMap::AColorMap(const string& name)
{
  m_name=name;
  m_boundary=BConst;
}

/*!
  The copy constructor

  \param CM the color map to be copied
*/
AColorMap::AColorMap(const AColorMap& CM)
{
  m_name=CM.m_name;
  m_boundary=CM.m_boundary;
}

/*!
  Destructor
*/
AColorMap::~AColorMap()
{}

/*!
  Assignment operator 
*/
AColorMap& AColorMap::operator=(const AColorMap& CM)
{
  m_name=CM.m_name;
  m_boundary=CM.m_boundary;

  return *this;
}

/*!
  Save a linear color map to a file. 

  \param filename the name of the file
*/
void AColorMap::SaveAs(const string& filename) const
{
  ofstream outfile(filename.c_str());
  outfile << m_name << endl;
  outfile << m_boundary << endl;

  outfile.close();
}
