#include "stdafx.h"
#include "GtkDisplayConServer.h"
#include <stdlib.h>
#include <gtk/gtk.h>

/***************************************************************************************/
/* Class CDisplayConsoleGTK                                                            */
/*                                                                                     */
/*                                                                                     */
/***************************************************************************************/

CDisplayConsoleSvcGTK::CDisplayConsoleSvcGTK() : CRemoteConsoleClient() , TPackageGTK<CDisplayConsoleSvcGTK>() {
  m_ConsoleText = NULL ;
  m_vadj = NULL ;
  Window=this ;
}

CDisplayConsoleSvcGTK::~CDisplayConsoleSvcGTK() {
  Window=NULL ;
}

void CDisplayConsoleSvcGTK::create(GtkWidget  *w, GtkAdjustment *a) { // assign widget to console...
  m_ConsoleText = w ; 
  m_vadj = a ;
}

void CDisplayConsoleSvcGTK::UpdateCon() { // overwrite the UpdateCon of base class to display messages.

  char TmpConsoleBuffer[16*1024];
  guint len ;
  guint maxsize = 16000 ;

  gtk_text_freeze(GTK_TEXT (m_ConsoleText)) ;
  console.GetLast(&TmpConsoleBuffer[0]) ;
  CRemoteConsoleClient::UpdateCon(&TmpConsoleBuffer[0]) ;
  len = gtk_text_get_length(GTK_TEXT (m_ConsoleText)) ;
  if (len > maxsize) {
    gtk_text_set_point (GTK_TEXT (m_ConsoleText),0) ;
    GdkColor color;
    color.red = 0x0000;
    color.green = 0x0000;
    color.blue = 0xAAAA;
    GdkColormap *cmap;
    cmap = gdk_colormap_get_system();
    gdk_color_alloc(cmap, &color) ;
    gtk_text_set_point (GTK_TEXT (m_ConsoleText),0) ;
    gtk_text_insert (GTK_TEXT (m_ConsoleText), NULL, &color, NULL,"\n   --- History has been cut out ---\n\n",-1) ;
    gtk_text_set_point (GTK_TEXT (m_ConsoleText),38) ;
    gtk_text_forward_delete(GTK_TEXT (m_ConsoleText),len-maxsize) ;
    len = gtk_text_get_length(GTK_TEXT (m_ConsoleText)) ;
  }
  gtk_text_set_point (GTK_TEXT (m_ConsoleText),len) ;
  gtk_text_insert (GTK_TEXT (m_ConsoleText), NULL, NULL, NULL,&TmpConsoleBuffer[0],strlen(&TmpConsoleBuffer[0]));
  len = gtk_text_get_length(GTK_TEXT (m_ConsoleText)) ;
  gtk_text_thaw (GTK_TEXT(m_ConsoleText));
  gtk_adjustment_set_value(m_vadj,2*len) ;
} 

