#include "stdafx.h"
#include <stdlib.h>
#include <gtk/gtk.h>
#include "GtkDisplayServer.h"
#include "GtkMessage.h"
#include "GtkAbout.h"
#include "mainparser.h"
#include "GtkPropertiesSvc.h"
#define MPI_NO_CPPBIND
#include <mpi.h>

#include "LatticeMaster.h"
#include "master_main.h"
#include "SocketServer.h"

/***************************************************************************************/
/* Class CDisplayGTK                                                                   */
/*                                                                                     */
/*                                                                                     */
/***************************************************************************************/

GtkItemFactoryEntry CDisplaySvcGTK::m_menu_items[] = {
  { "/_Connection",         NULL,         NULL, 0, "<Branch>" },
  { "/Connection/_Listen",   "<contro>F5", (void (*) ())(CDisplaySvcGTK::signalCB_vv), 0, NULL },
  { "/Connection/_Stop listening",   NULL, (void (*) ())(CDisplaySvcGTK::signalCB_vv), 0, NULL },
  { "/Connection/_Disconnect",   "<control>C", (void (*) ())(CDisplaySvcGTK::signalCB_vv), 0, NULL },
  { "/Connection/sep1",     NULL,         NULL, 0, "<Separator>" },
  { "/Connection/_Quit",     "<control>Q", (void (*) ())(CDisplaySvcGTK::signalCB_vv), 0, NULL },
  { "/_Simulation",         NULL,         NULL, 0, "<Branch>" },
  { "/Simulation/_Start",     "F7", (void (*) ())(CDisplaySvcGTK::signalCB_vv), 0, NULL },
  { "/Simulation/_Pause",     NULL, (void (*) ())(CDisplaySvcGTK::signalCB_vv), 0, NULL },
  { "/Simulation/_End",     NULL, (void (*) ())(CDisplaySvcGTK::signalCB_vv), 0, NULL },
  { "/_Edit",         NULL,         NULL, 0, "<Branch>" },
  { "/Edit/_Properties...",     "<control>P", (void (*) ())(CDisplaySvcGTK::signalCB_vv), 0, NULL },
  { "/_Help",         NULL,         NULL, 0, "<LastBranch>" },
  { "/_Help/About",   NULL,         (void (*) ())(CDisplaySvcGTK::signalCB_vv), 0, NULL },
};


CDisplaySvcGTK::~CDisplaySvcGTK ()  {
}

CDisplaySvcGTK::CDisplaySvcGTK (int argc, char **argv) : 
  CWindowGTK(), TPackageGTK<CDisplaySvcGTK>()  {
  int i ;
  int nmenu_items ;
    
  gtk_init (&argc, &argv);
  nmenu_items = sizeof (m_menu_items) / sizeof (m_menu_items[0]);

  for (i=0; i<nmenu_items; i++) {
    if (!strcmp(m_menu_items[i].path,"/Connection/_Quit"))  
      m_menu_items[i].callback_action = (guint) call(&CDisplaySvcGTK::quitCB) ;
    if (!strcmp(m_menu_items[i].path,"/Connection/_Listen"))  
      m_menu_items[i].callback_action = (guint) call(&CDisplaySvcGTK::listenCB) ;
    if (!strcmp(m_menu_items[i].path,"/Connection/_Stop listening"))  
      m_menu_items[i].callback_action = (guint) call(&CDisplaySvcGTK::stopListenCB) ;
    if (!strcmp(m_menu_items[i].path,"/Connection/_Disconnect"))  
      m_menu_items[i].callback_action = (guint) call(&CDisplaySvcGTK::disconnectCB) ;
    if (!strcmp(m_menu_items[i].path,"/Simulation/_Start"))  
      m_menu_items[i].callback_action = (guint) call(&CDisplaySvcGTK::startSimCB) ;
    if (!strcmp(m_menu_items[i].path,"/Simulation/_Pause"))  
      m_menu_items[i].callback_action = (guint) call(&CDisplaySvcGTK::pauseSimCB) ;
    if (!strcmp(m_menu_items[i].path,"/Simulation/_End"))  
      m_menu_items[i].callback_action = (guint) call(&CDisplaySvcGTK::endSimCB) ;
    if (!strcmp(m_menu_items[i].path,"/Edit/_Properties..."))  
      m_menu_items[i].callback_action = (guint) call(&CDisplaySvcGTK::propertiesCB) ;
    if (!strcmp(m_menu_items[i].path,"/_Help/About"))  
      m_menu_items[i].callback_action = (guint) call(&CDisplaySvcGTK::aboutCB) ;
  }

  m_aboutDLG=NULL ;
  m_messageDLG=NULL ;
  m_tag=0 ;
}

void CDisplaySvcGTK::create() {
  GtkWidget *window1;
  GtkWidget *vbox1;
  GtkWidget *handlebox1;
  GtkWidget *menubar1;
  GtkWidget *scrolledwindow2;
  GtkWidget *text2;
  GtkWidget *statusbar1;

  window1 = gtk_window_new (GTK_WINDOW_TOPLEVEL); m_window = window1 ;
  gtk_object_set_data (GTK_OBJECT (window1), "window1", window1);
  gtk_window_set_title (GTK_WINDOW (window1), "LSMearth - BackEnd");
  gtk_widget_set_usize (GTK_WIDGET(window1), 400, 300);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (window1), vbox1);

  handlebox1 = gtk_handle_box_new ();
  gtk_widget_ref (handlebox1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "handlebox1", handlebox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (handlebox1);
  gtk_box_pack_start (GTK_BOX (vbox1), handlebox1, FALSE, TRUE, 0);

  getMainMenu (window1, &menubar1);
  //menubar1 = gtk_menu_bar_new ();
  //gtk_widget_ref (menubar1);
  //gtk_object_set_data_full (GTK_OBJECT (window1), "menubar1", menubar1,
  //                          (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menubar1);
  gtk_container_add (GTK_CONTAINER (handlebox1), menubar1);

  GtkAdjustment *vadj = (GtkAdjustment *)gtk_adjustment_new(0,0,10,1,10,10) ;
  scrolledwindow2 = gtk_scrolled_window_new (NULL, vadj);
  gtk_widget_ref (scrolledwindow2);
  gtk_object_set_data_full (GTK_OBJECT (window1), "scrolledwindow2", scrolledwindow2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow2);
  gtk_box_pack_start (GTK_BOX (vbox1), scrolledwindow2, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow2), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

  text2 = gtk_text_new (NULL, NULL);

  gtk_widget_ref (text2);
  gtk_object_set_data_full (GTK_OBJECT (window1), "text2", text2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (text2);
  gtk_container_add (GTK_CONTAINER (scrolledwindow2), text2);

  statusbar1 = gtk_statusbar_new ();
  gtk_widget_ref (statusbar1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "statusbar1", statusbar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (statusbar1);
  gtk_box_pack_start (GTK_BOX (vbox1), statusbar1, FALSE, FALSE, 0);

  m_ConDsp.create(text2,vadj) ;

  if (sock->server() && sock->server()->connected()) {
    setSensitivity(CONNECTED) ;
  } else {
    setSensitivity(DISCONNECTED) ;
  }
  
  gtk_signal_connect (GTK_OBJECT (window1), "destroy",GTK_SIGNAL_FUNC (&CDisplaySvcGTK::signalCB_vv),call(&CDisplaySvcGTK::quitOK)) ;

}

void CDisplaySvcGTK::aboutCB() {
  if (m_aboutDLG) delete m_aboutDLG ;
  m_aboutDLG = new CAboutGTK(this) ;
  m_aboutDLG->create() ;
  m_aboutDLG->show() ;
}

void CDisplaySvcGTK::propertiesCB() {
  if (m_propertiesDLG) delete m_propertiesDLG ;
  m_propertiesDLG = new CPropertiesSvcGTK(this,NULL) ;
  m_propertiesDLG->create() ;
  m_propertiesDLG->show() ;
}

void CDisplaySvcGTK::disconnectCB() {
  if (m_state.m_connected) {
    sock->sendTag("END") ;
    sock->waitFor("ECK") ;
  }
  stop_timer() ;
  setSensitivity(DISCONNECTED) ;
}

void CDisplaySvcGTK::quitOK() {
  if (m_state.m_connected) {
    sock->sendTag("END") ;
    sock->waitFor("ECK") ;
  }
  stop_timer() ;
  gtk_main_quit() ;
}

void CDisplaySvcGTK::quitCB()
{
  if (m_state.m_connected) {
    if (m_messageDLG) delete m_messageDLG ;
    m_messageDLG = new CMessageGTK(this,"Query","Connection will be close.",(GTKFncPtr)&CDisplaySvcGTK::quitOK) ;
    m_messageDLG->create() ;
    m_messageDLG->show() ;
  } else {
    gtk_main_quit() ;
  }
}

void CDisplaySvcGTK::getMainMenu( GtkWidget  *window, GtkWidget **menubar )
{
  GtkAccelGroup *accel_group;
  gint nmenu_items = sizeof (m_menu_items) / sizeof (m_menu_items[0]);

  accel_group = gtk_accel_group_new ();
  m_item_factory = gtk_item_factory_new (GTK_TYPE_MENU_BAR, "<main>",
				       accel_group);
  gtk_item_factory_create_items (m_item_factory, nmenu_items, m_menu_items, NULL);

  /* Attach the new accelerator group to the window. */
  gtk_window_add_accel_group (GTK_WINDOW (window), accel_group);

  if (menubar)
    /* Finally, return the actual menu bar created by the item factory. */
    *menubar = gtk_item_factory_get_widget (m_item_factory, "<main>");
}

void CDisplaySvcGTK::setSensitivity(SENSITIVITY s) {
  switch (s) {
  case CONNECTED:
    m_state.m_connected = true ;
    m_state.m_listening = false ;
    break ;
  case DISCONNECTED:
    m_state.m_connected = false ;
    break ;
  case LISTEN:
    m_state.m_connected = false ;
    m_state.m_listening = true ;
    break ;
  case DONTLISTEN:
    m_state.m_listening = false ;
    break ;
  }
  updateMenuSensitivity() ;
}

void CDisplaySvcGTK::updateMenuSensitivity() {
  if (m_state.m_connected) {
    gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/Connection/Listen"),false);
    gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/Connection/Stop listening"),false);
    gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/Connection/Disconnect"),true);
  } else {
    gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/Connection/Disconnect"),false);
    if (m_state.m_listening) {
      gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/Connection/Listen"),false);
      gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/Connection/Stop listening"),true);
    } else {
      gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/Connection/Listen"),true);
      gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/Connection/Stop listening"),false);
    }
  }
}

int CDisplaySvcGTK::exec() {
  show();
  m_ConDsp.UpdateCon() ;
  //  start_timer() ;

  gtk_main();
  return(0);
}

void CDisplaySvcGTK::stopListenCB() {
  setSensitivity(DONTLISTEN) ;
  sock->server()->inboundClose() ;
  stop_timer() ;
  
}

void CDisplaySvcGTK::listenCB() {
  setSensitivity(LISTEN) ;
  start_timer() ;
}


void CDisplaySvcGTK::start_timer() {
  m_tag = gtk_timeout_add(100,&CDisplaySvcGTK::signalCB_iv,call(&CDisplaySvcGTK::timeoutCB)) ;
}

void CDisplaySvcGTK::stop_timer() {
  if (m_tag) gtk_timeout_remove(m_tag);
}

void CDisplaySvcGTK::startSimCB() {
  ((CBackEndSocketSvc *)(sock))->startPauseSim(true) ;
  // m_simtag = gtk_timeout_add(100,&CDisplaySvcGTK::signalCB_iv,call(&CDisplaySvcGTK::timeoutSimCB)) ;
  //  TheLatticeMaster->run() ;
}

void CDisplaySvcGTK::pauseSimCB() {
  ((CBackEndSocketSvc *)(sock))->startPauseSim(false) ;
  //if (m_simtag) gtk_timeout_remove(m_simtag);
}

void CDisplaySvcGTK::endSimCB() {
  TheLatticeMaster->runEnd() ;
}

//void CDisplaySvcGTK::timeoutSimCB() {
//  TheLatticeMaster->runOneStep() ;
//}

void CDisplaySvcGTK::timeoutCB() {
  sock->msgloop() ;
  if (sock->server()) {
    if ((sock->server()->connected()) && (m_ConDsp.getSocket()==NULL)) {
      m_ConDsp.connectTo(sock->server()) ;
      setSensitivity(CONNECTED) ;
    }
    if ((!sock->server()->connected())&& (m_ConDsp.getSocket())) {
      m_ConDsp.connectTo(NULL) ;
      setSensitivity(DISCONNECTED) ;
    }
  }
  if (sock->mustExit()) quitOK() ;
}
