/*--------------------------------------------------------------------------
 * GTK display for shake++
 * D. Place
 *-------------------------------------------------------------------------*/ 

#ifndef _GTKDISPLAYSVC_H
#define _GTKDISPLAYSVC_H

#include "ShakeDisplay.h"
#include "remoteConsole.h"
#include <gtk/gtk.h>
#include "GtkPackage.h"
#include "GtkCWindow.h"
#include "GtkDisplayConServer.h"


/***************************************************************************************/
/* Class CDisplaySvcGTK                                                                */
/*                                                                                     */
/*                                                                                     */
/***************************************************************************************/

class CAboutGTK  ;
class CMessageGTK  ;
class CPropertiesSvcGTK  ;

class CDisplaySvcGTK : public CWindowGTK, public TPackageGTK<CDisplaySvcGTK>
{
 private:

  // Data for menu...
  enum SENSITIVITY {CONNECTED,DISCONNECTED,LISTEN,DONTLISTEN} ;
  struct {
    bool m_connected,m_listening ;
  } m_state ;
  static GtkItemFactoryEntry m_menu_items[] ;
  GtkItemFactory *m_item_factory;

  void getMainMenu( GtkWidget  *window, GtkWidget **menubar) ;
  void setSensitivity(SENSITIVITY s) ;
  void updateMenuSensitivity() ;

 protected:
  guint m_tag;

  // The interfaces for console
  CDisplayConsoleSvcGTK m_ConDsp ;

  // The dialogs...
  CAboutGTK *m_aboutDLG ;
  CMessageGTK *m_messageDLG ;
  CPropertiesSvcGTK  *m_propertiesDLG;

  // callbacks from the menus
  void propertiesCB() ;
  void listenCB() ;
  void disconnectCB() ;
  void stopListenCB() ;
  void quitCB() ;
  void aboutCB() ;
  void startSimCB() ;
  void pauseSimCB() ;
  void endSimCB() ;

  // callbacks from dialogs
  void quitOK() ;

  void timeoutCB() ;
  void start_timer() ;
  void stop_timer() ;
 public:

  CDisplaySvcGTK(int argc, char **argv) ;
  ~CDisplaySvcGTK() ;

  virtual int exec() ;    // Main event loop
  virtual void create() ; // Create window & widgets...
};

#endif 

