#include "stdafx.h"
#include "GtkConnect.h"
#ifndef _WINDOWS
#include <unistd.h>
#endif

CConnectGTK::~CConnectGTK ()  {
}

CConnectGTK::CConnectGTK (CWindowGTK *parent, GTKFncPtr ptr) : CWindowGTK(), TPackageGTK<CConnectGTK>()  {
  m_parent = parent ;
  m_curPort = sock->minPort() ;
  m_servers = NULL ;
  m_nbrow = 0 ;
  m_ptr = ptr ;
}

void CConnectGTK::show() {
  CWindowGTK::show() ;
  m_tag = gtk_timeout_add(10,&CConnectGTK::signalCB_iv,call(&CConnectGTK::timeoutCB)) ;
}

void CConnectGTK::timeoutCB() {
  char Id[1024],name[1024],aPort[1024] ;
  char *myHost,*text[3],*curt ;
  bool same,insert ;
  unsigned short Port ; 
  int i ;

  myHost = gtk_entry_get_text(GTK_ENTRY (m_host->entry)) ;

  if (m_curPort > sock->maxPort()) return  ; 

  sock->client()->connectTo(myHost,m_curPort,m_curPort) ;
  if (sock->client()->connected()) {

    sock->sendTag("QRY") ;
    tconsole.Debug() << "Waiting for query data...\n" ;
    CShakePacket *QData=sock->waitFor("QDT") ;

    Cxdr xdata((char *)(QData->getData()),QData->getSize()) ;
    xdata >> &Id[0] >> Port >> &name[0] ;
   
    sprintf(&aPort[0],"%d",Port) ;
    text[0] = &Id[0] ; 
    text[1] = &aPort[0] ; 
    text[2] = myHost ;

    insert = true ;
    for (i=0; i<m_nbrow; i++) {
      gtk_clist_get_text (m_servers, i, 0, &curt);
      same = (!strcmp(text[0],curt)) ;
      gtk_clist_get_text (m_servers, i, 1, &curt);
      same = (same && !strcmp(text[1],curt)) ;
      gtk_clist_get_text (m_servers, i, 2, &curt);
      same = (same && !strcmp(text[2],curt)) ;
      if (same) insert=false ;
    }

    if (insert) {
      gtk_clist_append(GTK_CLIST ( m_servers),text) ;
      m_nbrow++ ;
      gtk_clist_thaw(GTK_CLIST ( m_servers));
    }

    sock->sendTag("END") ;
    sock->waitFor("ECK") ;
    sock->client()->close() ;
  }
  m_curPort++ ;
}

void CConnectGTK::quitCB() {
  gtk_timeout_remove(m_tag);  
  gtk_widget_destroy(GTK_WIDGET(m_window)) ;
}

void CConnectGTK::connectCB() {
  char *name,*host,*port ;
  gtk_clist_get_text (m_servers, m_rowsel, 0, &name);
  gtk_clist_get_text (m_servers, m_rowsel, 1, &port);
  gtk_clist_get_text (m_servers, m_rowsel, 2, &host);
  console.Debug() << "Connecting to "<<host<<":"<<port<<" aka "<<name<<" ...\n" ;
  sock->client()->connectTo(host,atol(port),atol(port),name) ;
  if (sock->client()->connected()) {
    console.Info() << "Connected to " << name << "\n" ;
    sock->sendTag("CLS") ;
    (m_parent->*m_ptr)() ;
  } else {
    console.Error() << "Connection failed.\n" ;
  }
  quitCB() ;
}

void CConnectGTK::refreshCB() {
  gtk_clist_clear(GTK_CLIST(m_servers)) ;
  gtk_clist_thaw(GTK_CLIST(m_servers));
  m_nbrow = 0 ;
  m_curPort=sock->minPort() ;
  gtk_widget_set_sensitive(m_connect,false);
}

void CConnectGTK::hostChangedCB() {
  //   m_curPort=sock->minPort() ;
}

void CConnectGTK::selectRowCB() {
  m_rowsel = (gint)(getCBargv(1)) ;
  gtk_widget_set_sensitive(m_connect,true);
}

void CConnectGTK::create() {
  GtkWidget *window1;
  GtkWidget *vbox1;
  GtkWidget *hbox1;
  GtkWidget *label1;
  GtkWidget *host;
  GtkWidget *combo_entry2;
  GtkWidget *scrolledwindow1;
  GtkWidget *clist1;
  GtkWidget *ServerId;
  GtkWidget *port;
  GtkWidget *owner;
  GtkWidget *hbuttonbox1;
  GtkWidget *button3;
  GtkWidget *button4;
  GtkWidget *button5;

  window1 = gtk_window_new (GTK_WINDOW_DIALOG);

  gtk_object_set_data (GTK_OBJECT (window1), "window1", window1);
  gtk_container_set_border_width (GTK_CONTAINER (window1), 3);
  gtk_window_set_title (GTK_WINDOW (window1), "Connection");
  gtk_window_set_position (GTK_WINDOW (window1), GTK_WIN_POS_MOUSE);
  gtk_window_set_modal (GTK_WINDOW (window1), TRUE);
  gtk_window_set_policy (GTK_WINDOW (window1), FALSE, FALSE, FALSE);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (window1), vbox1);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 3);

  label1 = gtk_label_new ("Host");
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (hbox1), label1, FALSE, FALSE, 10);

  // The host drop-down list...

  host = gtk_combo_new (); m_host = (GtkCombo *)host ;

  gtk_widget_ref (host);
  gtk_object_set_data_full (GTK_OBJECT (window1), "host", host,
                            (GtkDestroyNotify) gtk_widget_unref);
  GList *items = NULL;
  items = g_list_append (items,(void *) "localhost");
  items = g_list_append (items,(void *) "shake5.quakes.uq.edu.au");
  items = g_list_append (items,(void *) "shake2.quakes.uq.edu.au");
  items = g_list_append (items,(void *) "shake27.quakes.uq.edu.au");
  gtk_combo_set_popdown_strings (GTK_COMBO (host), items);

  gtk_widget_show (host);
  gtk_box_pack_start (GTK_BOX (hbox1), host, TRUE, TRUE, 3);

  combo_entry2 = GTK_COMBO (host)->entry;
  gtk_widget_ref (combo_entry2);
  gtk_object_set_data_full (GTK_OBJECT (window1), "combo_entry2", combo_entry2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo_entry2);

  // the list of servers

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "scrolledwindow1", scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (vbox1), scrolledwindow1, TRUE, TRUE, 9);
  gtk_widget_set_usize (scrolledwindow1, -2, 136);
  gtk_container_set_border_width (GTK_CONTAINER (scrolledwindow1), 3);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

  clist1 = gtk_clist_new (3);
  gtk_widget_ref (clist1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "clist1", clist1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (clist1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), clist1);
  gtk_clist_set_column_width (GTK_CLIST (clist1), 0, 71);
  gtk_clist_set_column_width (GTK_CLIST (clist1), 1, 60);
  gtk_clist_set_column_width (GTK_CLIST (clist1), 2, 135);
  gtk_clist_column_titles_show (GTK_CLIST (clist1));

  ServerId = gtk_label_new ("BackEnd Id");
  gtk_widget_ref (ServerId);
  gtk_object_set_data_full (GTK_OBJECT (window1), "BackEndId", ServerId,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ServerId);
  gtk_clist_set_column_widget (GTK_CLIST (clist1), 0, ServerId);
  gtk_label_set_justify (GTK_LABEL (ServerId), GTK_JUSTIFY_LEFT);

  port = gtk_label_new ("Port");
  gtk_widget_ref (port);
  gtk_object_set_data_full (GTK_OBJECT (window1), "port", port,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (port);
  gtk_clist_set_column_widget (GTK_CLIST (clist1), 1, port);

  owner = gtk_label_new ("Host");
  gtk_widget_ref (owner);
  gtk_object_set_data_full (GTK_OBJECT (window1), "owner", owner,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (owner);
  gtk_clist_set_column_widget (GTK_CLIST (clist1), 2, owner);

  m_servers = GTK_CLIST (clist1) ;

  // the three button Test, Connect & cancel

  hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "hbuttonbox1", hbuttonbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbuttonbox1, TRUE, TRUE, 0);
  gtk_button_box_set_child_size (GTK_BUTTON_BOX (hbuttonbox1), -1, 38);

  button3 = gtk_button_new_with_label ("Refresh");
  gtk_widget_ref (button3);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button3", button3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button3);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), button3);
  GTK_WIDGET_SET_FLAGS (button3, GTK_CAN_DEFAULT);

  button4 = gtk_button_new_with_label ("Connect");
  gtk_widget_ref (button4);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button4", button4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button4);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), button4);
  GTK_WIDGET_SET_FLAGS (button4, GTK_CAN_DEFAULT);
  m_connect = button4 ;
  gtk_widget_set_sensitive(m_connect,false);

  button5 = gtk_button_new_with_label ("Cancel");
  gtk_widget_ref (button5);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button5", button5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button5);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), button5);
  GTK_WIDGET_SET_FLAGS (button5, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (m_host->entry), "changed",GTK_SIGNAL_FUNC (&CConnectGTK::signalCB_vv),call(&CConnectGTK::hostChangedCB));
  gtk_signal_connect (GTK_OBJECT (window1), "destroy",GTK_SIGNAL_FUNC (&CConnectGTK::signalCB_vv),call(&CConnectGTK::quitCB));
  gtk_signal_connect (GTK_OBJECT (m_servers), "select-row",(GtkSignalFunc)(&CConnectGTK::signalCB_lst),call(&CConnectGTK::selectRowCB)) ;
  gtk_signal_connect_object (GTK_OBJECT (button5), "clicked",(GtkSignalFunc) gtk_widget_destroy, GTK_OBJECT (window1));
  gtk_signal_connect (GTK_OBJECT (button4), "clicked",(GtkSignalFunc)(&CConnectGTK::signalCB_vv),call(&CConnectGTK::connectCB)) ;
  gtk_signal_connect (GTK_OBJECT (button3), "clicked",(GtkSignalFunc)(&CConnectGTK::signalCB_vv),call(&CConnectGTK::refreshCB)) ;

  m_window = window1 ;
}

