#include "stdafx.h"
#include <stdlib.h>
#include <gtk/gtk.h>
#include "GtkDisplay.h"
#include "GtkConnect.h"
#include "GtkFileDialog.h"
#include "GtkConnect.h"
#include "GtkRenderer.h"
#include "GtkProperties.h"
#include "GtkMessage.h"
#include "GtkAbout.h"
#include "mainparser.h"
#include "RemoteData.h"


/***************************************************************************************/
/* Class CDisplayGTK                                                                   */
/*                                                                                     */
/*                                                                                     */
/***************************************************************************************/

GtkItemFactoryEntry CDisplayGTK::m_menu_items[] = {
  { "/_File",         NULL,         NULL, 0, "<Branch>" },
  { "/File/_New",     "<control>N", (void (*) ())(CDisplayGTK::menuCB_vv), 0, NULL },
  { "/File/_Open",    "<control>O", (void (*) ())(CDisplayGTK::menuCB_vv), 0, NULL },
  { "/File/_Save",    "<control>S", (void (*) ())(CDisplayGTK::menuCB_vv), 0, NULL },
  { "/File/Save _As", NULL,         (void (*) ())(CDisplayGTK::menuCB_vv), 0, NULL },
  { "/File/sep1",     NULL,         NULL, 0, "<Separator>" },
  { "/File/Parse...", "F7",          (void (*) ())(CDisplayGTK::menuCB_vv), 0, NULL },
  { "/File/Run main()", "<control>F5",  (void (*) ())(CDisplayGTK::menuCB_vv), 0, NULL },
  { "/File/Remote execute main()",     NULL, (void (*) ())(CDisplayGTK::menuCB_vv), 0,  NULL },
  { "/File/sep1",     NULL,         NULL, 0, "<Separator>" },
  { "/File/Quit",     "<control>Q", (void (*) ())(CDisplayGTK::menuCB_vv), 0, NULL },
  { "/_Edit",         NULL,         NULL, 0, "<Branch>" },
  { "/Edit/Copy",     "<control>C",         NULL, 0, NULL },
  { "/Edit/Cut",      "<control>X",         NULL, 0, NULL },
  { "/Edit/Past",     "<control>V",         NULL, 0, NULL },
  { "/Edit/sep1",     NULL,         NULL, 0, "<Separator>" },
  { "/Edit/_Properties...",     "<control>P", (void (*) ())(CDisplayGTK::menuCB_vv), 0, NULL },
  { "/_Back-end",      NULL,         NULL, 0, "<Branch>" },
  { "/Back-end/_Connect...", NULL,        (void (*) ())(CDisplayGTK::menuCB_vv), 0, NULL },
  { "/Back-end/_Disconnect",  "ESC", (void (*) ())(CDisplayGTK::menuCB_vv), 0, NULL },
  { "/Back-end/sep1",     NULL,         NULL, 0, "<Separator>" },
  { "/Back-end/Pin_g",  NULL, (void (*) ())(CDisplayGTK::menuCB_vv), 0, NULL },
  { "/Back-end/_Simulation Start",  NULL, (void (*) ())(CDisplayGTK::menuCB_vv), 0, NULL },
  { "/Back-end/Simulation _Pause",  NULL, (void (*) ())(CDisplayGTK::menuCB_vv), 0, NULL },
  { "/Back-end/sep1",     NULL,         NULL, 0, "<Separator>" },
  { "/Back-end/_Shutdown",  "<alt>F10", (void (*) ())(CDisplayGTK::menuCB_vv), 0, NULL },
  { "/_Renderer",      NULL,         NULL, 0, "<Branch>" },
  { "/Renderer/_Create new...", NULL,        (void (*) ())(CDisplayGTK::menuCB_vv), 0, NULL },
  { "/Renderer/Close all", "<control>F4",        (void (*) ())(CDisplayGTK::menuCB_vv), 0, NULL },
  { "/Renderer/Stereo", NULL,        (void (*) ())(CDisplayGTK::menuCB_vv), 0, NULL },
  { "/_Help",         NULL,         NULL, 0, "<LastBranch>" },
  { "/_Help/About",   NULL,         (void (*) ())(CDisplayGTK::menuCB_vv), 0, NULL },
};


CDisplayGTK::~CDisplayGTK ()  {
}

CDisplayGTK::CDisplayGTK (char *filename, int argc, char **argv) : 
  CWindowGTK(), CShakeDisplay(), TPackageGTK<CDisplayGTK>()  {
  int i ;
  int nmenu_items ;
    
  gtk_init (&argc, &argv);
  nmenu_items = sizeof (m_menu_items) / sizeof (m_menu_items[0]);

  for (i=0; i<nmenu_items; i++) {
    if (!strcmp(m_menu_items[i].path,"/File/_New")) 
      m_menu_items[i].callback_action = call_int(&CDisplayGTK::newCB) ;
    if (!strcmp(m_menu_items[i].path,"/File/_Open"))  
      m_menu_items[i].callback_action = call_int(&CDisplayGTK::openCB) ;
    if (!strcmp(m_menu_items[i].path,"/File/_Save"))  
      m_menu_items[i].callback_action = call_int(&CDisplayGTK::saveCB) ;
    if (!strcmp(m_menu_items[i].path,"/File/Save _As"))  
      m_menu_items[i].callback_action = call_int(&CDisplayGTK::saveasCB) ;
    if (!strcmp(m_menu_items[i].path,"/File/Parse..."))  
      m_menu_items[i].callback_action = call_int(&CDisplayGTK::parseCB) ;
    if (!strcmp(m_menu_items[i].path,"/File/Run main()"))  
      m_menu_items[i].callback_action = call_int(&CDisplayGTK::evalmainCB) ;
    if (!strcmp(m_menu_items[i].path,"/File/Remote execute main()"))  
      m_menu_items[i].callback_action = call_int(&CDisplayGTK::remoteEvalCB) ;
    if (!strcmp(m_menu_items[i].path,"/File/Quit"))  
      m_menu_items[i].callback_action = call_int(&CDisplayGTK::quitCB) ;
    if (!strcmp(m_menu_items[i].path,"/Back-end/_Connect..."))  
      m_menu_items[i].callback_action = call_int(&CDisplayGTK::connectCB) ;
    if (!strcmp(m_menu_items[i].path,"/Back-end/_Disconnect"))  
      m_menu_items[i].callback_action = call_int(&CDisplayGTK::disconnectCB) ;
    if (!strcmp(m_menu_items[i].path,"/Back-end/Pin_g"))  
      m_menu_items[i].callback_action = call_int(&CDisplayGTK::pingCB) ;
    if (!strcmp(m_menu_items[i].path,"/Back-end/_Simulation Start"))  
      m_menu_items[i].callback_action = call_int(&CDisplayGTK::simStartCB) ;
    if (!strcmp(m_menu_items[i].path,"/Back-end/Simulation _Pause"))  
      m_menu_items[i].callback_action = call_int(&CDisplayGTK::simPauseCB) ;
    if (!strcmp(m_menu_items[i].path,"/Back-end/_Shutdown"))  
      m_menu_items[i].callback_action = call_int(&CDisplayGTK::shutdownCB) ;
    if (!strcmp(m_menu_items[i].path,"/Renderer/_Create new..."))  
      m_menu_items[i].callback_action = call_int(&CDisplayGTK::openRendererCB) ;
    if (!strcmp(m_menu_items[i].path,"/Renderer/Close all"))  
      m_menu_items[i].callback_action = call_int(&CDisplayGTK::closeRendererCB) ;
    if (!strcmp(m_menu_items[i].path,"/Renderer/Stereo"))  
      m_menu_items[i].callback_action = call_int(&CDisplayGTK::stereoCB) ;
    if (!strcmp(m_menu_items[i].path,"/Edit/_Properties..."))  
      m_menu_items[i].callback_action = call_int(&CDisplayGTK::propertiesCB) ;
    if (!strcmp(m_menu_items[i].path,"/_Help/About"))  
      m_menu_items[i].callback_action = call_int(&CDisplayGTK::aboutCB) ;
  }

  m_FileDialogWindow = NULL ;
  m_connectDLG = NULL ;
  m_editor.setFilename(filename) ;
  // m_rendererWindow = NULL ;
  m_aboutDLG=NULL ;
  m_messageDLG=NULL ;
  m_propertiesDLG=NULL ;
  m_tag = 0 ;
}

void CDisplayGTK::create() {
  GtkWidget *window;
  GtkWidget *main_vbox;
  GtkWidget *menubar;
  GtkWidget *scrolledScript ;
  GtkWidget *scrolledConsole ;
  GtkWidget *ConsoleText ;
  GtkWidget *ScriptText ;
  GtkAdjustment *vadj ;

  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  m_window = window ;
  gtk_window_set_title (GTK_WINDOW(window), "LSMearth");
  gtk_widget_set_usize (GTK_WIDGET(window), 600, 480);

  main_vbox = gtk_vbox_new (FALSE, 1);
  gtk_container_border_width (GTK_CONTAINER (main_vbox), 1);
  gtk_container_add (GTK_CONTAINER (window), main_vbox);
  gtk_widget_show (main_vbox);

  GtkWidget *handlebox1 = gtk_handle_box_new ();
  gtk_widget_ref (handlebox1);
  gtk_object_set_data_full (GTK_OBJECT (window), "handlebox1", handlebox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (handlebox1);
  gtk_box_pack_start (GTK_BOX (main_vbox), handlebox1, FALSE, TRUE, 0);

  getMainMenu (window, &menubar);
  //gtk_box_pack_start (GTK_BOX (handlebox1), menubar, FALSE, TRUE, 0);
  //Renderergtk_widget_show (menubar);
  gtk_widget_show (menubar);
  gtk_container_add (GTK_CONTAINER (handlebox1), menubar);

  GtkWidget *vpaned1 = gtk_vpaned_new ();
  gtk_widget_ref (vpaned1);
  gtk_object_set_data_full (GTK_OBJECT (window), "vpaned1", vpaned1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vpaned1);
  gtk_box_pack_start (GTK_BOX (main_vbox), vpaned1, TRUE, TRUE, 0);
  gtk_paned_set_position (GTK_PANED (vpaned1), 350);

  scrolledScript = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledScript) ; 
  gtk_object_set_data_full (GTK_OBJECT (window), "scrolledscript", scrolledScript,(GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledScript);
  gtk_paned_pack1 (GTK_PANED (vpaned1), scrolledScript, FALSE, TRUE);
  //  gtk_box_pack_start (GTK_BOX (vpaned1), scrolledScript, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledScript), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

  ScriptText = gtk_text_new (NULL, NULL);
  gtk_text_set_editable (GTK_TEXT (ScriptText), TRUE);
  gtk_widget_ref (ScriptText);
  gtk_object_set_data_full (GTK_OBJECT (window), "script", ScriptText, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ScriptText);
  gtk_container_add (GTK_CONTAINER (scrolledScript), ScriptText);


  vadj = (GtkAdjustment *)gtk_adjustment_new(0,0,10,1,10,10) ;
  scrolledConsole = gtk_scrolled_window_new (NULL, vadj);
  gtk_widget_ref (scrolledConsole) ; 
  gtk_object_set_data_full (GTK_OBJECT (window), "scrolledconsole", scrolledConsole,(GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledConsole);
  gtk_paned_pack2 (GTK_PANED (vpaned1), scrolledConsole, FALSE, TRUE);
  //gtk_box_pack_start (GTK_BOX (vpaned1), scrolledConsole, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledConsole), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

  ConsoleText = gtk_text_new (NULL, NULL);
  GtkStyle *sty = gtk_widget_get_style(ConsoleText);
  GdkColor colorbg,colorfg;
  colorfg.red = 0x0000;
  colorfg.green = 0x0000;
  colorfg.blue = 0x0000;
  colorbg.red = 0xBBBB;
  colorbg.green = 0xBBBB;
  colorbg.blue = 0xBBBB;
  GdkColormap *cmap;
  cmap = gdk_colormap_get_system();
  gdk_color_alloc(cmap, &colorbg) ;
  gdk_color_alloc(cmap, &colorfg) ;
  sty->base[0] = colorbg ;
  sty->text[0] = colorfg ;
  gtk_widget_set_style(ConsoleText,sty) ;
  gtk_widget_ref (ConsoleText);
  gtk_object_set_data_full (GTK_OBJECT (window), "console", ConsoleText, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ConsoleText);
  gtk_container_add (GTK_CONTAINER (scrolledConsole), ConsoleText);

  GtkWidget *statusbar1 = gtk_statusbar_new ();
  gtk_widget_ref (statusbar1);
  gtk_object_set_data_full (GTK_OBJECT (window), "statusbar1", statusbar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (statusbar1);
  gtk_box_pack_start (GTK_BOX (main_vbox), statusbar1, FALSE, FALSE, 0);

  m_ConDsp.create(ConsoleText,vadj) ;
  m_editor.create(this,ScriptText) ;

  if (m_editor.getFilename()) {
    m_editor.readfile() ;
    setSensitivity(DISK_SYNCHRONIZED) ;
  } else {
    setSensitivity(EMPTYED) ;
  }

  if (sock->client() && sock->client()->connected()) {
    setSensitivity(CONNECTED) ;
  } else {
    setSensitivity(DISCONNECTED) ;
  }
  
  gtk_signal_connect (GTK_OBJECT (window), "destroy",GTK_SIGNAL_FUNC (&CDisplayGTK::signalCB_vv),call(&CDisplayGTK::quitOK)) ;

}  

void CDisplayGTK::simStartCB() {
  if (sock->client() && sock->client()->connected()) {
    if (m_backend.startSim()) {
      console.Info() << "Starting Simulation.\n" ;
    } else {
      console.Info() << "Connection is down...\n" ;
      disconnected() ;
    }
  } else {
    console.Info() << "Connection is down...\n" ;
    disconnected() ;
  }
}

void CDisplayGTK::simPauseCB() {
  if (sock->client() && sock->client()->connected()) {
    if (m_backend.pauseSim()) {
      console.Info() << "Pausing Simulation.\n" ;
    } else {
      console.Info() << "Connection is down...\n" ;
      disconnected() ;
    }
  } else {
    console.Info() << "Connection is down...\n" ;
    disconnected() ;
  }
}

void CDisplayGTK::pingCB() {
  if (sock->client() && sock->client()->connected()) {
    console.Debug() << "Sending packet, waiting for answer...\n" ;
    if (m_backend.ping()) {
      console.Info() << "Server is alive.\n" ;
      //CRemoteData cm(&m_backend) ;
      //m_backend.getParticlesData(&cm) ;
      //console.Info() << "Server is very alive.\n" ;
    } else {
      console.Info() << "Connection is down...\n" ;
      disconnected() ;
    }
  } else {
    console.Info() << "Connection is down...\n" ;
    disconnected() ;
  }
}

void CDisplayGTK::propertiesCB() {
  if (m_propertiesDLG) delete m_propertiesDLG ;
  m_propertiesDLG = new CPropertiesGTK(this,(GTKFncPtr)NULL) ;
  m_propertiesDLG->create() ;
  m_propertiesDLG->show() ;
}

void CDisplayGTK::aboutCB() {
  if (m_aboutDLG) delete m_aboutDLG ;
  m_aboutDLG = new CAboutGTK(this) ;
  m_aboutDLG->create() ;
  m_aboutDLG->show() ;
}

void CDisplayGTK::openRendererCB() {
  CRendererGTK *rendererWindow ;
  //if (m_rendererWindow) delete m_rendererWindow;
  rendererWindow = new CRendererGTK(this,m_Idrenderer) ;
  rendererWindow->create() ;
  rendererWindow->show() ;

  addRenderer(rendererWindow) ;
}

void CDisplayGTK::closeRendererCB() {
  closeAllRenderer() ;
}

void CDisplayGTK::stereoCB() {
  closeAllRenderer() ;
  CShakeRenderer::stereo = !CShakeRenderer::stereo ;
  if (CShakeRenderer::stereo) {
    console.Info() << "Stereo is on.\n" ;
  } else {
    console.Info() << "Stereo is off.\n" ;
  }
}

void CDisplayGTK::shutdownOK() {
    disconnected() ;
    m_backend.shutdown() ;
}

void CDisplayGTK::shutdownCB() {
  if (sock->client() && sock->client()->connected()) {
    if (m_messageDLG) delete m_messageDLG ;
    m_messageDLG = new CMessageGTK(this,"Query","Ok to showdown the server?",(GTKFncPtr)&CDisplayGTK::shutdownOK) ;
    m_messageDLG->create() ;
    m_messageDLG->show() ;
  } else {
    if (m_messageDLG) delete m_messageDLG ;
    m_messageDLG = new CMessageGTK(this,"Error","Not connected!") ;
    m_messageDLG->create() ;
    m_messageDLG->show() ;
  }
}

void CDisplayGTK::newOK()
{
  m_editor.renew() ;
  setSensitivity(EMPTYED) ;
}

void CDisplayGTK::newCB()
{
  if (state.m_modified) {
    if (m_messageDLG) delete m_messageDLG ;
    m_messageDLG = new CMessageGTK(this,"Query","Script modified, press OK to discard.",(GTKFncPtr)&CDisplayGTK::newOK) ;
    m_messageDLG->create() ;
    m_messageDLG->show() ;
  } else {
    newOK() ;
  }
}

void CDisplayGTK::quitOK2()
{
  gtk_main_quit() ;
}
void CDisplayGTK::quitOK()
{
  if (state.m_connected) {
    disconnectCB() ;
    //if (m_messageDLG) delete m_messageDLG ;
    m_messageDLG = new CMessageGTK(this,"Warning","Your connection has been ended.",(GTKFncPtr)&CDisplayGTK::quitOK2,(GTKFncPtr)&CDisplayGTK::quitOK2) ;
    m_messageDLG->create() ;
    m_messageDLG->show() ;
  } else {
    quitOK2() ;
  }
  //  gtk_main_quit() ;
}

void CDisplayGTK::quitCB()
{
  if (state.m_modified) {
    if (m_messageDLG) delete m_messageDLG ;
    m_messageDLG = new CMessageGTK(this,"Query","Script modified, press OK to discard.",(GTKFncPtr)&CDisplayGTK::quitOK) ;
    m_messageDLG->create() ;
    m_messageDLG->show() ;
  } else {
    if (m_messageDLG) delete m_messageDLG ;
    m_messageDLG = new CMessageGTK(this,"Query","Really Quit?",(GTKFncPtr)&CDisplayGTK::quitOK) ;
    m_messageDLG->create() ;
    m_messageDLG->show() ;
  }
}

static AParserInterface API ;
static AParser *aparser=NULL ;

void CDisplayGTK::parseCB()
{
  if (!aparser) {
    aparser = new AParser(&API) ;
  }
  if (state.m_diskSynchonized) {
    aparser->Destroy() ;
    int res = aparser->Parse(m_editor.getFilename()) ;
    if (res) {
      setSensitivity(PARSED) ;
    } else {
      if (m_messageDLG) delete m_messageDLG ;
      m_messageDLG = new CMessageGTK(this,"Message","The script contains errors.") ;
      m_messageDLG->create() ;
      m_messageDLG->show() ;
    }
  } else {
    if (m_messageDLG) delete m_messageDLG ;
    m_messageDLG = new CMessageGTK(this,"Message","The script must be saved before parsing.") ;
    m_messageDLG->create() ;
    m_messageDLG->show() ;
  }
}

void CDisplayGTK::evalmainCB()
{
  if (aparser) {
    int res = aparser->Eval("main") ;
    if (!res) {
      if (m_messageDLG) delete m_messageDLG ;
      m_messageDLG = new CMessageGTK(this,"Message","Evaluation failed.") ;
      m_messageDLG->create() ;
      m_messageDLG->show() ;
    } 
  } else {
    if (m_messageDLG) delete m_messageDLG ;
    m_messageDLG = new CMessageGTK(this,"Message","The script must be parsed before evaluation") ;
    m_messageDLG->create() ;
    m_messageDLG->show() ;
  }
}

void CDisplayGTK::connectCB()
{
  if (m_connectDLG) delete m_connectDLG; 
  m_connectDLG = new CConnectGTK(this,(GTKFncPtr)&CDisplayGTK::connectOK) ;
  m_connectDLG->create() ;
  m_connectDLG->show() ;
}

void CDisplayGTK::disconnectCB()
{
  m_backend.disconnect() ;
  disconnected() ;
}

void CDisplayGTK::connectOK()
{
  m_ConDsp.start_timer() ;
  start_timer() ;
  setSensitivity(CONNECTED) ;
}

void CDisplayGTK::disconnected()
{
  m_ConDsp.stop_timer() ;
  stop_timer() ;
  setSensitivity(DISCONNECTED) ;
}

void CDisplayGTK::saveCB()
{
  if (m_editor.save()) {
    setSensitivity(DISK_SYNCHRONIZED) ;
  }
}

void CDisplayGTK::saveAsOK()
{
  m_editor.setFilename(m_FileDialogWindow->getFileName()) ; 
  if (m_editor.save()) {
    setSensitivity(DISK_SYNCHRONIZED) ;
  }
}

void CDisplayGTK::saveasCB()
{
  if (m_FileDialogWindow) delete m_FileDialogWindow ;
  m_FileDialogWindow = new CFileDialogGTK(this,(GTKFncPtr)&CDisplayGTK::saveAsOK) ;
  m_FileDialogWindow->create() ;
  m_FileDialogWindow->show() ;
}

void CDisplayGTK::openOK()
{
  m_editor.setFilename(m_FileDialogWindow->getFileName()) ; 
  if (m_editor.readfile()) {
    setSensitivity(DISK_SYNCHRONIZED) ;
  }
}

void CDisplayGTK::openOK2()
{
  if (m_FileDialogWindow) delete m_FileDialogWindow ;
  m_FileDialogWindow = new CFileDialogGTK(this,(GTKFncPtr)&CDisplayGTK::openOK) ;
  m_FileDialogWindow->create() ;
  m_FileDialogWindow->show() ;
}

void CDisplayGTK::openCB()
{
  if (state.m_modified) {
    if (m_messageDLG) delete m_messageDLG ;
    m_messageDLG = new CMessageGTK(this,"Query","Script modified, press OK to discard.",(GTKFncPtr)&CDisplayGTK::openOK2) ;
    m_messageDLG->create() ;
    m_messageDLG->show() ;
  } else {
    openOK2() ;
  }
}

void CDisplayGTK::getMainMenu( GtkWidget  *window, GtkWidget **menubar )
{
  GtkAccelGroup *accel_group;
  gint nmenu_items = sizeof (m_menu_items) / sizeof (m_menu_items[0]);

  accel_group = gtk_accel_group_new ();
  m_item_factory = gtk_item_factory_new (GTK_TYPE_MENU_BAR, "<main>",
				       accel_group);
  gtk_item_factory_create_items (m_item_factory, nmenu_items, m_menu_items, NULL);

  /* Attach the new accelerator group to the window. */
  gtk_window_add_accel_group (GTK_WINDOW (window), accel_group);

  if (menubar)
    /* Finally, return the actual menu bar created by the item factory. */
    *menubar = gtk_item_factory_get_widget (m_item_factory, "<main>");
}

void CDisplayGTK::scriptModified() {
  setSensitivity(MODIFIED) ;
}

void CDisplayGTK::setSensitivity(SENSITIVITY s) {
  switch (s) {
  case DISK_SYNCHRONIZED:
    state.m_diskSynchonized = true ;
    state.m_modified = false ;
    state.m_emptyed = false ;
    break ;
  case MODIFIED:
    state.m_modified = true ;
    state.m_diskSynchonized = false ;
    state.m_parsed = false ;
    //state.m_emptyed = false ;
    break ;
  case CONNECTED:
    state.m_connected = true ;
    break ;
  case DISCONNECTED:
    state.m_connected = false ;
    break ;
  case PARSED:
    state.m_parsed = true ;
    break ;
  case EMPTYED:
    state.m_diskSynchonized = false ;
    state.m_modified = false ;
    state.m_parsed = false ;
    state.m_emptyed = true ;
    break ;
  }
  updateMenuSensitivity() ;
}

void CDisplayGTK::updateMenuSensitivity() {
  if (state.m_emptyed) {
    gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/File/Save"),false);
    gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/File/Parse..."),false);
    if (!state.m_modified) {
      gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/File/Save As"),false);
      char newtitle[100] ;
      strcpy(&newtitle[0],"LSMearth") ;
      gtk_window_set_title (GTK_WINDOW(m_window), &newtitle[0]) ;
    } else {
      gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/File/Save As"),true);
      char newtitle[100] ;
      strcpy(&newtitle[0],"LSMearth (*) ") ;
      gtk_window_set_title (GTK_WINDOW(m_window), &newtitle[0]) ;
    }
  } else {
    gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/File/Save As"),true);
    if (state.m_diskSynchonized) {
      gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/File/Save"),false);
      gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/File/Parse..."),true);
      char newtitle[100] ;
      strcpy(&newtitle[0],"LSMearth - ") ;
      if (m_editor.getFilename()) {
	strcat(&newtitle[0],m_editor.getFilename()) ;
      }
      gtk_window_set_title (GTK_WINDOW(m_window), &newtitle[0]) ;
    } else {
      gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/File/Save"),true);
      gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/File/Parse..."),false);
      char newtitle[100] ;
      strcpy(&newtitle[0],"LSMearth - ") ;
      if (m_editor.getFilename()) {
	strcat(&newtitle[0],m_editor.getFilename()) ;
      }
      strcat(&newtitle[0]," (*)");
      gtk_window_set_title (GTK_WINDOW(m_window), &newtitle[0]) ;
    }
  }
  if (state.m_connected) {
    gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/Back-end/Connect..."),false);
    gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/Back-end/Disconnect"),true);
    gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/Back-end/Ping"),true);
    gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/Back-end/Shutdown"),true);
    gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/Back-end/Simulation Start"),true);
    gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/Back-end/Simulation Pause"),true);
    if (state.m_diskSynchonized) {
      gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/File/Remote execute main()"),true);
    } else {
      gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/File/Remote execute main()"),false);
    }
  } else {
    gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/Back-end/Connect..."),true);
    gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/Back-end/Disconnect"),false);
    gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/Back-end/Ping"),false);
    gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/Back-end/Shutdown"),false);
    gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/File/Remote execute main()"),false);
    gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/Back-end/Simulation Start"),false);
    gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/Back-end/Simulation Pause"),false);
  }
  if (state.m_parsed) {
    gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/File/Run main()"),true);
  } else {
    gtk_widget_set_sensitive(gtk_item_factory_get_widget(m_item_factory, "<main>/File/Run main()"),false);
  }
}

int CDisplayGTK::exec() {
  show();
  m_ConDsp.UpdateCon() ;

  gtk_main();
  return(0);
}

void CDisplayGTK::start_timer() {
  m_tag = gtk_timeout_add(100,&CDisplayGTK::signalCB_iv,call(&CDisplayGTK::timeoutCB)) ;
}

void CDisplayGTK::stop_timer() {
  if (m_tag) gtk_timeout_remove(m_tag);
}

void CDisplayGTK::timeoutCB() {
  sock->msgloop() ;
  if ((!sock->client()) || (!sock->client()->connected())) {
    //if (m_messageDLG) delete m_messageDLG ;
    disconnected() ;
    //m_messageDLG = new CMessageGTK(this,"Info","You have been disconnected") ;
    //m_messageDLG->create() ;
    //m_messageDLG->show() ;
  }
}

#define MAXFILESIZE 65536
void CDisplayGTK::remoteEvalCB() {
  char buffer[MAXFILESIZE];
  int nchars;
  FILE *infile ;

  console.Debug() << "Performing a remote evaluation...\n" ;
  sock->sendTag("EVL") ;
  sock->waitFor("WAT") ;

  console.Debug() << "Reading script...\n" ;

  infile = fopen(m_editor.getFilename(), "r");
  nchars = fread(buffer, 1, MAXFILESIZE, infile);
  fclose (infile);
  buffer[nchars] = '\0' ;
  console.Debug() << "Sending script...\n" ;
  CShakePacket Script(&buffer[0],nchars+1,"LSM") ;
  sock->client()->send(Script) ;
  console.Debug() << "Done sending script.\n" ;
}
