#include "GtkFieldWindow.h"

CFieldWindowGTK::CFieldWindowGTK(CRendererGTK* parent)
{
  m_parent=parent;
  m_nbrow = 0 ;
}

CFieldWindowGTK::~CFieldWindowGTK()
{
  m_parent->FieldWindowHasClosed();
  destroy();
}
  
void CFieldWindowGTK::close() 
{
  m_parent->FieldWindowHasClosed();
  destroy();
}

/*!
  Create the Window and connect signals to callbacks. The initialization, layout... is generated with glade. 
*/
void CFieldWindowGTK::create() 
{
  // -- glade-generated initalization code --

  GtkWidget *window1;
  GtkWidget *hbox1;
  GtkWidget *scrolledwindow1;
  GtkWidget *activelabel;
  GtkWidget *vbox1;
  GtkWidget *editbutton;
  GtkWidget *hseparator1;
  GtkWidget *okbutton;
  GtkWidget *applybutton;
  GtkWidget *cancelbutton;
  GtkWidget *scrolledwindow2;
  GtkWidget *availlabel;

  window1 = gtk_window_new (GTK_WINDOW_TOPLEVEL);

  m_window=window1;

  gtk_object_set_data (GTK_OBJECT (window1), "window1", window1);
  gtk_widget_set_uposition (window1, 500, 350);
  gtk_window_set_title (GTK_WINDOW (window1), "Fields");
  gtk_window_set_default_size (GTK_WINDOW (window1), 500, 350);
  gtk_window_set_policy (GTK_WINDOW (window1), FALSE, FALSE, FALSE);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (window1), hbox1);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "scrolledwindow1", scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (hbox1), scrolledwindow1, TRUE, TRUE, 5);

  m_activelist = gtk_clist_new (1);
  gtk_widget_ref (m_activelist);
  gtk_object_set_data_full (GTK_OBJECT (window1), "m_activelist", m_activelist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (m_activelist);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), m_activelist);
  gtk_widget_set_usize (m_activelist, 160, -2);
  gtk_container_set_border_width (GTK_CONTAINER (m_activelist), 5);
  gtk_clist_set_column_width (GTK_CLIST (m_activelist), 0, 80);
  gtk_clist_column_titles_show (GTK_CLIST (m_activelist));
  gtk_clist_set_shadow_type (GTK_CLIST (m_activelist), GTK_SHADOW_ETCHED_IN);

  activelabel = gtk_label_new ("Active Fields");
  gtk_widget_ref (activelabel);
  gtk_object_set_data_full (GTK_OBJECT (window1), "activelabel", activelabel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (activelabel);
  gtk_clist_set_column_widget (GTK_CLIST (m_activelist), 0, activelabel);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_box_pack_start (GTK_BOX (hbox1), vbox1, FALSE, FALSE, 10);

  m_addbutton = gtk_button_new_with_label ("Add");
  gtk_widget_ref (m_addbutton);
  gtk_object_set_data_full (GTK_OBJECT (window1), "m_addbutton", m_addbutton,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (m_addbutton);
  gtk_box_pack_start (GTK_BOX (vbox1), m_addbutton, TRUE, FALSE, 10);
  gtk_widget_set_sensitive(m_addbutton,false);

  m_removebutton = gtk_button_new_with_label ("Remove");
  gtk_widget_ref (m_removebutton);
  gtk_object_set_data_full (GTK_OBJECT (window1), "m_removebutton", m_removebutton,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (m_removebutton);
  gtk_box_pack_start (GTK_BOX (vbox1), m_removebutton, TRUE, FALSE, 10);
  gtk_widget_set_sensitive(m_removebutton,false);

  editbutton = gtk_button_new_with_label ("Edit");
  gtk_widget_ref (editbutton);
  gtk_object_set_data_full (GTK_OBJECT (window1), "editbutton", editbutton,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (editbutton);
  gtk_box_pack_start (GTK_BOX (vbox1), editbutton, TRUE, FALSE, 10);

  hseparator1 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "hseparator1", hseparator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator1);
  gtk_box_pack_start (GTK_BOX (vbox1), hseparator1, TRUE, TRUE, 20);

  okbutton = gtk_button_new_with_label ("Ok");
  gtk_widget_ref (okbutton);
  gtk_object_set_data_full (GTK_OBJECT (window1), "okbutton", okbutton,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (okbutton);
  gtk_box_pack_start (GTK_BOX (vbox1), okbutton, TRUE, FALSE, 10);

  applybutton = gtk_button_new_with_label ("Apply");
  gtk_widget_ref (applybutton);
  gtk_object_set_data_full (GTK_OBJECT (window1), "applybutton", applybutton,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (applybutton);
  gtk_box_pack_start (GTK_BOX (vbox1), applybutton, TRUE, FALSE, 10);

  cancelbutton = gtk_button_new_with_label ("Cancel");
  gtk_widget_ref (cancelbutton);
  gtk_object_set_data_full (GTK_OBJECT (window1), "cancelbutton", cancelbutton,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cancelbutton);
  gtk_box_pack_start (GTK_BOX (vbox1), cancelbutton, TRUE, FALSE, 10);

  scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow2);
  gtk_object_set_data_full (GTK_OBJECT (window1), "scrolledwindow2", scrolledwindow2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow2);
  gtk_box_pack_start (GTK_BOX (hbox1), scrolledwindow2, TRUE, TRUE, 5);

  m_availlist = gtk_clist_new (1);
  gtk_widget_ref (m_availlist);
  gtk_object_set_data_full (GTK_OBJECT (window1), "m_availlist", m_availlist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (m_availlist);
  gtk_container_add (GTK_CONTAINER (scrolledwindow2), m_availlist);
  gtk_widget_set_usize (m_availlist, 160, -2);
  gtk_container_set_border_width (GTK_CONTAINER (m_availlist), 5);
  gtk_clist_set_column_width (GTK_CLIST (m_availlist), 0, 80);
  gtk_clist_column_titles_show (GTK_CLIST (m_availlist));
  gtk_clist_set_shadow_type (GTK_CLIST (m_availlist), GTK_SHADOW_ETCHED_IN);

  availlabel = gtk_label_new ("Available Fields");
  gtk_widget_ref (availlabel);
  gtk_object_set_data_full (GTK_OBJECT (window1), "availlabel", availlabel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (availlabel);
  gtk_clist_set_column_widget (GTK_CLIST (m_availlist), 0, availlabel);

  // -- connect signals to callbacks --
  
  gtk_signal_connect (GTK_OBJECT (okbutton),"clicked",
		      GTK_SIGNAL_FUNC (&CFieldWindowGTK::signalCB_vv),
		      call(&CFieldWindowGTK::okCB));

  gtk_signal_connect (GTK_OBJECT (m_addbutton),"clicked",
		      GTK_SIGNAL_FUNC (&CFieldWindowGTK::signalCB_vv),
		      call(&CFieldWindowGTK::addCB));

  gtk_signal_connect (GTK_OBJECT (m_removebutton),"clicked",
		      GTK_SIGNAL_FUNC (&CFieldWindowGTK::signalCB_vv),
		      call(&CFieldWindowGTK::removeCB));

  gtk_signal_connect (GTK_OBJECT (editbutton),"clicked",
		      GTK_SIGNAL_FUNC (&CFieldWindowGTK::signalCB_vv),
		      call(&CFieldWindowGTK::editCB));

  gtk_signal_connect (GTK_OBJECT (applybutton),"clicked",
		      GTK_SIGNAL_FUNC (&CFieldWindowGTK::signalCB_vv),
		      call(&CFieldWindowGTK::applyCB));

  gtk_signal_connect (GTK_OBJECT (cancelbutton),"clicked",
		      GTK_SIGNAL_FUNC (&CFieldWindowGTK::signalCB_vv),
		      call(&CFieldWindowGTK::closeCB));

  gtk_signal_connect (GTK_OBJECT (m_availlist), "select-row",
		      (GtkSignalFunc)(&CFieldWindowGTK::signalCB_lst),
		      call(&CFieldWindowGTK::selectAvRowCB)) ;

 gtk_signal_connect (GTK_OBJECT (m_activelist), "select-row",
		      (GtkSignalFunc)(&CFieldWindowGTK::signalCB_lst),
		      call(&CFieldWindowGTK::selectAcRowCB)) ;

  // -- get the field names --
  int nfields=m_parent->m_remoteData.getNbFields();
  char *text[1];
  gtk_clist_freeze(GTK_CLIST (m_availlist));
  for (int i=0;i<nfields;i++){
    CFieldDescription fd=m_parent->m_remoteData.getFieldDecription(i);

    int slen=strlen(fd.getName().c_str())+1;
    gchar *name=new gchar[slen];
    strcpy(name,fd.getName().c_str());
    text[0]=name;
    gtk_clist_append(GTK_CLIST (m_availlist),text) ;
  }
  gtk_clist_thaw(GTK_CLIST (m_availlist));
} 

// -- callbacks --

void CFieldWindowGTK::closeCB()
{
  console.XDebug() << "CFieldWindowGTK::closeCB()\n";
  close();
}

void CFieldWindowGTK::applyCB()
{
  console.XDebug() << "CFieldWindowGTK::applyCB()\n";
  
  char *name[1];
  
  for (int i=0; i<m_nbrow; i++) {
    gtk_clist_get_text (GTK_CLIST (m_activelist), i, 0, &name[0]);
    console.XDebug() << "apply : " << name[0] << "\n";
    m_parent->m_remoteData.activateField(string(name[0]));
  }
  m_parent->update_fields();
  m_parent->update_view();
}

void CFieldWindowGTK::okCB()
{
  console.XDebug() << "CFieldWindowGTK::okCB()\n";
  applyCB();
  close();
}

void CFieldWindowGTK::editCB()
{
  console.XDebug() << "CFieldWindowGTK::editCB()\n";
}

/*!
  Add the field selected in the available list to active list
*/
void CFieldWindowGTK::addCB()
{
  char *name[1],*test;
  bool same,insert;

  console.XDebug() << "CFieldWindowGTK::addCB()\n";
  
  gtk_clist_freeze(GTK_CLIST (m_activelist));
  // get the text from the selected field
  gtk_clist_get_text (GTK_CLIST (m_availlist), m_rowsel_av, 0, &name[0]);
  insert = true ;
  for (int i=0; i<m_nbrow; i++) {
    gtk_clist_get_text (GTK_CLIST (m_activelist), i, 0, &test);
    same = (!strcmp(test,name[0])) ;
    if (same) insert=false;
  }

  if(insert){
    gtk_clist_append(GTK_CLIST (m_activelist),name) ;
    m_nbrow++;
  }

  gtk_clist_thaw(GTK_CLIST (m_activelist));

}

/*!
  Remove field from active list
*/
void CFieldWindowGTK::removeCB()
{
  console.XDebug() << "CFieldWindowGTK::removeCB()\n";
  char *name[1];

  gtk_clist_get_text (GTK_CLIST (m_activelist), m_rowsel_ac, 0, &name[0]);
  m_parent->m_remoteData.deleteField(string(name[0]));
  gtk_clist_remove(GTK_CLIST (m_activelist),m_rowsel_ac);
  gtk_widget_set_sensitive(m_removebutton,false);
  m_nbrow--;
}

void CFieldWindowGTK::selectAvRowCB() {
  m_rowsel_av = (gint)(getCBargv(1)) ;
  gtk_widget_set_sensitive(m_addbutton,true);
}

void CFieldWindowGTK::selectAcRowCB() {
  m_rowsel_ac = (gint)(getCBargv(1)) ;
  gtk_widget_set_sensitive(m_removebutton,true);
}
