#ifndef __GTKFIELDWINDOW_H
#define __GTKFIELDWINDOW_H

// -- project includes --
#include "remoteConsole.h"
#include "GtkPackage.h"
#include "GtkCWindow.h"
#include "GtkRenderer.h"

// -- GTK includes --
#include <gtk/gtk.h>

/*!
  \class CFieldWindowGTK
  \brief Field selection dialog

  \author Steffen Abe
  $Revision$
  $Date$
*/
class CFieldWindowGTK : public CWindowGTK, public TPackageGTK<CFieldWindowGTK>
{
private:
  CRendererGTK *m_parent;
  GtkWidget *m_activelist;
  GtkWidget *m_availlist;
  GtkWidget *m_addbutton;
  GtkWidget *m_removebutton;
  
 
  int m_rowsel_av,m_nbrow,m_rowsel_ac;

protected:
  void closeCB();
  void applyCB();
  void okCB();
  void editCB();
  void addCB();
  void removeCB();
  void selectAvRowCB();
  void selectAcRowCB();

public:
  CFieldWindowGTK(CRendererGTK* parent);
  ~CFieldWindowGTK();
  
  virtual void close() ;

  virtual void create() ; 
};

#endif // __GTKFIELDWINDOW_H
