#include "GtkFileDialog.h"

CFileDialogGTK::~CFileDialogGTK()  {
  if (m_filename) delete m_filename ;
}

CFileDialogGTK::CFileDialogGTK(CWindowGTK *parent, GTKFncPtr ptr) : CWindowGTK(), TPackageGTK<CFileDialogGTK>()  {
  m_parent = parent ;
  m_filename = NULL ;
  m_ptr = ptr ;
}

char *CFileDialogGTK::getFileName() {
  return m_filename ;
}

void CFileDialogGTK::create() {
  GtkWidget *m_filew;

  m_filew = gtk_file_selection_new ("File selection");
                        
  //gtk_signal_connect (GTK_OBJECT (filew), "destroy", (GtkSignalFunc) gtk_widget_destroy, &filew);
  /* Connect the ok_button to file_ok_sel function */
  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (m_filew)->ok_button),"clicked", 
		      (GtkSignalFunc)(&CFileDialogGTK::signalCB_vv), call(&CFileDialogGTK::fileOKCB)) ;

  gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (m_filew)->cancel_button), "clicked", 
			     (GtkSignalFunc) gtk_widget_destroy, GTK_OBJECT (m_filew));
                        
  gtk_file_selection_set_filename (GTK_FILE_SELECTION(m_filew),"script.lsm");
  gtk_window_set_modal            (GTK_WINDOW(m_filew),true) ;
  gtk_window_set_position (GTK_WINDOW (m_filew), GTK_WIN_POS_MOUSE);

  m_window = m_filew ;
}

void CFileDialogGTK::fileOKCB()
{
  char *filename ;

  filename = gtk_file_selection_get_filename (GTK_FILE_SELECTION (m_window));
  if (m_filename) {
    delete m_filename ;
  }
  m_filename = new char[strlen(filename)+1] ;
  strcpy(m_filename,filename) ;
  destroy() ;
  (m_parent->*m_ptr)() ;
}

