#include "GtkMessage.h"
#define _(e1) e1

CMessageGTK::~CMessageGTK()  {
}

CMessageGTK::CMessageGTK(CWindowGTK *parent, char *type,char *msg,GTKFncPtr ptrOK,GTKFncPtr ptrCANCEL) : CWindowGTK(), TPackageGTK<CMessageGTK>()  {
  m_parent = parent ;
  m_ptrOK = ptrOK ;
  m_ptrCANCEL = ptrCANCEL ;
  m_message = msg ;
  m_type = type ;
}

void CMessageGTK::okCB() {
  if (m_ptrOK) {
    (m_parent->*m_ptrOK)() ;
  } 
  gtk_widget_destroy(GTK_WIDGET(m_window)) ;
}

void CMessageGTK::cancelCB() {
  if (m_ptrCANCEL) {
    (m_parent->*m_ptrCANCEL)() ;
  } 
  gtk_widget_destroy(GTK_WIDGET(m_window)) ;
}

void CMessageGTK::create() {
  GtkWidget *window1;
  GtkWidget *vbox1;
  GtkWidget *frame1;
  GtkWidget *vbox2;
  GtkWidget *label3;
  GtkWidget *hseparator1;
  GtkWidget *hbuttonbox1;
  GtkWidget *button2;
  GtkWidget *button3;

  window1 = gtk_window_new (GTK_WINDOW_DIALOG); 
  m_window = window1 ;
  gtk_object_set_data (GTK_OBJECT (window1), "window1", window1);
  gtk_window_set_title (GTK_WINDOW (window1), _("LSM"));
  gtk_window_set_position (GTK_WINDOW (window1), GTK_WIN_POS_MOUSE);
  gtk_window_set_modal (GTK_WINDOW (window1), TRUE);
  gtk_window_set_policy (GTK_WINDOW (window1), FALSE, TRUE, TRUE);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (window1), vbox1);

  frame1 = gtk_frame_new (_(m_type));
  gtk_widget_ref (frame1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "frame1", frame1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (vbox1), frame1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame1), 10);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox2);
  gtk_object_set_data_full (GTK_OBJECT (window1), "vbox2", vbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (frame1), vbox2);
  gtk_container_set_border_width (GTK_CONTAINER (vbox2), 7);

  label3 = gtk_label_new (_(m_message));
  gtk_widget_ref (label3);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label3", label3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label3);
  gtk_box_pack_start (GTK_BOX (vbox2), label3, FALSE, FALSE, 0);
  gtk_label_set_line_wrap (GTK_LABEL (label3), TRUE);

  hseparator1 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "hseparator1", hseparator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator1);
  gtk_box_pack_start (GTK_BOX (vbox1), hseparator1, TRUE, TRUE, 0);

  hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "hbuttonbox1", hbuttonbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbuttonbox1, FALSE, TRUE, 3);
  gtk_container_set_border_width (GTK_CONTAINER (hbuttonbox1), 2);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox1), GTK_BUTTONBOX_SPREAD);
  gtk_button_box_set_child_size (GTK_BUTTON_BOX (hbuttonbox1), 85, 42);

  button2 = gtk_button_new_with_label (_("OK"));
  gtk_widget_ref (button2);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button2", button2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button2);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), button2);
  gtk_widget_set_usize (button2, -2, 33);
  GTK_WIDGET_SET_FLAGS (button2, GTK_CAN_DEFAULT);

  button3 = gtk_button_new_with_label (_("Cancel"));
  gtk_widget_ref (button3);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button3", button3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button3);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), button3);
  gtk_widget_set_usize (button3, -2, 33);
  GTK_WIDGET_SET_FLAGS (button3, GTK_CAN_DEFAULT);
  gtk_window_set_modal(GTK_WINDOW(m_window),true) ;
  gtk_signal_connect_after (GTK_OBJECT (button2), "clicked",(GtkSignalFunc)(&CMessageGTK::signalCB_vv), call(&CMessageGTK::okCB));
  gtk_signal_connect_after (GTK_OBJECT (button3), "clicked",(GtkSignalFunc)(&CMessageGTK::signalCB_vv), call(&CMessageGTK::cancelCB));
}

