#ifndef _GTKPACKAGE_H
#define _GTKPACKAGE_H

// -- GTK includes --
#include <gtk/gtk.h>

// --- STL includes ---
#include <map>
#include <utility>

using std::map;
using std::make_pair;

/*!
  \class TPackageGTK
  \brief Some basic functions to use Gtk with OO windows 

  \author David Place
  $Revision$
  $Date$
*/

template<class T>
class TPackageGTK {
private:
  struct callback {
    void (T::*ptr)() ;
    void *data ;
    void **args; 
    int narg ;
    T *self ;
  } ;

  static void processCallBack(callback * CB) ;

  static map<guint,callback> m_callback_map;
  static guint m_max_index;

protected:
  int m_CBargc ;
  void **m_CBargv ;


  static void signalCB_vvv(GtkWidget *w, GdkEvent *event, gpointer data) ;
  static void signalCB_vv(GtkWidget *w, gpointer data) ;
  static void signalCB_v(gpointer data) ;
  static gint signalCB_iv(gpointer data) ;
  static void signalCB_lst(GtkCList *w, gint row, gint column, GdkEventButton *event, gpointer user_data) ;

  static void menuCB_vv(GtkWidget *w, guint data) ;

  void * getCBargv(int n) ;
  int getCBargc() ;
  void setCBArgs(int n, void **arg) ;

  guint call_int(void (T::*call)(), void* data=NULL) ; 
  void* call(void (T::*call)(), void* data=NULL) ;

public:
  TPackageGTK<T>() ;
} ;

#include "GtkPackage.hpp" 

#endif 

