template<class T>
guint TPackageGTK<T>::m_max_index=0;

template<class T>
map<guint,typename TPackageGTK<T>::callback> TPackageGTK<T>::m_callback_map;

template<class T>
void TPackageGTK<T>::signalCB_vv(GtkWidget *w, gpointer data) 
{
  callback * CB = (callback *)(data) ;
  if (!CB) {
    console.Error()<< "Callback not defined...\n" ;
  } else {
    CB->args = new void *[2] ;
    CB->narg = 2 ;
    CB->args[0] = (void *)(w) ;
    CB->args[1] = (void *)(CB->data) ;
  }
  processCallBack(CB) ;
} 

template<class T>
void TPackageGTK<T>::menuCB_vv(GtkWidget *w, guint data) 
{
  callback CB = m_callback_map[data];
 
  CB.args=new void *[2] ;
  CB.narg = 2 ;
  CB.args[0] = (void *)(w) ;
  CB.args[1] = (void *)(CB.data) ;
 
  processCallBack(&CB) ;
}

template<class T>
void TPackageGTK<T>::signalCB_vvv(GtkWidget *w, GdkEvent *event, gpointer data) {
    callback * CB = (callback *)(data) ;
    if (!CB) {
      console.Error()<< "Callback not defined...\n" ;
    } else {
      CB->args = new void *[3] ;
      CB->narg = 3 ;
      CB->args[0] = (void *)(w) ;
      CB->args[1] = (void *)(event) ;
      CB->args[2] = (void *)(CB->data) ;
    }
    processCallBack(CB) ;
} 

template<class T>
void TPackageGTK<T>::signalCB_lst(GtkCList *w, gint row, gint column, GdkEventButton *event, gpointer data) {
    callback * CB = (callback *)(data) ;
    if (!CB) {
      console.Error()<< "Callback not defined...\n" ;
    } else {
      CB->args = new void *[5] ;
      CB->narg = 5 ;
      CB->args[0] = (void *)(w) ;
      CB->args[1] = (void *)(row) ;
      CB->args[2] = (void *)(column) ;
      CB->args[3] = (void *)(event) ;
      CB->args[4] = (void *)(CB->data) ;
    }
    processCallBack(CB) ;
} 

template<class T>
void TPackageGTK<T>::signalCB_v(gpointer data) {
    callback * CB = (callback *)(data) ;
    if (!CB) {
      console.Error()<< "Callback not defined...\n" ;
    } else {
      CB->args = new void *[1] ;
      CB->narg = 1 ;
      CB->args[0] = (void *)(CB->data) ;
    }
    processCallBack(CB) ;
} 

template<class T>
gint TPackageGTK<T>::signalCB_iv(gpointer data) {
    callback * CB = (callback *)(data) ;
    if (!CB) {
      console.Error()<< "Callback not defined...\n" ;
    } else {
      CB->args = new void *[1] ;
      CB->narg = 1 ;
      CB->args[0] = (void *)(CB->data) ;
    }
    processCallBack(CB) ;
    return 1 ;
} 

template<class T>
void TPackageGTK<T>::processCallBack(callback * CB) {
    if (!CB) {
      console.Error()<< "Callback not defined...\n" ;
    } else {
      CB->self->setCBArgs(CB->narg,CB->args) ;
      (CB->self->*CB->ptr)() ;
      delete CB->args ;
    }
}

template<class T>
void TPackageGTK<T>::setCBArgs(int n, void **arg) {
  m_CBargc = n ;
  m_CBargv = arg ;
}

template<class T>
void * TPackageGTK<T>::getCBargv(int n) {
  return m_CBargv[n] ;
}

template<class T>
int TPackageGTK<T>::getCBargc() {
  return m_CBargc ;
}

template<class T>
guint TPackageGTK<T>::call_int(void (T::*call)(), void * data) 
{
  m_max_index++;
  guint idx=m_max_index;
  
  callback CB;

  CB.self = (T*) this ;
  CB.ptr = call ;
  CB.data = data ;
  m_callback_map.insert(make_pair(idx,CB));

  return idx;
}

template<class T>
void * TPackageGTK<T>::call(void (T::*call)(), void * data) {
    callback * CB = new callback ;
    CB->self = (T*) this ;
    CB->ptr = call ;
    CB->data = data ;
    return (void *)CB ;
}


template<class T>
TPackageGTK<T>::TPackageGTK() {
} 

