#ifndef _GTKRENDERER_H
#define _GTKRENDERER_H

// -- project includes --
#include "remoteConsole.h"
#include "GtkPackage.h"
#include "GtkCWindow.h"
#include "GtkDisplay.h"
#include "ShakeView.h"
#include "GtkFieldWindow.h"

class CFieldWindowGTK;

// -- GTK includes --
#include <gtk/gtk.h>

/*!
  \class CRendererGTK
  \brief Gtk interface to ShakeRenderer

  \author David Place, Steffen Abe
  $Revision$
  $Date$
*/
class CRendererGTK : public CShakeView, public CWindowGTK, public TPackageGTK<CRendererGTK>
{
 private:
  void get_main_menu( GtkWidget  *window, GtkWidget **menubar) ;
  GtkWidget *m_glarea ;
  int m_button,m_mx,m_my,m_lastx,m_lasty,m_rotationType ;
  bool m_autoUpdate ;
  guint m_tag ;
  CFieldWindowGTK *m_fieldWindow;

 protected:
  GtkItemFactory *m_item_factory;
  static GtkItemFactoryEntry m_menu_items[] ;
  enum {BTN_RELEASE=1,BTN_PRESS,MOUSE_MOVE} ;
  enum {ROTZX=1,ROTZY} ;

  virtual void repaint() ;

  void quitOK() ;
  void initCB() ;
  void drawCB() ;
  void closeCB();
  void reshapeCB() ;
  void inputCB() ;
  void vscaleCB() ;
  void printPSCB() ;

  void updateCB() ;
  void autoupdateCB() ;
  void field_selectCB();
  void timeoutCB() ;

public:
  CRendererGTK(CDisplayGTK *parent, int Id) ;
  ~CRendererGTK() ;

  virtual void close() ;
  virtual void create() ; 
  void FieldWindowHasClosed(){m_fieldWindow=NULL;};

  friend class CFieldWindowGTK;

} ;

#endif
