#include "stdafx.h"
#include "GtkScriptEditor.h"
#include "GtkDisplay.h"

/***************************************************************************************/
/* Class CDisplayEditorGTK                                                             */
/*                                                                                     */
/*                                                                                     */
/***************************************************************************************/

bool CDisplayEditorGTK::readfile() {
  FILE *infile ;

  infile = fopen(m_filename, "r");
                      
  if (infile) {
    char buffer[1024];
    int nchars;

    GdkFont *fixed_font = gdk_font_load ("-adobe-helvetica-medium-r-normal-*-*-120-*-*-p-*-iso8859-1");
    gtk_text_freeze(GTK_TEXT (m_ScriptText)) ;

    guint len = gtk_text_get_length(GTK_TEXT (m_ScriptText)) ;
    if (len >0) {
      gtk_text_set_point (GTK_TEXT (m_ScriptText),len) ;
      gtk_text_backward_delete(GTK_TEXT (m_ScriptText),len) ;
    }
                        
    while (1)
      {
	nchars = fread(buffer, 1, 1024, infile);
	gtk_text_insert (GTK_TEXT (m_ScriptText), fixed_font, NULL, NULL, buffer, nchars);
                            
	if (nchars < 1024)
	  break;
      }
                        
    fclose (infile);
    gtk_text_thaw (GTK_TEXT (m_ScriptText));
    m_modified = false ;
    return true ;
  } else {
    console.Error() << "Cannot open file " << m_filename << "\n" ; 
  }
  return false; 
}

void CDisplayEditorGTK::modifiedCB() {
  m_modified = true ;
  m_mainwindow->scriptModified() ;
}

void CDisplayEditorGTK::renew() {
  gtk_text_freeze(GTK_TEXT (m_ScriptText)) ;
  
  guint len = gtk_text_get_length(GTK_TEXT (m_ScriptText)) ;
  if (len >0) {
    gtk_text_set_point (GTK_TEXT (m_ScriptText),len) ;
    gtk_text_backward_delete(GTK_TEXT (m_ScriptText),len) ;
  }
  gtk_text_thaw (GTK_TEXT (m_ScriptText));
  m_modified = false ;
}

bool CDisplayEditorGTK::save() {
  if (m_filename) {
    FILE *outfile ;

    outfile = fopen(m_filename, "w");
                      
    if (outfile) {
      guint len = gtk_text_get_length(GTK_TEXT (m_ScriptText)) ;
      char *buffer ;
      guint i ;

      buffer = new char[len+1] ; 
      buffer[len]='\0' ;

      for (i=0; i<len; i++) buffer[i] = (char)(GTK_TEXT_INDEX(GTK_TEXT (m_ScriptText),i)) ;

      fwrite(buffer, 1, len, outfile) ;

      delete buffer ;
      fclose(outfile) ;
      m_modified = false ;
      return true ;
    }
  } 
  return false ;
}

bool CDisplayEditorGTK::isModified() {
  return m_modified ;
}

CDisplayEditorGTK::CDisplayEditorGTK() : TPackageGTK<CDisplayEditorGTK>() {
  m_ScriptText = NULL ;
  m_modified = false ;
  m_filename = NULL ;
}

CDisplayEditorGTK::~CDisplayEditorGTK() {
}
 
void CDisplayEditorGTK::setFilename(char *s) {
  m_filename = s ;
}

char *CDisplayEditorGTK::getFilename() {
  return m_filename ;
}

void CDisplayEditorGTK::create(CDisplayGTK* p,GtkWidget *w) {
  m_mainwindow = p ;
  m_ScriptText = w ;
  gtk_signal_connect (GTK_OBJECT (m_ScriptText), "changed",
		      GTK_SIGNAL_FUNC(&CDisplayEditorGTK::signalCB_vv),call(&CDisplayEditorGTK::modifiedCB)) ;
}


