#include "RDConnectionField.h"
#include "LinearColorMap.h"

int AConnectionField::addConnection(int i,int j)
{
  m_conn.push_back(pair<int,int>(i,j));

  return m_conn.size()-1;
}


CScalarConnectionField::CScalarConnectionField(const string& name):AConnectionField(),
								   AScalarField(name)
{
  setShape(ADataField::FLD_CONN);
  m_colormap=new CLinearColorMap("testcolormap"); // testing
}

CScalarConnectionField::~CScalarConnectionField()
{
  if(m_colormap!=NULL) delete m_colormap;
}


void CScalarConnectionField::draw(CShakeRenderer * rend)
{
  console.XDebug() << "CScalarConnectionField::draw\n";
  
  // check consistency

  // draw 
  for(int i=0;i<m_data.size();i++){
    pair<int,int> idx=m_conn[i];
    Colour c=m_colormap->getColor(m_data[i]);
    rend->addColorToConnection(idx.first,idx.second,c);
  }
}
