#ifndef __RDCONNECTIONFIELD_H
#define __RDCONNECTIONFIELD_H

// -- project includes ---
#include "RDFields.h"

// --- STL includes ---
#include <vector>
#include <utility>

using std::vector;
using std::pair;

/*!
  \class AConnectionField
  \brief abstract class for a field on connections between particles

  \author Steffen Abe
  $Revision$
  $Date$
*/
class AConnectionField
{
protected:
  vector<pair<int,int> > m_conn; //<! mapping the local to the global connection id 

public:
  AConnectionField(){};
  virtual int addConnection(int,int);
};


/*!
  \class CScalarConnectionField
  \brief class for a scalar field on connections between particles

  \author Steffen Abe
  $Revision$
  $Date$
*/
class CScalarConnectionField: public AConnectionField, public AScalarField
{
public:
  CScalarConnectionField(const string&);
  ~CScalarConnectionField();

  virtual void draw(CShakeRenderer *);
};

#endif //__RDCONNECTIONFIELD_H
