#include "RDFields.h"
#include "console.h"

//-------------------------
//  ADataField functions
//-------------------------

ADataField::ADataField(ADataType adt,const string& name) 
{
  m_fieldName=name;
  m_dataType = adt ;
  m_isInitialized=false ;
  m_autoscale=true; // temporary
}

ADataField::~ADataField() 
{}

void ADataField::setName(const string& name) 
{
  m_fieldName = name ;
}

string ADataField::getName() const 
{
  return m_fieldName ;
}

//-------------------------
//  AScalarField functions
//-------------------------

AScalarField::AScalarField(const string& name):ADataField(ADataField::FLD_SCALAR,name)
{}

void AScalarField::clear()
{
  m_data.clear();
}

//-------------------------
//  AVectorField functions
//-------------------------

AVectorField::AVectorField(const string& name):ADataField(ADataField::FLD_VECTOR,name)
{}

void AVectorField::clear()
{
  m_data.clear();
}

void AVectorField::addVector(int i,const Vec3& V)
{
  m_data[i]=V;
}
