#include "RemoteData.h"
#include "console.h"
#include "shake_debug.h"

template<class T>
TDataField<T>::TDataField(ADataType adt) : ADataField(adt) {
}

template<class T>
TDataField<T>::~TDataField() {
  destroy() ;
}

template<class T>
void  TDataField<T>::destroy() {
  if (m_isInitialized) {
    m_data.clear() ;
    m_isInitialized = false ;
  }
  
}

template<class T>
bool TDataField<T>::create(int sizex, int sizey, int sizez) {
  destroy() ;

  if (sizez>1) m_dim=3 ;
  else if (sizey>1) m_dim=2 ;
  else m_dim=1 ;

  m_size[0] = sizex ; 
  m_size[1] = 1 ; 
  m_size[2] = 1 ; 

  m_tsize=sizex ;
  if (m_dim==3) { 
    m_size[2] = sizez ;
    m_tsize *= sizez ; 
  }
  if (m_dim>=2) { 
    m_size[1] = sizey ;
    m_tsize *= sizey ; 
  }

  m_data.reserve(m_tsize) ;
  m_isInitialized = true ;
  return true ;
}

template <class T>
T & TDataField<T>::operator() (int ix,int iy, int iz) {
  return m_data[id(ix,iy,iz)] ;
}  

