#ifndef __SHAKEVIEW_H
#define __SHAKEVIEW_H

//-- project includes --
#include "ShakeRenderer.h"
#include "RemoteData.h"
#include "BackendCom.h"

//-- system includes --

//-- forwar declarations --

class CShakeDisplay;

/*!
  \class CShakeView
  \brief The class CShakeView handles the user interaction with the data vizualization, i.e. in a MVC-architecture it is a "controller" class. It contains the remote data (Model) and a renderer (View)

  \author Steffen Abe
  $Revision$
  $Date$
*/
class CShakeView
{
private:

protected:
  CShakeRenderer *m_renderer;
  CShakeDisplay *m_theDisplay ;
  CRemoteData m_remoteData ;
  CBackEndCom *m_backend ;
  int m_id ;

  void update_view();

public:
  CShakeView(CShakeDisplay *,int);
  virtual ~CShakeView();

  int getId() { return m_id;} ;

  virtual void close()=0;
  virtual void repaint()=0;
  void update_particles();
  void update_fields();
  void printPS(const char*);
};

#endif //__SHAKEVIEW_H
