// NewConsoleView.cpp : implementation file
//

#include "stdafx.h"
#include "LSMearth.h"
#include "NewConsoleView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNewConsoleView

IMPLEMENT_DYNCREATE(CNewConsoleView, CEditView)

//extern CSocketLoop *SockLoop ;

CNewConsoleView::CNewConsoleView() : CEditView(), ARemoteConsoleServer() 
{
   Window=this ;
}

CNewConsoleView::~CNewConsoleView()
{
   Window=NULL ;
}

BEGIN_MESSAGE_MAP(CNewConsoleView, CEditView)
	//{{AFX_MSG_MAP(CNewConsoleView)
	ON_WM_CREATE()
	ON_CONTROL_REFLECT(EN_CHANGE, OnChange)
	ON_WM_CTLCOLOR_REFLECT()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNewConsoleViewST drawing

void CNewConsoleView::OnDraw(CDC*)
{
	//CDocument* pDoc = GetDocument();

	// TODO: add draw code here
}

/////////////////////////////////////////////////////////////////////////////
// CNewConsoleViewST diagnostics

#ifdef _DEBUG
void CNewConsoleView::AssertValid() const
{
	CEditView::AssertValid();
}

void CNewConsoleView::Dump(CDumpContext& dc) const
{
	CEditView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CNewConsoleViewST message handlers

void CNewConsoleView::UpdateCon() 
{   
    char buffer[4096] ;
    
    console.GetLast(&buffer[0]) ;
    
    CString str;
    if (strlen(&buffer[0]) >0) {
        CEdit & Edit =GetEditCtrl() ;
        int len = Edit.GetWindowTextLength();
        if (len >= 16384*2) // limit the buffer to 128k.
        {
            Edit.GetWindowText(str);
            Edit.SetWindowText(str.GetBuffer(len)+4097);
            len -= 4097;
        }
        Edit.SetSel(len,len) ;
        
        str = CString(&buffer[0])/*+CString("\r\n")*/ ;
        Edit.ReplaceSel(str) ;
    }
}

int CNewConsoleView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CEditView::OnCreate(lpCreateStruct) == -1)
		return -1;

	LOGFONT lf; 

	lf.lfHeight = -12 ;
	lf.lfWidth = 0 ;
	lf.lfEscapement = 0 ;
	lf.lfOrientation = 0 ;
	lf.lfWeight = 400 ;
	lf.lfItalic = 0 ;
	lf.lfUnderline = 0 ;
	lf.lfStrikeOut = 0 ;
	lf.lfCharSet = 0 ;
	lf.lfOutPrecision = 3 ;
	lf.lfClipPrecision = 2 ;
	lf.lfQuality = 1 ;
	lf.lfPitchAndFamily = 49 ;
	strcpy((char *)(&(lf.lfFaceName[0])),"Lucida Console"); 

	ConsoleFont.CreateFontIndirect(&lf); 
        m_clrText = RGB( 200, 200, 200 );
        m_clrBkgnd = RGB( 32, 32, 64 );
        m_brBkgnd.CreateSolidBrush( m_clrBkgnd );

    	SetFont(&ConsoleFont);
    SetTimer(ID_CON_TIMER, 100, NULL) ; 	
	return 0;
}

BOOL CNewConsoleView::PreCreateWindow(CREATESTRUCT& cs) 
{
	cs.style |= ES_READONLY | ES_MULTILINE | ES_WANTRETURN | WS_VSCROLL;
	
	return CEditView::PreCreateWindow(cs);
}

void CNewConsoleView::OnChange() 
{
	// Nothing to do here, just avoid to
}

HBRUSH CNewConsoleView::CtlColor(CDC* pDC, UINT /*nCtlColor*/) 
{
        pDC->SetTextColor( m_clrText );    // text
        pDC->SetBkColor( m_clrBkgnd );    // text bkgnd
	return m_brBkgnd ;
}

void CNewConsoleView::OnTimer(UINT nIDEvent) 
{
    switch (nIDEvent) {
    case ID_CON_TIMER :
		Gathering() ;
        // tconsole.Debug() << "Timer rang for Gathering\n" ;
        break ;
    default:
        break ;
    }
    CEditView::OnTimer(nIDEvent);
}
