#include "stdafx.h"
#include <stdlib.h>
#include "SocketServer.h"
#include "remoteConsole.h"
#include "interface.h"
#include "ModelFnc.h"
#include "LatticeMaster.h"
#include "master_main.h"

CBackEndSocketSvc::CBackEndSocketSvc() : CSocketSvc() { 
  n=0; 
  m_run = false ;
} 

void CBackEndSocketSvc::startPauseSim(bool v) {
  m_run = v ;
}

/*!
  Process a TCP/IP packet, return true is the packet has been processed
  \param Packet packet to be processed
 */
bool CBackEndSocketSvc::m_packetSW(CShakePacket &Packet) {
  if (!strcmp(Packet.getType(),"RUN")) {  // End connection (should return an ECK)
    return startSimSW() ;
  } else if (!strcmp(Packet.getType(),"PSE")) { 
    return pauseSimSW() ;
  } else if (!strcmp(Packet.getType(),"GDT")) { 
    return sendParticleDataSW() ;
  } else if (!strcmp(Packet.getType(),"QFT")) { 
    return queryFieldAvailableSW() ;
  } else if (!strcmp(Packet.getType(),"GFD")) { 
    return getFieldDataSW(Packet) ;
  } else {
    return CSocketSvc::m_packetSW(Packet) ;
  }
}

bool CBackEndSocketSvc::queryFieldAvailableSW() {
  return false;//TheLatticeMaster->queryFieldAvailable(this) ;
}

bool CBackEndSocketSvc::sendParticleDataSW() {
  return false;//TheLatticeMaster->sendParticleData(this) ;
}

bool CBackEndSocketSvc::getFieldDataSW(CShakePacket &pack)
{ 
  return false;//return TheLatticeMaster->sendFieldData(this,pack) ;
}

bool CBackEndSocketSvc::msgloop() {
  if (m_run) {
    if (TheLatticeMaster) {
      if (TheLatticeMaster->getSteps()<TheLatticeMaster->getNumSteps()) TheLatticeMaster->runOneStep() ;
    } else {
      console.Warning() << "No model created, unnable to run the simulation\n" ;
      m_run = false ;
    }
  }
  return CSocketSvc::msgloop() ;
}

bool CBackEndSocketSvc::pauseSimSW() {
  //CShakePacket ECK((void *)"nothing", 1 , "ACK") ;
  sendTag("ACK") ; //send(ECK) ;
  m_run = false ;
  return true ;
}

bool CBackEndSocketSvc::startSimSW() {
  // CShakePacket ECK((void *)"nothing", 1 , "ACK") ;
  sendTag("ACK") ; 
  // m_Socket->send(ECK) ;
  m_run = true ;
  return true ;
}

bool CBackEndSocketSvc::notConnectedSW() {
  if (n%10 == 0) console.Debug() << "Server listening...\n" ;
  n++ ;
  if (!server()->isCreated()) {
    server()->create() ;
  }
  server()->serverNonBlocking(true) ;
  server()->accept() ;
  server()->serverNonBlocking(false) ;
  
  return true ;
}

bool CBackEndSocketSvc::evaluateSW(char *script) 
{
  int res;
  char tfilename[] = "/tmp/tmp.lsmXXXXXX";
  mkstemp(tfilename);
  char *filename= tfilename;

  console.Debug()<< "temp filename is : " << filename << "\n";

  parserBridge.addLocalVariables() ;
  
  FILE *outfile ;
  outfile = fopen(filename, "w");
  fwrite(script, 1, strlen(script), outfile) ;
  fclose(outfile) ;
  
  res = SParserAccess::Parser()->Parse(filename) ;
  if (res) {
    res = SParserAccess::Parser()->Eval("main") ;
  }
  return res!=0;
}
