#ifndef _SOCKETSERVERCOM_H_
#define _SOCKETSERVERCOM_H_

#include "SocketLoop.h"


/*!
  \class CBackEndSocketSvc
  \brief Server responding to TCP/IP Socket command

  \author David Place
  $revision: 1.0 $
  $Date$
*/
class CBackEndSocketSvc : public CSocketSvc {
private:
  int n ; //!< number of time the server is listening 
protected:
  bool m_run ; //!< flag indicating if simulation is running
  virtual bool m_packetSW(CShakePacket &Packet);  //!< process packet
public:
  CBackEndSocketSvc() ;

  void startPauseSim(bool) ;
  virtual bool msgloop() ;

  virtual bool startSimSW() ;
  virtual bool pauseSimSW() ;
  virtual bool evaluateSW(char *script) ;
  virtual bool notConnectedSW() ;             //!< action when not connected (ie. listening for server...)
  virtual bool sendParticleDataSW() ;         //!< send particle data....
  virtual bool queryFieldAvailableSW() ;      //!< send available fields
  virtual bool getFieldDataSW(CShakePacket&); //!< send field data
} ;

#endif
