#ifndef MODEL_BWALLINTERACTION_HPP
#define MODEL_BWALLINTERACTION_HPP

template <class T>
CBondedWallInteraction<T>::CBondedWallInteraction(T* p,CWall* w,double k,bool iflag):
  AWallInteraction<T>(p,w,iflag)
{
  m_k=k;
}

/*!
  calculate bonded elastic forces.
*/

template <class T>
void CBondedWallInteraction<T>::calcForces()
{
  Vec3 D=(m_p->getTotalDisplacement()-m_wall->getTotalDisplacement());
  double dist=sqrt(D*D);
 
  Vec3 force=D*m_k;
  Vec3 pos=m_p->getPos();

  m_p->applyForce(-1.0*force,pos);
  if(m_inner_flag) m_wall->addForce(force);
}

/*!
  calculate and return the bonded elastic force
*/
template <class T>
Vec3 CBondedWallInteraction<T>::getForce()
{
  Vec3 D=(m_p->getTotalDisplacement()-m_wall->getTotalDisplacement());
  const double dist=sqrt(D*D);
 
  return D*m_k;
}
 
#endif
