#include "Model/BWallInteractionGroup.h"
#include "Foundation/console.h"

//----------------------------------------
//    CBWallIGP member functions 
//----------------------------------------

void  CBWallIGP::packInto(CVarMPIBuffer* B) const
{
  console.XDebug() << "CBWallIGP::packInto( " << B << " )\n"; 
  CEWallIGP::packInto(B);
  B->append(m_tag);
  console.XDebug() << "end CBWallIGP::packInto()\n ";
}

ostream& operator<<(ostream& ost,const CBWallIGP& I)
{
  ost << "CEWallIGP\n";
  ost << "Spring constant : " << I.m_k << endl;
  ost << "Wall position   : " << I.m_ipos << endl;
  ost << "Wall normal     : " << I.m_inorm << endl;  
  ost << "Tag             : " << I.m_tag << endl;
  return ost;
}

CBWallIGP* extractBWallIGP(AMPIBuffer* B)
{
  console.XDebug() << "extractBWallIGP\n";
  CBWallIGP* res=new CBWallIGP;
  res->setName(B->pop_string());
  res->setSpringConst(B->pop_double());
  Vec3 pos=B->pop_vector();
  Vec3 norm=B->pop_vector();
  res->setTag(B->pop_int());
  res->setWall(pos,norm);
  console.XDebug() << "end extractBWallIGP\n";
  return res;
}
