/*=============================================================================
??
??******************************************************************************
??*                                               *
??* COPYRIGHT ??????? - All Rights Reserved *
??*  *
??* This software is the property of ??????????????. No part of this code   *
??* may be copied in any form or by any means without the expressed written   *
??* consent of ???????????. Copying, use or modification of this software     *
??* by any unauthorised person is illegal unless that    *
??* person has a software license agreement with ?????????????.            *
??*                                                          *
??******************************************************************************
??
*********************************************************************************/

#include "Model/BodyForceGroup.h"

namespace esys
{
  namespace lsm
  {
    BodyForceIGP::BodyForceIGP() : AIGParam(), m_acceleration()
    {
    }

    BodyForceIGP::BodyForceIGP(const std::string &name, const Vec3 &acceleration)
      : AIGParam(name),
        m_acceleration(acceleration)
    {
    }

    BodyForceIGP::~BodyForceIGP()
    {
    }

    const Vec3 &BodyForceIGP::getAcceleration() const
    {
      return m_acceleration;
    }

    const std::string &BodyForceIGP::getName() const
    {
      return Name();
    }

    void BodyForceIGP::packInto(CVarMPIBuffer *pBuffer) const
    {
      pBuffer->append(getName().c_str());
      pBuffer->append(m_acceleration.X());
      pBuffer->append(m_acceleration.Y());
      pBuffer->append(m_acceleration.Z());
    }

    BodyForceIGP BodyForceIGP::extract(CVarMPIBuffer *pBuffer)
    {
      const std::string name = pBuffer->pop_string();

      const double x = pBuffer->pop_double();
      const double y = pBuffer->pop_double();
      const double z = pBuffer->pop_double();

      return BodyForceIGP(name, Vec3(x, y, z));
    }
  }
}
