
#include "Model/Damping.h"

//----------------------------------------------
//           DampingIGP functions
//----------------------------------------------

/*!
  Pack the parameters for a DampingGroup into a MPI-buffer

  \param B the buffer
*/
void CDampingIGP::packInto(CVarMPIBuffer* B) const
{
  AIGParam::packInto(B);
  B->append(m_vref);
  B->append(m_visc);
  B->append(m_dt);
  B->append(m_max_iter);
}

/*!
  Extract parameters for a DampingGroup from a MPI-buffer

  \param B the buffer
*/
CDampingIGP* extractDampingIGP(AMPIBuffer* B)
{
  CDampingIGP* res = new CDampingIGP;
  res->setName(B->pop_string());
  res->setVRef(B->pop_vector());
  res->setVisc(B->pop_double());
  res->setTimeStep(B->pop_double());
  res->setMaxIter(B->pop_int());

  return res;
}
