#include "Model/EWallInteractionGroup.h"
#include "Foundation/console.h"

//----------------------------------------
//    CEWallIGP member functions 
//----------------------------------------

void  CEWallIGP::packInto(CVarMPIBuffer* B) const
{
  console.XDebug() << "CEWallIGP::packInto( " << B << " )\n"; 
  CElasticIGP::packInto(B);
  B->append(m_ipos);
  B->append(m_inorm); 
  console.XDebug() << "end CEWallIGP::packInto()\n ";
}

ostream& operator<<(ostream& ost,const CEWallIGP& I)
{
  ost << "CEWallIGP\n";
  ost << "Spring constant : "  << I.m_k << endl;
  ost << "Wall position   : "  << I.m_ipos << endl;
  ost << "Wall normal     : "  << I.m_inorm << endl;
  return ost;
}

CEWallIGP* extractEWallIGP(AMPIBuffer* B)
{
  CEWallIGP* res=new CEWallIGP;
  res->setName(B->pop_string());
  res->setSpringConst(B->pop_double());
  Vec3 pos=B->pop_vector();
  Vec3 norm=B->pop_vector();
  res->setWall(pos,norm);
  return res;
}

/*!
  extract the specific part of  CEWallIGP, i.e. without the type info
*/
CEWallIGP* extractEWallIGP_p(AMPIBuffer* B)
{
  CEWallIGP* res=new CEWallIGP;
  res->setSpringConst(B->pop_double());
  Vec3 pos=B->pop_vector();
  Vec3 norm=B->pop_vector();
  res->setWall(pos,norm);
  return res;
}
