#include "ElasticInteractionGroup.h"
#include "console.h"

#include <memory>

//----------------------------------------
//    CElasticIGP member functions 
//----------------------------------------

void CElasticIGP::packInto(CVarMPIBuffer* B) const
{
  AIGParam::packInto(B);
  B->append(m_k);
}

CElasticIGP* extractElasticIGP(AMPIBuffer* B)
{
  CElasticIGP* res=new CElasticIGP;
  B->pop_int();
  res->setName(B->pop_string());
  res->setSpringConst(B->pop_double());
  return res;
}

/*!
  extract the specific part of  CElasticIGP, i.e. without the type info
*/
CElasticIGP* extractElasticIGP_p(AMPIBuffer* B)
{
  CElasticIGP* res=new CElasticIGP;
  res->setName(B->pop_string());
  res->setSpringConst(B->pop_double());
  return res;
}

ostream& operator<<(ostream& ost,const CElasticIGP& B)
{
  ost << "CElasticIGP\n";
  ost << "Spring Constant : " << B.m_k << endl;
  return ost;
}
