#ifndef __ELASTICINTERACTIONGROUP_H
#define __ELASTICINTERACTIONGROUP_H

#include "InteractionGroup.h"
#include "ElasticInteraction.h"
#include "IGParam.h"

//--- IO includes ---
#include <iostream>
using std::ostream;
using std::endl;


/*!
  \class CElasticInteractionGroup
  \brief Class for a group of unbonded,elastic interactions
 
  \author Steffen Abe
  $Revision$.
  $Date$
*/
template <class T>
class CElasticInteractionGroup : public APairInteractionGroup<T>
{
 protected:
  vector<CElasticInteraction> m_interactions;
  AParallelInteractionStorage* m_exIG; //<! if an interaction is in m_exIG, it can't be in m_interactions
  double m_k; //<! spring constant
 
 public:
  CElasticInteractionGroup();
  CElasticInteractionGroup(const CElasticIGP*);
  virtual ~CElasticInteractionGroup(){};
  
  virtual void setExIG(AParallelInteractionStorage* eg){m_exIG=eg;};
  void setParam(const CElasticIGP*);

  virtual void calcForces();
  virtual void Update(ParallelParticleArray<T>*);
  friend ostream& operator<< <>(ostream&,const CElasticInteractionGroup<T>&); 
};

#include "ElasticInteractionGroup.hpp"

#endif //__ELASTICINTERACTIONGROUP_H
