#ifndef __IGPARAM_H
#define __IGPARAM_H

#include "mpivbuf.h"

// -- STL includes --
#include <string>

using std::string;

/*!
  \class AIGParam
  \brief Abstract base class for InteractionGroup parameters
  \author Steffen Abe
  $Revision$
  $Date$
 */
class AIGParam
{
protected:
  string m_name;

public:
  AIGParam(const std::string &name = "");
  
  virtual ~AIGParam()=0;
  virtual void packInto(CVarMPIBuffer*) const;

  void setName(const std::string &name);
  const std::string &Name() const {return m_name;};

  //  friend class AInteractionGroup;
};

#endif //__IGPARAM_H
