
#include "Model/Interaction.h"
#include "Parallel/mpibuf.h"

#include <iostream>

AInteraction::AInteraction():m_id(), m_iid(-1), m_init(false)
{
}

AInteraction::~AInteraction()
{
}

vector<int> AInteraction::getAllID() const
{
  return m_id;
}

bool AInteraction::initialized() const
{
  return m_init;
}

APairInteraction::~APairInteraction()
{
}

APairInteraction::APairInteraction():AInteraction()
{
  m_p1=NULL;
  m_p2=NULL;
  m_id.push_back(-1);
  m_id.push_back(-1);
}

APairInteraction::APairInteraction(CParticle* p1,CParticle* p2):AInteraction()
{
  m_p1=p1;
  m_p2=p2;
  m_id.push_back(m_p1->getID());
  m_id.push_back(m_p2->getID());
  m_init=true;
}

void APairInteraction::checkIDs()
{
  if ((m_id[0]!=m_p1->getID())||(m_id[1]!=m_p2->getID())){
    std::cout
      << "inconsistent IDs : " << m_id[0] << "-" << m_id[1]
      << " vs. "
      << m_p1->getID() << "-" << m_p2->getID() << std::endl << std::flush;
  }
}

/*!
  check if any of the particles in the interaction fits tag & mask

  \param tag the tag
  \param mask the mask
*/
bool APairInteraction::hasTag(int tag ,int mask) const
{
  int tag1=m_p1->getTag();
  int tag2=m_p2->getTag();
  return (((tag1 & mask)==(tag & mask))||((tag2 & mask)==(tag & mask)));
}
