#ifndef __MESHDATA_H
#define __MESHDATA_H

// -- IO includes --
#include <iostream>
using std::istream;

/*!
  \struct MeshNodeData
  \brief data describing one node(point) in a TriMesh

  \author Steffen Abe
  $Date$
  $Revision$  
*/
struct MeshNodeData
{
  int id;
  int tag;
  double x,y,z;

  void read(istream&);
};

/*!
  \struct MeshTriData
  \brief data describing one Triangle  in a TriMesh

  \author Steffen Abe
  $Date$
  $Revision$  
*/
struct MeshTriData
{
  int id,tag;
  int p1,p2,p3;

  void read(istream&);
};


#endif // __MESHDATA_H
