/********************************************************************************/
/* ModelFNC.H                                                                   */
/*                                                                              */
/* Description:   Parser functions                                              */
/* Author(s):     D. Place (QUAKES)                                             */
/* Creation date: November 2001                                                 */
/*                                                                              */
/********************************************************************************/
#ifndef _MODELFNC_H_
#define _MODELFNC_H_

#include "globals.h"
#include "interface.h"
#include "functions.h"

class AModelInterface {
 public:
   virtual void AddVariablesTo(InternVFTable &) = 0 ;
   virtual void DelVariablesFrom(InternVFTable &) = 0 ;
} ;


class CParserBridge {
  List<AModelInterface> m_Locals ;
  List<AModelInterface> m_Globals ;
public:
  CParserBridge() ;

  void addLocalInterface(AModelInterface *) ;
  void addGlobalInterface(AModelInterface *) ;
  
  void addLocalVariables() ;
  void addGlobalVariables() ;
  void removeLocalVariables() ;
  void removeGlobalVariables() ;
} ;

extern CParserBridge parserBridge ;

class CGlobalFunctions : public AModelInterface {
 public:
   virtual void AddVariablesTo(InternVFTable &) ;
   virtual void DelVariablesFrom(InternVFTable &) ;
} ;

class CModelFunctions : public AModelInterface  {
 public:
  virtual void AddVariablesTo(InternVFTable &) ;
  virtual void DelVariablesFrom(InternVFTable &) ;
} ;

class CModelVariables : public AModelInterface  {
 public:
  virtual void AddVariablesTo(InternVFTable &) ;
  virtual void DelVariablesFrom(InternVFTable &) ;
} ;

#endif
