#ifndef __ROTELASTICINTERACTIONGROUP_H
#define __ROTELASTICINTERACTIONGROUP_H

#include "InteractionGroup.h"
#include "RotElasticInteraction.h"
#include "IGParam.h"

//--- IO includes ---
#include <iostream>
using std::ostream;
using std::endl;


/*!
  \class CElasticInteractionGroup
  \brief Class for a group of unbonded,elastic interactions
 
  \author Steffen Abe
  $Revision$.
  $Date$
*/
template <class T>
class CRotElasticInteractionGroup : public APairInteractionGroup<T>
{
 protected:
  vector<CRotElasticInteraction> m_interactions;
  AParallelInteractionStorage* m_exIG; //<! if an interaction is in m_exIG, it can't be in m_interactions
  double m_k; //<! spring constant
 
 public:
  CRotElasticInteractionGroup();
  CRotElasticInteractionGroup(const CRotElasticIGP*);
  virtual ~CRotElasticInteractionGroup(){};
  
  virtual void setExIG(AParallelInteractionStorage* eg){m_exIG=eg;};
  void setParam(const CRotElasticIGP*);

  virtual void calcForces();
  virtual void Update(ParallelParticleArray<T>*);
  friend ostream& operator<< <>(ostream&,const CRotElasticInteractionGroup<T>&); 
};

#include "RotElasticInteractionGroup.hpp"

#endif //__ELASTICINTERACTIONGROUP_H
