#ifndef __SOFTBWALLINTERACTION_H
#define __SOFTBWALLINTERACTION_H

#include "WallInteraction.h"
#include "Wall.h"

/*!
  \class CSoftBondedWallInteraction
  \brief bonded elastic interaction between a particle and a wall with different 
  spring constants in each direction

  \author Steffen Abe
  $Revision$
  $Date$  
*/
template <class T>
class CSoftBondedWallInteraction : public AWallInteraction<T>
{
protected:
  double m_kx,m_ky,m_kz;//!< directional spring constants
public:
  CSoftBondedWallInteraction();
  CSoftBondedWallInteraction(T*,CWall*,double,double,double);
  virtual ~CSoftBondedWallInteraction(){};

  virtual void calcForces();
  virtual void setPP(const vector<T*>){};
};

#include "Model/SoftBWallInteraction.hpp"

#endif //__SOFTBWALLINTERACTION_H
