
#ifndef MODEL_SOFTBWALLINTERACTION_HPP
#define MODEL_SOFTBWALLINTERACTION_HPP

#include "SoftBWallInteraction.h"

template <class T>
CSoftBondedWallInteraction<T>::CSoftBondedWallInteraction(T* p,CWall* w,double kx,double ky,double kz):
  AWallInteraction<T>(p,w)
{
  m_kx=kx;
  m_ky=ky;
  m_kz=kz;
}

/*!
  calculate bonded elastic forces.
*/
template <class T>
void CSoftBondedWallInteraction<T>::calcForces()
{
  Vec3 D=(m_p->getTotalDisplacement()-m_wall->getTotalDisplacement());
  
  double fx=D.X()*m_kx;
  double fy=D.Y()*m_ky;
  double fz=D.Z()*m_kz;
  Vec3 force=Vec3(fx,fy,fz);
  Vec3 pos=m_p->getPos();

  m_p->applyForce(-1.0*force,pos);
  m_wall->addForce(force);
}

#endif
