#include "SoftBWallInteractionGroup.h"
#include "console.h"

//----------------------------------------
//    CSoftBWallIGP member functions 
//----------------------------------------

void  CSoftBWallIGP::packInto(CVarMPIBuffer* B) const
{
  console.XDebug() << "CSoftBWallIGP::packInto( " << B << " )\n"; 
  CBWallIGP::packInto(B);
  B->append(m_ky);
  B->append(m_kz);
  console.XDebug() << "end CSoftBWallIGP::packInto()\n ";
}

ostream& operator<<(ostream& ost,const CSoftBWallIGP& I)
{
  ost << "CSoftBWallIGP\n";
  ost << "Spring constants : " << I.m_k << " , " << I.m_ky << " , " << I.m_kz << endl;
  ost << "Wall position   : " << I.m_ipos << endl;
  ost << "Wall normal     : " << I.m_inorm << endl;  
  ost << "Tag             : " << I.m_tag << endl;
  return ost;
}

CSoftBWallIGP* extractSoftBWallIGP(AMPIBuffer* B)
{
  console.XDebug() << "extractSoftBWallIGP\n";
  CSoftBWallIGP* res=new CSoftBWallIGP;
  res->setName(B->pop_string());
  double kx=B->pop_double();
  Vec3 pos=B->pop_vector();
  Vec3 norm=B->pop_vector();
  res->setTag(B->pop_int());
  double ky=B->pop_double();
  double kz=B->pop_double();
  res->setAllK(kx,ky,kz);
  res->setWall(pos,norm);
  console.XDebug() << "end extractSoftBWallIGP\n";
  return res;
}
