#include "ViscWallIG.h"
#include "console.h"

//----------------------------------------
//    CVWallIGP member functions 
//----------------------------------------

void  CVWallIGP::packInto(CVarMPIBuffer* B) const
{
  console.XDebug() << "CVWallIGP::packInto( " << B << " )\n"; 
  CEWallIGP::packInto(B);
  B->append(m_tag);
  B->append(m_nu);
  console.XDebug() << "end CBWallIGP::packInto()\n ";
}

ostream& operator<<(ostream& ost,const CVWallIGP& I)
{
  ost << "CVWallIGP\n";
  ost << "Spring constant : " << I.m_k << endl;
  ost << "Wall position   : " << I.m_ipos << endl;
  ost << "Wall normal     : " << I.m_inorm << endl;  
  ost << "Tag             : " << I.m_tag << endl;
  ost << "Viscosity       : " << I.m_nu << endl;
  return ost;
}

CVWallIGP* extractVWallIGP(AMPIBuffer* B)
{
  console.XDebug() << "extractVWallIGP\n";
  CVWallIGP* res=new CVWallIGP;
  res->setName(B->pop_string());
  res->setSpringConst(B->pop_double());
  Vec3 pos=B->pop_vector();
  Vec3 norm=B->pop_vector();
  res->setTag(B->pop_int());
  res->setNu(B->pop_double());
  res->setWall(pos,norm);
  console.XDebug() << "end extractVWallIGP\n";
  return res;
}
