/*=============================================================================
??
??******************************************************************************
??*                                               *
??* COPYRIGHT ??????? - All Rights Reserved *
??*  *
??* This software is the property of ??????????????. No part of this code   *
??* may be copied in any form or by any means without the expressed written   *
??* consent of ???????????. Copying, use or modification of this software     *
??* by any unauthorised person is illegal unless that    *
??* person has a software license agreement with ?????????????.            *
??*                                                          *
??******************************************************************************
??
*********************************************************************************/

#ifndef LSMTESTROTBONDEDINTERACTIONTEST_H
#define LSMTESTROTBONDEDINTERACTIONTEST_H

#include <cppunit/extensions/HelperMacros.h>
#include <cppunit/TestCase.h>

#include <boost/shared_ptr.hpp>

namespace LsmTest
{
  /*!
     $Revision$
     $Date$
  */
  class RotBondedInteractionTest : public CppUnit::TestCase
  {
  public:
    RotBondedInteractionTest();
    virtual ~RotBondedInteractionTest();

    virtual void setUp();
    virtual void tearDown();

    CPPUNIT_TEST_SUITE( RotBondedInteractionTest );
    CPPUNIT_TEST( testZeroForce );
    CPPUNIT_TEST( testElasticOnlyForce );
    CPPUNIT_TEST( testElasticEnergyConservation );
    CPPUNIT_TEST( testElasticAndAngularEnergyConservation );
    CPPUNIT_TEST( testElasticAngularAndLinearEnergyConservation );
    CPPUNIT_TEST_SUITE_END();

    // the test methods
    void testZeroForce();
    void testElasticOnlyForce();
    void testElasticEnergyConservation();
    void testElasticAndAngularEnergyConservation();
    void testElasticAngularAndLinearEnergyConservation();
  private:
    class Impl;
    typedef boost::shared_ptr<Impl> ImplPtr;
    ImplPtr m_impl;
  };
};

#endif // LSMTESTROTBONDEDINTERACTIONTEST_H
