/*=============================================================================
??
??******************************************************************************
??*                                               *
??* COPYRIGHT ??????? - All Rights Reserved *
??*  *
??* This software is the property of ??????????????. No part of this code   *
??* may be copied in any form or by any means without the expressed written   *
??* consent of ???????????. Copying, use or modification of this software     *
??* by any unauthorised person is illegal unless that    *
??* person has a software license agreement with ?????????????.            *
??*                                                          *
??******************************************************************************
??
*********************************************************************************/

#ifndef LSMTESTROTFRICTIONINTERACTIONTEST_H
#define LSMTESTROTFRICTIONINTERACTIONTEST_H

#include <cppunit/extensions/HelperMacros.h>
#include <cppunit/TestCase.h>

#include <boost/shared_ptr.hpp>

namespace LsmTest
{
  /*!
     $Revision$
     $Date$
  */
  class RotFrictionInteractionTest : public CppUnit::TestCase
  {
  public:
    RotFrictionInteractionTest();
    virtual ~RotFrictionInteractionTest();

    virtual void setUp();
    virtual void tearDown();

    CPPUNIT_TEST_SUITE( RotFrictionInteractionTest );
    CPPUNIT_TEST( testZeroForce );
    CPPUNIT_TEST( testElasticOnlyForce );
    CPPUNIT_TEST( testShearForce );
    CPPUNIT_TEST( testElasticPlusMoment );
    CPPUNIT_TEST( testShearForceWithVelocity );
    CPPUNIT_TEST_SUITE_END();

    // the test methods
    void testZeroForce();
    void testElasticOnlyForce();
    void testShearForce();
    void testElasticPlusMoment();
    void testShearForceWithVelocity();
  private:
    class Impl;
    typedef boost::shared_ptr<Impl> ImplPtr;
    ImplPtr m_impl;
  };
};

#endif // LSMTESTROTFRICTIONINTERACTIONTEST_H
