/*=============================================================================
??
??******************************************************************************
??*                                               *
??* COPYRIGHT ??????? - All Rights Reserved *
??*  *
??* This software is the property of ??????????????. No part of this code   *
??* may be copied in any form or by any means without the expressed written   *
??* consent of ???????????. Copying, use or modification of this software     *
??* by any unauthorised person is illegal unless that    *
??* person has a software license agreement with ?????????????.            *
??*                                                          *
??******************************************************************************
??
*********************************************************************************/

#ifndef LSMTESTROTPARTICLETEST_H
#define LSMTESTROTPARTICLETEST_H

#include <cppunit/extensions/HelperMacros.h>
#include <cppunit/TestCase.h>

#include <boost/shared_ptr.hpp>

namespace LsmTest
{
  /*!
     \author Steffen Abe
     $Revision$
     $Date$
  */
  class RotParticleTest : public CppUnit::TestCase
  {
  public:
    RotParticleTest();
    virtual ~RotParticleTest();
    
    virtual void setUp();
    virtual void tearDown();

    CPPUNIT_TEST_SUITE( RotParticleTest );
    CPPUNIT_TEST( testIntegrationConstantAngVel );
    CPPUNIT_TEST( testIntegrationInitialMoment );
    CPPUNIT_TEST_SUITE_END();
    
    // the test methods
    void testIntegrationConstantAngVel();
    void testIntegrationInitialMoment();
  private:    
    class Impl;
    typedef boost::shared_ptr<Impl> ImplPtr;
    ImplPtr m_implPtr;
    
  };
};

#endif // LSMTESTROTPARTICLETEST_H
