#include "TMITest.h"

// -- test includes --
#include "Model/Particle.h"
#include "Geometry/Triangle.h"
#include "Model/ETriangleInteraction.h"
#include "Model/ETriMeshIP.h"

namespace LsmTest
{
  CPPUNIT_TEST_SUITE_REGISTRATION( TMITest );

  /*! 
    constructor - do nothing
  */
  TMITest::TMITest() : CppUnit::TestCase()
  {}

  /*!
    destructor - do nothing
  */
  TMITest::~TMITest()
  {
  }
    
  /*!
   */
  void TMITest::setUp()
  {
    CppUnit::TestCase::setUp();
  }
  
  /*!
   */ 
  void TMITest::tearDown()
  {
    CppUnit::TestCase::tearDown();
  }

  /*!
    test ETriangleInteraction::calcForce
  */
  void TMITest::testTriangleForce()
  {
    // setup triangle
    Vec3 p1=Vec3(0.0,0.0,0.0);
    Vec3 p2=Vec3(1.0,0.0,1.0);
    Vec3 p3=Vec3(0.0,0.0,1.0);
    Triangle Tr1=Triangle(1,2,3,p1,p2,p3,0,0);
    // some test particles & interactions
    Vec3 vpos=Vec3(0.4,0.8,0.6);
    CParticle P1=CParticle(1.0,1.0,vpos,Vec3(0.0,0.0,0.0),Vec3(0.0,0.0,0.0),1);
    ETriMeshIP param;
    param.k=1.0;
    ETriangleInteraction I1=ETriangleInteraction(&P1,&Tr1,param);
    // calc & check forces
    I1.calcForces();
    Vec3 force1=P1.getForce();
    CPPUNIT_ASSERT_DOUBLES_EQUAL(0.0,force1.X(),1e-10);
    CPPUNIT_ASSERT_DOUBLES_EQUAL(0.2,force1.Y(),1e-10);
    CPPUNIT_ASSERT_DOUBLES_EQUAL(0.0,force1.Z(),1e-10);
  }
};
