/*=============================================================================
??
??******************************************************************************
??*                                                                            *
??*       COPYRIGHT  ???????  -  All Rights Reserved                           *
??*                                                                            *
??* This software is the property of ??????????????.  No part of this code     *
??* may be copied in any form or by any means without the expressed written    *
??* consent of ???????????.  Copying, use or modification of this software     *
??* by any unauthorised person is illegal unless that                          *
??* person has a software license agreement with ?????????????.                *
??*                                                                            *
??******************************************************************************
??
*********************************************************************************/

#ifndef LSMTESTTRIMESHTEST_H
#define LSMTESTTRIMESHTEST_H

// -- CPPUnit includes ---
#include <cppunit/extensions/HelperMacros.h>
#include <cppunit/TestCase.h>

// -- STL includes ---
#include <vector>
using std::vector;

// -- Project includes --
#include "Model/MeshData.h"
#include "Model/TriMesh.h"

namespace LsmTest
{
  /*!
     \author Steffen Abe
     $Revision$
     $Date$
  */	
  class TriMeshTest  : public CppUnit::TestCase
  {
  private:
    vector<MeshTriData> m_mtd;
    vector<MeshNodeData> m_mnd;
    TriMesh m_tm;

  public:	
    TriMeshTest();
    virtual ~TriMeshTest();    
    virtual void setUp();
    virtual void tearDown();

    CPPUNIT_TEST_SUITE( TriMeshTest );
    CPPUNIT_TEST( testLoadMesh );
    CPPUNIT_TEST( testGetTriangleById );
    CPPUNIT_TEST_SUITE_END();

    // test methods
    void testLoadMesh();
    void testGetTriangleById();
  };
};

#endif //LSMTESTTRIMESHTEST_H
