/*=============================================================================

******************************************************************************
*                                               *
* COPYRIGHT ??????? - All Rights Reserved *
*  *
* This software is the property of ??????????????. No part of this code   *
* may be copied in any form or by any means without the expressed written   *
* consent of ???????????. Copying, use or modification of this software     *
* by any unauthorised person is illegal unless that    *
* person has a software license agreement with ?????????????.            *
*                                                          *
******************************************************************************

*********************************************************************************/

#include "Parallel/CheckPointer.h"
#include "Parallel/CheckPointParams.h"
#include "Parallel/CheckPointable.h"
#include "Parallel/mpivbuf.h"

#include <fstream>
#include <sstream>

using esys::lsm::CheckPointable;

CheckPointer::CheckPointer(CheckPointable &checkPointable)
  : m_pCheckPointable(&checkPointable)
{
}

CheckPointer::~CheckPointer()
{
}

void CheckPointer::save()
{
  CVarMPIBuffer buffer(MPI_COMM_WORLD);

  // get check-point parameters
  buffer.receiveBroadcast(0);
  CheckPointParams checkPointParams = CheckPointParams::unpackFrom(&buffer);

  // Write the check-point info to file.  
  std::ofstream oStream(checkPointParams.getFileName().c_str());
  save(oStream);
  oStream.close();
}

void CheckPointer::save(std::ostream &oStream)
{
  m_pCheckPointable->saveCheckPointData(oStream);
}
