/*=============================================================================

******************************************************************************
*                                               *
* COPYRIGHT ??????? - All Rights Reserved *
*  *
* This software is the property of ??????????????. No part of this code   *
* may be copied in any form or by any means without the expressed written   *
* consent of ???????????. Copying, use or modification of this software     *
* by any unauthorised person is illegal unless that    *
* person has a software license agreement with ?????????????.            *
*                                                          *
******************************************************************************

*********************************************************************************/

#ifndef CHECKPOINTER_H
#define CHECKPOINTER_H

#include <string>
#include <iostream>

namespace esys
{
  namespace lsm
  {
    class CheckPointable;
  }
}

/**
 * Saves the state of a model.
*/
class CheckPointer
{
public:
  /**
  */
  CheckPointer(esys::lsm::CheckPointable &checkPointable);

  /**
  */
  virtual ~CheckPointer();

  /**
   * Saves the state of a model.
   */
  virtual void save();

  /**
   * Saves the state of a model to specified stream.
   */
  virtual void save(std::ostream &oStream);

private:
  esys::lsm::CheckPointable *m_pCheckPointable;
};

#endif
