/*=============================================================================
??
??******************************************************************************
??*                                               *
??* COPYRIGHT ??????? - All Rights Reserved *
??*  *
??* This software is the property of ??????????????. No part of this code   *
??* may be copied in any form or by any means without the expressed written   *
??* consent of ???????????. Copying, use or modification of this software     *
??* by any unauthorised person is illegal unless that    *
??* person has a software license agreement with ?????????????.            *
??*                                                          *
??******************************************************************************
??
*********************************************************************************/

#include "Parallel/MpiInfo.h"
#include "Parallel/mpibuf.h"

MpiInfo::MpiInfo(MPI_Comm comm) : m_comm(comm)
{
}

MpiInfo::~MpiInfo()
{
}

int MpiInfo::rank() const
{
  int rank;
  MPI_Comm_rank(m_comm, &rank);
  
  return rank;
}

int MpiInfo::size() const
{
  int size;
  MPI_Comm_size(m_comm, &size);
  
  return size;
}
