/*=============================================================================
??
??******************************************************************************
??*                                               *
??* COPYRIGHT ??????? - All Rights Reserved *
??*  *
??* This software is the property of ??????????????. No part of this code   *
??* may be copied in any form or by any means without the expressed written   *
??* consent of ???????????. Copying, use or modification of this software     *
??* by any unauthorised person is illegal unless that    *
??* person has a software license agreement with ?????????????.            *
??*                                                          *
??******************************************************************************
??
*********************************************************************************/

#ifndef MPIINFO_H
#define MPIINFO_H

#include <mpi.h>

/**
 * Convenience class for obtaining rank of current process
 * (and size of a specified MPI_Comm).
 */
class MpiInfo
{
public:
  /**
   * Rank and size for specified MPI_Comm.
   */
  MpiInfo(MPI_Comm comm = MPI_COMM_WORLD);
  
  virtual ~MpiInfo();
  
  /**
   *
   */
  int rank() const;
  
  /**
   *
   */
  int size() const;
  
private:
  MPI_Comm m_comm;
};

#endif
