/*=============================================================================
??
??******************************************************************************
??*                                               *
??* COPYRIGHT ??????? - All Rights Reserved *
??*  *
??* This software is the property of ??????????????. No part of this code   *
??* may be copied in any form or by any means without the expressed written   *
??* consent of ???????????. Copying, use or modification of this software     *
??* by any unauthorised person is illegal unless that    *
??* person has a software license agreement with ?????????????.            *
??*                                                          *
??******************************************************************************
??
*********************************************************************************/

#ifndef ESYS_LSMPARSERLMINITIALISER_H
#define ESYS_LSMPARSERLMINITIALISER_H

#include "Parser/ModelFnc.h"

class CLatticeMaster;

namespace esys
{
  namespace lsm
  {
    /**
     * Initialises lattice-master from lsm 
     */
    class ParserLmInitialiser : public AModelInterface
    {
    public:
      ParserLmInitialiser(CLatticeMaster &latticeMaster, CParserBridge &bridge);

      virtual ~ParserLmInitialiser();

      /**
       * Add Variables/Functions to Parser
       */
      virtual void AddVariablesTo(InternVFTable &vfTable);

      /**
       * Remove Variables/Functions from Parser
       */
      virtual void DelVariablesFrom(InternVFTable &vfTable);
    
    protected:
      CLatticeMaster &getLatticeMaster();
      const CLatticeMaster &getLatticeMaster() const;
      
    private:
      class Impl;
      Impl *m_pImpl;
    };
  };
};

#endif
