/*=============================================================================
??
??******************************************************************************
??*                                               *
??* COPYRIGHT ??????? - All Rights Reserved *
??*  *
??* This software is the property of ??????????????. No part of this code   *
??* may be copied in any form or by any means without the expressed written   *
??* consent of ???????????. Copying, use or modification of this software     *
??* by any unauthorised person is illegal unless that    *
??* person has a software license agreement with ?????????????.            *
??*                                                          *
??******************************************************************************
??
*********************************************************************************/

#include "ParallelTest/CheckPointControllerTest.h"
#include "Parallel/CheckPointController.h"

namespace LsmTest
{
  CPPUNIT_TEST_SUITE_REGISTRATION(CheckPointControllerTest);

  CheckPointControllerTest::CheckPointControllerTest()
      : CppUnit::TestCase()
  {
  }

  CheckPointControllerTest::~CheckPointControllerTest()
  {
  }

  void CheckPointControllerTest::setUp()
  {
  }
  
  void CheckPointControllerTest::tearDown()
  {
  }
  
  void CheckPointControllerTest::testDefault()
  {
    CheckPointController chkPtCntrl;
    
    CPPUNIT_ASSERT(!chkPtCntrl.isCheckPoint(0));
  }
  
  void CheckPointControllerTest::testIsCheckPoint()
  {
    CheckPointController chkPtCntrl("some/lame/prefix", 5, 50, 5);
    
    CPPUNIT_ASSERT(!chkPtCntrl.isCheckPoint(0));
    CPPUNIT_ASSERT(!chkPtCntrl.isCheckPoint(4));
    CPPUNIT_ASSERT(chkPtCntrl.isCheckPoint(5));
    CPPUNIT_ASSERT(!chkPtCntrl.isCheckPoint(6));
    CPPUNIT_ASSERT(chkPtCntrl.isCheckPoint(10));
    CPPUNIT_ASSERT(!chkPtCntrl.isCheckPoint(44));
    CPPUNIT_ASSERT(chkPtCntrl.isCheckPoint(45));
    CPPUNIT_ASSERT(chkPtCntrl.isCheckPoint(50));
    CPPUNIT_ASSERT(!chkPtCntrl.isCheckPoint(51));
    CPPUNIT_ASSERT(!chkPtCntrl.isCheckPoint(55));
  }  
}
