/*=============================================================================
??
??******************************************************************************
??*                                               *
??* COPYRIGHT ??????? - All Rights Reserved *
??*  *
??* This software is the property of ??????????????. No part of this code   *
??* may be copied in any form or by any means without the expressed written   *
??* consent of ???????????. Copying, use or modification of this software     *
??* by any unauthorised person is illegal unless that    *
??* person has a software license agreement with ?????????????.            *
??*                                                          *
??******************************************************************************
??
*********************************************************************************/

#ifndef __MESHREADERTEST_H
#define __MESHREADERTEST_H

#include <cppunit/extensions/HelperMacros.h>
#include <UnitTest/FileTestCase.h>

#include <stdexcept>

namespace LsmTest
{
  /*!
    Test cases for MeshReader and its components (NodeReader,TriReader...)

    \author Steffen Abe
    $Date$
    $Revision$
  */
  class MeshReaderTest : public FileTestCase
  {
  
  public:
    MeshReaderTest();
    virtual ~MeshReaderTest();

    virtual void setUp();
    virtual void tearDown();

    CPPUNIT_TEST_SUITE( MeshReaderTest );
    CPPUNIT_TEST( testNodeReader );
    CPPUNIT_TEST( testTriReader );
    CPPUNIT_TEST( testMeshReader );
    CPPUNIT_TEST_SUITE_END();

    void testNodeReader();
    void testTriReader();
    void testMeshReader();
  };
};

#endif //__MESHREADERTEST_H
