/*=============================================================================
??
??******************************************************************************
??*                                               *
??* COPYRIGHT ??????? - All Rights Reserved *
??*  *
??* This software is the property of ??????????????. No part of this code   *
??* may be copied in any form or by any means without the expressed written   *
??* consent of ???????????. Copying, use or modification of this software     *
??* by any unauthorised person is illegal unless that    *
??* person has a software license agreement with ?????????????.            *
??*                                                          *
??******************************************************************************
??
*********************************************************************************/

#ifndef __NTABLETEST_H
#define __NTABLETEST_H

// --- CPPUnit includes ---
#include <cppunit/extensions/HelperMacros.h>
#include <cppunit/TestCase.h>

// --- LSM includes ---
#include "ntable/src/ntable.h"
#include "Model/BasicParticle.h"

namespace LsmTest
{
  /*!
    Test cases for NTable

    \author Steffen Abe
     $Revision$
     $$Date$
  */
  class NTableTest : public CppUnit::TestCase
  {
  private:
    NeighborTable<CBasicParticle> *m_NT;
  public:
    NTableTest();
    virtual ~NTableTest();

    virtual void setUp();
    virtual void tearDown();

    CPPUNIT_TEST_SUITE(NTableTest); 
    CPPUNIT_TEST(TestTriangle);  
    CPPUNIT_TEST_SUITE_END();
    
    // the test methods
    void TestTriangle();
  };
};  
#endif //__NTABLETEST_H
