/********************************************************************************/
/* GLOBALS.H		 							*/
/* 										*/
/* Description:	  Parser predefined functions and globals varibale		*/
/* Author(s):     D. Place (QUAKES)						*/
/* Creation date: March 1999							*/
/*										*/
/********************************************************************************/
#ifndef _GLOBALS_H_
#define _GLOBALS_H_
#include "t_list.h"
#include "shake_math.h"
#include "mainparser.h"

class PredefinedFunction ;
class Symbol ;
class OpValueArray ;
/*!
   \class InternVariable
   \brief Intern Variable representation
*/
class InternVariable {
 public:
  Symbol *Sym ;
  int Update ;
  union {
    char **str ;
    integer *l;
    real *d;
    void *WhatEver ;
  } Content ;
} ;

/*!
   \class InternVFTable
   \brief List of predefined variables, Fnc etc...
*/
class InternVFTable : public List<InternVariable>, public ParserStatics {
public:
    InternVFTable() ;

    int DelFnc(char *name) ;
    int DelVar(char* VarName) ; 

    int AddFnc(char *name, PredefinedFunction *Fn) ;
    int AddVar(char* VarName, char **PtrValue) ; 
    int AddVar(char* VarName, integer *PtrValue) ; 
    int AddVar(char* VarName, real *PtrValue) ; 
    int AddArray(char* VarName, integer *PtrValue, int NDim, int *Dims) ; 
    int AddArray(char* VarName, real *PtrValue, int NDim, int *Dims) ; 
    int AddArray(char* VarName, char **PtrValue, int NDim, int *Dims) ; 

    void Destroy() ;
    void Init() ;
} ;
#endif
