/********************************************************************************/
/* STATEMENTS.H		 							*/
/* 										*/
/* Description:	  Parser evaluation functions					*/
/* Author(s):     D. Place (QUAKES)						*/
/* Creation date: March 1999							*/
/*										*/
/********************************************************************************/
#ifndef _STATEMENTS_H_
#define _STATEMENTS_H_

#include "expression.h"
#include "mtypes.h"

/*!
 \class WhileStatement
 \brief statement while (cf constructor for the child values)
*/
class WhileStatement: public ExpressionNode {
public:
    WhileStatement(ExpressionNode *Predicat, ExpressionNode *Block) ;

    virtual int Eval() ;
};

/*!
 \class DoStatement
 \brief statement do (cf constructor for the child values)
*/
class DoStatement: public ExpressionNode {
public:
    DoStatement(ExpressionNode *Predicat, ExpressionNode *Block) ;

    virtual int Eval() ;
};

/*!
 \class ForStatement
 \brief statement for (cf constructor for the child values)
*/
class ForStatement: public ExpressionNode {
public:
    ForStatement(ExpressionNode *Pre, ExpressionNode *Predica, ExpressionNode *Post, ExpressionNode *Block) ;

    virtual int Eval() ;
};

/*!
  \class IfStatement
  \brief Statement If
  structure of a if (Px is an expression or predicat, Bx is a block) :
  if (P1) B1 elseif (P2) B2 elseif (P3) B3 ... else Bn:
  the list contains: P1 B1 P2 B2 P3 B3 ... 1 Bn
*/
class IfStatement: public ExpressionNode {
public:
    IfStatement(ExpressionNode *Predicat, ExpressionNode *Block) ;

    virtual int Eval() ;
};

/*!
  \class Block
  \brief A list of expression
*/
class Block: public ExpressionNode {
public:
    Block(ExpressionNode *instruction) ;
    Block() ;

    virtual int Eval() ;
};

#endif


