#ifndef _SOCKET_LOOP_H_
#define _SOCKET_LOOP_H_

#include "LSMSocket.h"
#include "t_list.h"

class CPacketList : public List<CShakePacket> {} ;

class CSocketLoop {
protected:
	CPacketList m_PB ;
	CShakeSocket *m_s ;
public:
	CSocketLoop(CShakeSocket &s) ;
	virtual ~CSocketLoop() ;

	bool checkMessages() ;
	void getAllMessages() ;
	CShakePacket *getMessage(char *Type=NULL) ;
        void putMessage(CShakePacket *P) ;
} ;

/* Socket services for either back-end or front-end */

class CSocketSvc {
private:
  static int m_maxPort,m_minPort ;
protected:
  CSocketLoop *m_Loop ;
  CShakeSocketClient *m_SocketClient ;
  CShakeSocketServer *m_SocketServer ;
  CShakeSocket *m_Socket ;
  virtual bool m_packetSW(CShakePacket &Packet);  // process packet
  bool m_MustExit ;
public:
  CSocketSvc() ;
  void initAsClient(CSocketLoop *Loop,CShakeSocketClient *SocketClient) ;
  void initAsServer(CSocketLoop *Loop,CShakeSocketServer *SocketServer) ;
  CSocketLoop *loop() ;
  CShakeSocketClient *client() ;
  CShakeSocketServer *server() ;
  CShakeSocket *socket() ;

  virtual bool msgloop() ;
  bool mustExit() ; // true if the program should end now

  int & maxPort() { return m_maxPort; } ;
  int & minPort() { return m_minPort; } ;

  CShakePacket *waitFor(char *Type) ;
  int sendTag(char *Type) ;

  virtual bool closeInboundSW() ; // stop listening (server only)
  virtual bool notConnectedSW() { return true ; } ; // action when not connected (ie. listening for server...)
  virtual bool evaluateSW(char *script) { return true ; } ; // action to evaluate script
  virtual bool reqEvaluateSW()  ; // action to evaluate script
  virtual bool closeConnectionSW() ; // action when connection closing
  virtual bool connectionEndedSW() ; // action when connection is closed
  virtual bool exitSW() ; // action when ask for exit (will close connection before)
  virtual bool pingSW() ; // action when pinged
  virtual bool querySW() ; // action when asked for query
  virtual bool queryReplySW(CShakePacket &Packet) ; // action when reply to query
  virtual void queryReadSW(char *Id,unsigned short Port,char *name) {} ;// action to process query data
  virtual bool packetSW(CShakePacket &Packet) { return true ; } ; // process packet
} ;

extern CSocketSvc* sock ;
#endif
