#include "stdafx.h"
#include "remoteConsole.h"

/********************************************************************************/
/* class ARemoteConsoleServer   						*/
/* 										*/
/* Description:									*/
/*   server console								*/
/********************************************************************************/

CSocketLoop *ARemoteConsoleServer::s_SockLp = NULL ;

void ARemoteConsoleServer::setSocketLoop(CSocketLoop *SockLoop) {
    s_SockLp = SockLoop ;
}

void ARemoteConsoleServer::Gathering() {
    if (m_SockLp) {       
        CShakePacket *ConData ;
        m_SockLp->getAllMessages() ; // get All messages from queue
        ConData = m_SockLp->getMessage("CON") ;
        while (ConData) {
	    //tconsole.Debug() << "Gathering: some data arrived\n" ;
            char *buffer ;
            buffer = (char*)(ConData->getData()) ;
            //console << "<C>: " ;
	    if (strlen(buffer)>4) {
	      if (!strncmp("[dbg]",buffer,5)) {
		console.Debug(false) << "BE:" << buffer ;
	      } else if (!strncmp("[msg]",buffer,5)) {
		console.Message(false) << "BE:" << buffer ;
	      } else if (!strncmp("[inf]",buffer,5)) {
		console.Info(false) << "BE:" << buffer ;
	      } else if (!strncmp("[wrn]",buffer,5)) {
		console.Warning(false) << "BE:" << buffer ;
	      } else if (!strncmp("[err]",buffer,5)) {
		console.Error(false) << "BE:" << buffer ;
	      } else if (!strncmp("[crt]",buffer,5)) {
		console.Critical(false) << "BE:" << buffer ;
	      } else {
		console.Info(false) << "BE:" << buffer ;
	      }
	    } else {
	      console.Info(false) << "BE:" << buffer ;
	    };
            delete buffer ;
            delete ConData ;
            ConData = m_SockLp->getMessage("CON") ;   // extract all "CON" messages from queue
        }
    }
}

ARemoteConsoleServer::ARemoteConsoleServer(CSocketLoop *SockLp) {
    m_SockLp = SockLp ;
}

ARemoteConsoleServer::ARemoteConsoleServer() {
    m_SockLp = s_SockLp ;
}

ARemoteConsoleServer::~ARemoteConsoleServer() {
} 

/********************************************************************************/
/* class CRemoteConsoleClient 	    					        */
/* 										*/
/* Description: 								*/
/*   client console								*/
/********************************************************************************/

void CRemoteConsoleClient::UpdateCon(char *buf) {
  if (m_Sock) {
    if (m_Sock->connected()) {
      CShakePacket ConData((void *)(buf),strlen(buf)+1,"CON") ; 
      if (m_Sock->send(ConData)==-1) {
	tconsole.Error() << "Error while sending console message, closing connection\n" ;
	m_Sock->close() ;
      };
    }
  }
}

CShakeSocket *CRemoteConsoleClient::getSocket() {
  return m_Sock ;
}

void CRemoteConsoleClient::UpdateCon() {
  char buffer[4096] ;
    
  console.GetLast(&buffer[0]) ;
  UpdateCon(&buffer[0]) ;
}

CRemoteConsoleClient::CRemoteConsoleClient(CShakeSocket *Sock) {
  m_Sock = Sock ;
    //ConsoleWindow::Window=this ;
}

CRemoteConsoleClient::CRemoteConsoleClient() {
  m_Sock = NULL ;
}

CRemoteConsoleClient::~CRemoteConsoleClient() {
} 
 
void CRemoteConsoleClient::setAsConsole() {
   ConsoleWindow::Window=this ;
}

void CRemoteConsoleClient::connectTo(CShakeSocket *Sock) {
    m_Sock = Sock ;
    //ConsoleWindow::Window=this ;
}
