/*=============================================================================
??
??******************************************************************************
??*                                               *
??* COPYRIGHT ??????? - All Rights Reserved *
??*  *
??* This software is the property of ??????????????. No part of this code   *
??* may be copied in any form or by any means without the expressed written   *
??* consent of ???????????. Copying, use or modification of this software     *
??* by any unauthorised person is illegal unless that    *
??* person has a software license agreement with ?????????????.            *
??*                                                          *
??******************************************************************************
??
*********************************************************************************/

#ifndef LSMTESTREGISTRYRUNNER_H
#define LSMTESTREGISTRYRUNNER_H

/**
 * Namespace containing all LSM related testing classes.
 */
namespace LsmTest
{
  /**
   * Wrapper class for running tests which have been registered
   * via the CPPUNIT_TEST_SUITE_REGISTRATION macro.
   */
  class RegistryRunner
  {
  public:
    RegistryRunner();

    RegistryRunner(int argc, char *argv[]);

    virtual ~RegistryRunner();

    /**
     * Loads all specified dynamic libraries and then
     * runs all registered CppUnit tests.
     */
    virtual void run();

  private:
    class Impl;

    Impl *m_pImpl;
  };
};

#endif
