/*=============================================================================
??
??******************************************************************************
??*                                               *
??* COPYRIGHT ??????? - All Rights Reserved *
??*  *
??* This software is the property of ??????????????. No part of this code   *
??* may be copied in any form or by any means without the expressed written   *
??* consent of ???????????. Copying, use or modification of this software     *
??* by any unauthorised person is illegal unless that    *
??* person has a software license agreement with ?????????????.            *
??*                                                          *
??******************************************************************************
??
*********************************************************************************/

#include "UnitTest/TestDll.h"
#include <sstream>
#include <stdexcept>

namespace LsmTest
{
  TestDll::TestDll(const std::string &dlName)
    : m_dlName(dlName),
      m_dlHandle(NULL)
  {
  }

  TestDll::~TestDll()
  {
  }

  void TestDll::load()
  {
    m_dlHandle = lt_dlopen(getDlName().c_str());
    if (!m_dlHandle) {
      std::stringstream msgStream;
      const char *errMsg = lt_dlerror();
      errMsg = ((errMsg != NULL) ? errMsg : "unknown");
      msgStream
        << "Failed to open dynamic library "
        << getDlName()
        << ": "
        << errMsg;
      std::runtime_error e(msgStream.str().c_str());
      throw e;
    }
  }

  void TestDll::unload()
  {
    lt_dlclose(getDlHandle());
    m_dlHandle = NULL;
  }

  const std::string &TestDll::getDlName() const
  {
    return m_dlName;
  }

  lt_dlhandle TestDll::getDlHandle()
  {
    return m_dlHandle;
  }
}

