/*=============================================================================
??
??******************************************************************************
??*                                               *
??* COPYRIGHT ??????? - All Rights Reserved *
??*  *
??* This software is the property of ??????????????. No part of this code   *
??* may be copied in any form or by any means without the expressed written   *
??* consent of ???????????. Copying, use or modification of this software     *
??* by any unauthorised person is illegal unless that    *
??* person has a software license agreement with ?????????????.            *
??*                                                          *
??******************************************************************************
??
*********************************************************************************/

#ifndef LSMTESTTESTDLL_H
#define LSMTESTTESTDLL_H

#include "libltdl/ltdl.h"
#include <string>

namespace LsmTest
{

  class TestDll
  {
  public:
    /**
     * Dynamically loads specified dynamic library.
     * 
     * @param filename Name of dynamic library file.
     */
    TestDll(const std::string &dlName);
  
    /**
     * Destructor.
     */
    virtual ~TestDll();
  
    /**
     * Opens/loads dynamic library.
     */
    virtual void load();
  
    /**
     * Closes/unloads dynamic library.
     */
    virtual void unload();
  
    /**
     * Returns the dynamic library name.
     */
    const std::string &getDlName() const;
  
  protected:
    /**
     * Returns the handle associated with this dynamic library.
     */
    lt_dlhandle getDlHandle();
  
  private:
    /**
     * Dynamic library name.
     */
    std::string m_dlName;
    /**
     * Dynamic library handle.
     */
    lt_dlhandle m_dlHandle;
  };
};

#endif
