template<typename P,typename I>
ParallelInteractionStorage_EB<P,I>::ParallelInteractionStorage_EB(AParallelParticleArray* ppa,const typename I::ParameterType& param):ParallelInteractionStorage_E<P,I>(ppa,param)
{}

/*!
  Update interactions. Check for broken interactions and remove them.
*/
template<typename P,typename InteractionType>
bool ParallelInteractionStorage_EB<P,InteractionType>::update()
{
  bool res=false;

  //  cout << "PIS_EB::update on node " << m_comm.rank() << endl << flush;
  typename list<InteractionType>::iterator iter=m_interactions.begin();
  while(iter!=m_interactions.end()){
    if(iter->broken()){
      res=true;
      typename list<InteractionType>::iterator er_iter=iter;
      // get IDs to remove from set
      vector<int> pids=iter->getAllID();
      m_set.erase(make_pair(pids[0],pids[1]));
      iter++;
       // remove interaction
      m_interactions.erase(er_iter);
    } else {
      iter++;
    }
  }
  //  cout << "end PIS_EB::update on node " << m_comm.rank() << endl << flush;
  return res;
}
