#ifndef __PARALLEL_INTERACTION_STORAGE_NE_H
#define __PARALLEL_INTERACTION_STORAGE_NE_H

//--- project includes ---
#include "pi_storage.h"

//--- STL includes ---
#include <vector>
using std::vector;

//--- IO includes ---

/*!
  \class ParallelInteractionStorage_NE
  \brief parallel storage array without exchange for dynamically created interactions (elastic)

  \author Steffen Abe
  $Revision$
  $Date$
*/
template<typename P,typename I>
class ParallelInteractionStorage_NE : public TParallelInteractionStorage<I>
{
 protected:
  int m_update_timestamp;
  AParallelInteractionStorage* m_exIG; //<! if an interaction is in m_exIG, it can't be in m_interactions
  set<pair<int,int> > m_set; // evil hack, should be vector<int>, not pair<int,int>
  typename I::ParameterType m_param;

 public:
  ParallelInteractionStorage_NE(AParallelParticleArray*,const typename I::ParameterType&);

  virtual void addExIG(AParallelInteractionStorage*);
  virtual bool update();
  virtual void exchange(){}; //!< do nothing
  virtual void rebuild(){}; //!< do nothing
  virtual void tryInsert(const vector<int>&){};//!< do nothing
  virtual bool isIn(const vector<int>&);
  virtual void calcForces();
};

#include "pis/pi_storage_ne.hpp"

#endif // __PARALLEL_INTERACTION_STORAGE_ED_H
