#ifndef __PARALLEL_INTERACTION_STORAGE_SINGLE_H
#define __PARALLEL_INTERACTION_STORAGE_SINGLE_H

//--- project includes ---
#include "pi_storage.h"

//--- STL includes ---
#include <vector>
using std::vector;

//--- IO includes ---

/*!
  \class ParallelInteractionStorage_Single
  \brief parallel storage array without exchange for dynamically created single particle 
  interactions (i.e. Damping...)

  \author Steffen Abe
  $Revision$
  $Date$
*/
template<typename P,typename I>
class ParallelInteractionStorage_Single : public TParallelInteractionStorage<I>
{
 protected:
  typename I::ParameterType m_param;

 public:
  ParallelInteractionStorage_Single(AParallelParticleArray*,const typename I::ParameterType&);

  virtual void addExIG(AParallelInteractionStorage*){}; // do nothing
  virtual bool update();
  virtual void exchange(){}; //!< do nothing
  virtual void rebuild(){}; //!< do nothing
  virtual void tryInsert(const vector<int>&){};//!< do nothing
  virtual bool isIn(const vector<int>&){return true;}; 
  virtual void calcForces();
};

#include "pi_storage_single.hpp"

#endif //__PARALLEL_INTERACTION_STORAGE_SINGLE_H
