#include "console.h"

template<typename P,typename I>
ParallelInteractionStorage_Single<P,I>::ParallelInteractionStorage_Single(AParallelParticleArray* ppa,const typename I::ParameterType& param):TParallelInteractionStorage<I>(ppa)
{
  m_param=param;
}

template<typename P,typename I>
bool ParallelInteractionStorage_Single<P,I>::update()
{
  console.XDebug() << "CDampingGroup<T>::Update()\n" ;
  // empty particle list first
  m_interactions.erase(m_interactions.begin(),m_interactions.end());
  // build new particle list
  typename ParallelParticleArray<P>::ParticleListHandle plh=((ParallelParticleArray<P>*)m_ppa)->getAllParticles();
  for(typename ParallelParticleArray<P>::ParticleListIterator iter=plh->begin();
      iter!=plh->end();
      iter++){
    m_interactions.push_back(CDamping<P>(*iter,m_param));
  }
  console.XDebug() << "end CDampingGroup<T>::Update()\n" ;

  return true;
}


template<typename P,typename InteractionType>
void ParallelInteractionStorage_Single<P,InteractionType>::calcForces()
{
  console.Debug() << "calculating " << m_interactions.size() << " damping forces\n" ;
  
  for(typename list<InteractionType>::iterator it=m_interactions.begin();
      it!=m_interactions.end();
      it++){
    it->calcForces();
  }
}
