#ifndef __TRIMESH_PIS_H
#define __TRIMESH_PIS_H

// --- project includes ---
#include "pi_storage.h"

// --- STL includes ---
#include <set>
#include <list>

using std::set;
using std::list;

/*!
  \class TriMesh_PIS
  \brief Abstract base class for parallel storage of interactions between a triangle 
  mesh and particles

  \author Steffen Abe
  $Revision$
  $Date$
*/
template<class ParticleType> 
class TriMesh_PIS : public AParallelInteractionStorage
{
 protected:
  int m_update_timestamp;
  TriMesh* m_mesh;
  AParallelInteractionStorage* m_exIG; //<! if an interaction is in m_exIG, it can't be in m_interactions

 public:
  TriMesh_PIS(TriMesh*,ParallelParticleArray<ParticleType>*);
  virtual ~TriMesh_PIS();

  virtual void addExIG(AParallelInteractionStorage*);
  virtual AFieldSlave* generateNewScalarFieldSlave(TML_Comm*,const string&,int,int,int,int);
  virtual AFieldSlave* generateNewVectorFieldSlave(TML_Comm*,const string&,int,int,int,int);
};

#include "trimesh_pis.hpp"

#endif //__TRIMESH_PIS_H
