#ifndef __GETTYPE_H
#define __GETTYPE_H

//--- MPI ---
#include <mpi.h>

//--- STL includes ---
#include <utility>

using std::pair;

/*!
  \class SGetType
  \brief static function object to extract MPI type from data in a consistent way

*/
class SGetType
{
 public:
  template <typename T> MPI_Datatype operator()(const T&);
  template<typename T1,typename T2> MPI_Datatype operator()(const pair<T1,T2>&);
};

template<typename T1,typename T2> 
struct tml_pair {
  static MPI_Datatype type;
  static bool initialized;
};

template<typename T1,typename T2> MPI_Datatype tml_pair<T1,T2>::type=MPI_DATATYPE_NULL;
template<typename T1,typename T2> bool tml_pair<T1,T2>::initialized=false;

static SGetType GetType;

#include "tml/type/gettype.hpp"

#endif //__GETTYPE_H
